<?php


namespace App\Helpers;


use Illuminate\Support\Facades\Cookie;

class CustomerLogic
{

    public static function get_balance(ApiService $apiService, $customer_id)
    {
        $response = $apiService->callAPI('POST', 'api/global_api/', [
            "id" => Cookie::get('data_id'),
            "token" => Cookie::get('data'),
            "action" =>  "get_balance",
            "customer_id" =>  $customer_id,
            "device_id" =>  "",
        ]);
        if (isset($response['status']) && $response['status'] != true && $response['error'] == 'Invalid key found.'){
            if ($response['error'] == 'Invalid key found.'){
                $info = self::admin_login($apiService);
                $response = $apiService->callAPI('POST', 'api/global_api/', [
                    "id" => isset($info['data_id']) ? $info['data_id'] : null,
                    "token" => isset($info['data']) ? $info['data'] : null,
                    "action" =>  "get_balance",
                    "customer_id" =>  $customer_id,
                    "device_id" =>  "",
                ]);
                return $response;
            }else{
                return $response;
            }
        }else{
            return $response;
        }
    }

    public static function get_timezone_list(ApiService $apiService)
    {
        $response = $apiService->callAPI('POST', 'api/global_api/', [
            "id" => Cookie::get('data_id'),
            "token" => Cookie::get('data'),
            "action" => "get_timezone_list",
            "start_limit" => "1",
            "end_limit" => "1000",
            "device_id" =>  "",
        ]);
    //    print_r($response); // Print the API response
	


        if (isset($response['status']) && $response['status'] == false){
            if ($response['error'] == 'Invalid key found.'){
                $info = self::admin_login($apiService);
                print_r($info); // Print the API credentials
		$response = $apiService->callAPI('POST', 'api/global_api/', [
                    "id" => $info['data_id'] ?? null,
                    "token" => $info['data'] ?? null,
                    "action" => "get_timezone_list",
                    "start_limit" => "1",
                    "end_limit" => "1000",
                    "device_id" =>  "",
                ]);
                return $response;
            }else{
                return $response;
            }
        }else{
            return $response;
        }
    }

    public static function add_balance(ApiService $apiService, $customer_info, $balance)
    {
        $response = $apiService->callAPI('POST', 'admin/add_balance/', [
            "id" => Cookie::get('data_id'),
            "token" => Cookie::get('data'),
            "action" =>  "add_balance",
            "reseller_id" =>  $customer_info['reseller_id'],
            "account_id" =>  $customer_info['accountid'],
            "balance" =>  $balance,
            "type" =>  $customer_info['type'],
            "payment_method" => 'stripe'
        ]);
        if (isset($response['status']) && $response['status'] != true && $response['error'] == 'Invalid key found.'){
            if ($response['error'] == 'Invalid key found.'){
                $info = self::admin_login($apiService);
                $response = $apiService->callAPI('POST', 'admin/add_balance/', [
                    "id" => $info['data_id'],
                    "token" => $info['data'],
                    "action" =>  "add_balance",
                    "reseller_id" =>  $customer_info['reseller_id'],
                    "account_id" =>  $customer_info['accountid'],
                    "balance" =>  $balance,
                    "type" =>  $customer_info['type'],
                    "payment_method" => 'stripe'
                ]);
                return $response;
            }else{
                return $response;
            }
        }else{
            return $response;
        }
    }

    public static function productlist(ApiService $apiService)
    {
        $response = $apiService->callAPI('POST', 'admin/product/', [
            "id" => Cookie::get('data_id'),
            "token" => Cookie::get('data'),
            "action" =>  "list",
            "start_limit" =>  1,
            "end_limit" =>  50,
            "object_where_params" =>  [
                'name' => '',
                'country_id' => '',
                'buy_cost' => '',
                'setup_fee' => '',
                'price' => '',
                'billing_days' => '',
                'billing_type' => '',
                'free_minutes' => '',
            ]
        ]);
        if (isset($response['status']) && $response['status'] != true && $response['error'] == 'Invalid key found.'){
            if ($response['error'] == 'Invalid key found.'){
                $info = self::admin_login($apiService);
                $response = $apiService->callAPI('POST', 'admin/product/', [
                    "id" => $info['data_id'] ?? null,
                    "token" => $info['data'] ?? null,
                    "action" =>  "list",
                    "start_limit" =>  1,
                    "end_limit" =>  50,
                    "object_where_params" =>  [
                        'name' => '',
                        'country_id' => '',
                        'buy_cost' => '',
                        'setup_fee' => '',
                        'price' => '',
                        'billing_days' => '',
                        'billing_type' => '',
                        'free_minutes' => '',
                    ]
                ]);
                return $response;
            }else{
                return $response;
            }
        }else{
            return $response;
        }
    }

    public static function get_customer_list(ApiService $apiService, $number)
    {
        $response = $apiService->callAPI('POST', 'admin/customer/', [
            "id" => Cookie::get('data_id'),
            "token" => Cookie::get('data'),
            "action" =>  "customer_list",
            "object_where_params" =>  [
                'number' => $number
            ],
            "start_limit" =>  1,
            "end_limit" =>  50,
        ]);
        if (isset($response['status']) && $response['status'] != true && $response['error'] == 'Invalid key found.'){
            if ($response['error'] == 'Invalid key found.'){
                $info = self::admin_login($apiService);
                $response = $apiService->callAPI('POST', 'admin/customer/', [
                    "id" => $info['data_id'],
                    "token" => $info['data'],
                    "action" =>  "customer_list",
                    "object_where_params" =>  [
                        'number' => $number,
                    ],
                    "start_limit" =>  1,
                    "end_limit" =>  50,
                ]);
                return $response;
            }else{
                return $response;
            }
        }else{
            return $response;
        }
    }

    public static function admin_login(ApiService $apiService)
    {
        $body = [
            "username" => "admin",
            "password" => "AlOtEl24@ET",
            "device_id" =>  "645C18B55-26C-4504-AADF-034BDFE1AFEA1",
            "callkit_token" =>  "BE6CAF775FFC2C1AAD28D9992E467156F044D68D21C59E4973C3A692DACAB03C",
            "apns_token" =>  "63c7620a2c5ce0a1717850ecb559fb994c57bc6180f49c2e815efab09421f924",
            "mobile_type"=> "android"
        ];

        $response = $apiService->callAPI('POST', 'api/login/', $body);
        if ($response['status'] == true){
            $expirationInMinutes = 2 * 24 * 60;
            Cookie::queue('data', $response['data']['token'], $expirationInMinutes);
            Cookie::queue('data_id', $response['data']['id'], $expirationInMinutes);
            return ['data'=> $response['data']['token'], 'data_id' =>  $response['data']['id']];
        }else{
            return $response;
        }
    }

    public static function convert_price($dt_price=0, $type='')
    {
        $spacePosition = strpos($dt_price, ' ');
        $price = substr($dt_price, 0, $spacePosition);
        if ($type == 'acc'){
            return number_format($price, 2);
        }else{

        }return number_format($price);

    }
}
