<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Str;
use App\Models\Event_post;
use App\Models\Tag;
use App\Models\Event_tag;

use App\Http\Controllers\Controller;
use App\User;
use Carbon\Carbon;
use DB;

use Artisan;
use Session;

class AdminController extends Controller{
    public $successStatus = 200;
    public $errorStatus = 401;

    // -------------- CACHE PAGE ------------- //
    public function clear_cache(Request $request){
        $exitCode = Artisan::call('route:clear');
        $exitCode = Artisan::call('config:cache');
        $exitCode = Artisan::call('cache:clear');
        $exitCode = Artisan::call('view:clear');

        Session::flash('success', 'Cache Cleared!'); 
        return redirect('admin/dashboard');
    }
    // -------------- CACHE PAGE ------------- //
    
    // -------------- LOGIN PAGE ------------- //
    public function index(Request $request){
        if ($request->session()->has('id')) {
            return redirect('admin/dashboard');
        } else{
            return view('admin.login'); 
        }
    }
    // -------------- LOGIN PAGE ------------- //

    // -------------- LOGIN AUTHENTICATION ------------- //
    public function login(Request $request){
        $validateData = $request->validate([
            'email' => 'required|email',
            'password' => 'required'
        ]);
        
        $postData = $request->all();
        $ifExists = DB::table('users_system')->where('email', $postData['email'])->where('password', $postData['password'])->first();
        if (!empty($ifExists)) {
            $request->session()->put([
                'id' => $ifExists->users_system_id,
                'users_system_roles_id'=>$ifExists->users_system_roles_id,
                'user_image' => $ifExists->user_image,
                'fname' => $ifExists->first_name,
                'lname' => '',
                'email' => $ifExists->email,
            ]);
            Session::flash('success', ' Logged in successfully.'); 
            return redirect('admin/dashboard');
        } else {
            Session::flash('error', 'Invalid Email/Password'); 
            return redirect()->back();
        }
    }
    // -------------- LOGIN AUTHENTICATION ------------- //

    // -------------- LOGOUT ------------- //
    public function logout(Request $request){
        $request->session()->flush();
        return redirect('admin');
    }
    // -------------- LOGOUT ------------- //

    // ------------- DASHBOARD -------------- //
    public function dashboard(){
        if(session()->has('id')){
            $total_venues_claimed           = number_format(DB::table('venues_claimed')->count());
            $total_venues                   = DB::table('venues')->count();
            $total_active_users_customers   = DB::table('users_customers')->where('status', 'Active')->count();
            $total_venues_visits            = number_format(DB::table('venues_visits')->count());
            $total_events_visits            = number_format(DB::table('events_visits')->count());
            $total_events                   = DB::table('events')->count();
            
            $total_events_1               = DB::table('events')->whereMonth('date_added', 1)->count();
            $total_events_2               = DB::table('events')->whereMonth('date_added', 2)->count();
            $total_events_3               = DB::table('events')->whereMonth('date_added', 3)->count();
            $total_events_4               = DB::table('events')->whereMonth('date_added', 4)->count();
            $total_events_5               = DB::table('events')->whereMonth('date_added', 5)->count();
            $total_events_6               = DB::table('events')->whereMonth('date_added', 6)->count();
            $total_events_7               = DB::table('events')->whereMonth('date_added', 7)->count();
            $total_events_8               = DB::table('events')->whereMonth('date_added', 8)->count();
            $total_events_9               = DB::table('events')->whereMonth('date_added', 9)->count();
            $total_events_10              = DB::table('events')->whereMonth('date_added', 10)->count();
            $total_events_11              = DB::table('events')->whereMonth('date_added', 11)->count();
            $total_events_12              = DB::table('events')->whereMonth('date_added', 12)->count();

            $total_venues_1               = DB::table('venues')->whereMonth('date_added', 1)->count();
            $total_venues_2               = DB::table('venues')->whereMonth('date_added', 2)->count();
            $total_venues_3               = DB::table('venues')->whereMonth('date_added', 3)->count();
            $total_venues_4               = DB::table('venues')->whereMonth('date_added', 4)->count();
            $total_venues_5               = DB::table('venues')->whereMonth('date_added', 5)->count();
            $total_venues_6               = DB::table('venues')->whereMonth('date_added', 6)->count();
            $total_venues_7               = DB::table('venues')->whereMonth('date_added', 7)->count();
            $total_venues_8               = DB::table('venues')->whereMonth('date_added', 8)->count();
            $total_venues_9               = DB::table('venues')->whereMonth('date_added', 9)->count();
            $total_venues_10              = DB::table('venues')->whereMonth('date_added', 10)->count();
            $total_venues_11              = DB::table('venues')->whereMonth('date_added', 11)->count();
            $total_venues_12              = DB::table('venues')->whereMonth('date_added', 12)->count();

            $total_users_1               = DB::table('users_customers')->whereMonth('date_added', 1)->count();
            $total_users_2               = DB::table('users_customers')->whereMonth('date_added', 2)->count();
            $total_users_3               = DB::table('users_customers')->whereMonth('date_added', 3)->count();
            $total_users_4               = DB::table('users_customers')->whereMonth('date_added', 4)->count();
            $total_users_5               = DB::table('users_customers')->whereMonth('date_added', 5)->count();
            $total_users_6               = DB::table('users_customers')->whereMonth('date_added', 6)->count();
            $total_users_7               = DB::table('users_customers')->whereMonth('date_added', 7)->count();
            $total_users_8               = DB::table('users_customers')->whereMonth('date_added', 8)->count();
            $total_users_9               = DB::table('users_customers')->whereMonth('date_added', 9)->count();
            $total_users_10              = DB::table('users_customers')->whereMonth('date_added', 10)->count();
            $total_users_11              = DB::table('users_customers')->whereMonth('date_added', 11)->count();
            $total_users_12              = DB::table('users_customers')->whereMonth('date_added', 12)->count();
            
            $recent_users_customers           = DB::table('users_customers')->orderBy("users_customers_id", "DESC")->take(5)->get();
            
            return view('admin.dashboard', compact('total_venues_claimed','total_venues', 'total_active_users_customers', 'total_venues_visits', 'total_events_visits', 'total_events', 'recent_users_customers', 
                'total_events_1',
                'total_events_2',
                'total_events_3',
                'total_events_4',
                'total_events_5',
                'total_events_6',
                'total_events_7',
                'total_events_8',
                'total_events_9',
                'total_events_10',
                'total_events_11',
                'total_events_12',

                'total_venues_1',
                'total_venues_2',
                'total_venues_3',
                'total_venues_4',
                'total_venues_5',
                'total_venues_6',
                'total_venues_7',
                'total_venues_8',
                'total_venues_9',
                'total_venues_10',
                'total_venues_11',
                'total_venues_12',

                'total_users_1',
                'total_users_2',
                'total_users_3',
                'total_users_4',
                'total_users_5',
                'total_users_6',
                'total_users_7',
                'total_users_8',
                'total_users_9',
                'total_users_10',
                'total_users_11',
                'total_users_12'
            ));
        } else {
            return redirect('admin');
        }
    }
    // ------------- DASHBOARD -------------- //

    // ------------- MANAGE BUSINESS -------------- //
    public function users_customers(Request $request){
        if ($request->session()->has('id')) {
            $users = db::table('users_customers')->where('status', '!=','Deleted')->orderBy('users_customers_id', 'DESC')->get();
            return view('admin.users_customers', compact('users'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE BUSINESS -------------- //

    // ------------- UPDATE BUSINESS -------------- //
    public function users_customers_update($users_customers_id, $status){
        $update['status'] = $status;
        $updated = DB::table('users_customers')->where('users_customers_id', '=', $users_customers_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // ------------- UPDATE BUSINESS -------------- //

    // ------------- DELETE BUSINESS -------------- //
    public function users_customers_delete($users_customers_id){
        if(session()->has('id')){
            if(!empty($users_customers_id)){
                $checkdata = DB::table('users_customers')->where('users_customers_id', $users_customers_id)->where('status', '!=','Deleted')->get();

                if(count($checkdata) != 0){
                    $del = DB::table('users_customers')->where('users_customers_id', '=', $users_customers_id)->update(array( 'status' => 'Deleted'));
                    if($del){
                        return back()->with('success', 'Data Deleted successfully');
                    } else {
                        return back()->with('error', 'Oops! something went wrong');
                    }
                } else {
                    return back()->with('success', 'This record is already deleted');
                }
            } else {
                return back()->with('error', 'No Data Found');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- DELETE BUSINESS -------------- //

    // ------------- MANAGE BUSINESS -------------- //
    public function users_business(Request $request){
        if ($request->session()->has('id')) {
            $users = db::table('users_business')->where('status', '!=','Deleted')->orderBy('users_business_id', 'DESC')->get();
            return view('admin.users_business', compact('users'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE BUSINESS -------------- //

    // ------------- UPDATE BUSINESS -------------- //
    public function users_business_update($users_business_id, $status){
        $update['status'] = $status;
        $updated = DB::table('users_business')->where('users_business_id', '=', $users_business_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // ------------- UPDATE BUSINESS -------------- //

    // ------------- DELETE BUSINESS -------------- //
    public function users_business_delete($users_business_id){
        if(session()->has('id')){
            if(!empty($users_business_id)){
                $checkdata = DB::table('users_business')->where('users_business_id', $users_business_id)->where('status', '!=','Deleted')->get();

                if(count($checkdata) != 0){
                    $del = DB::table('users_business')->where('users_business_id', '=', $users_business_id)->update(array( 'status' => 'Deleted'));
                    if($del){
                        return back()->with('success', 'Data Deleted successfully');
                    } else {
                        return back()->with('error', 'Oops! something went wrong');
                    }
                } else {
                    return back()->with('success', 'This record is already deleted');
                }
            } else {
                return back()->with('error', 'No Data Found');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- DELETE BUSINESS -------------- //


    // ------------- MANAGE VENUE BOOKINGS -------------- //
    public function venue_bookings(){
        if (session()->has('id')) {
            $total_venues_bookings          = number_format(DB::table('venues_bookings')->count());
            $fetch_data                     = DB::table('venues_bookings')->orderBy('venues_bookings_id','DESC')->get();
            
            return view('admin.venue_bookings', compact('fetch_data', 'total_venues_bookings'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUE BOOKINGS -------------- //

    // ------------- MANAGE VENUE BOOKINGS STATUS -------------- //
    public function venue_bookings_status($id, $status){
        if (session()->has('id')) {
            if($status == 'Deleted'){
                DB::table('venues_bookings')->where('venues_bookings_id', $id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } else {
                $update_array['status'] = $status;
                $update_data = DB::table('venues_bookings')->where('venues_bookings_id', '=', $id)->update($update_array);
                Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }

            return redirect('admin/venue_bookings');
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUE BOOKINGS STATUS -------------- //

    // ------------- MANAGE VENUE CHAT -------------- //
    public function venues_chat($id){
        if (session()->has('id')) {
            return view('admin.venues_chat', compact('id'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUE CHAT -------------- //

    // ------------- MANAGE VENUES -------------- //
    public function manage_venues(){
        if (session()->has('id')) {
            $fetch_data = db::table('venues')->where('status', '!=','Deleted')->orderBy('venues_id', 'DESC')->get();
            return view('admin.manage_venues', compact('fetch_data'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE VENUES -------------- //

    // ------------- MANAGE VENUES ADD -------------- //
    public function manage_venues_add(){
        if (session()->has('id')) {
            $users_business = db::table('users_business')->where('status', '!=','Deleted')->orderBy('users_business_id', 'DESC')->get();
            return view('admin.manage_venues_add', compact('users_business'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE VENUES ADD -------------- //

    // ------------- MANAGE VENUES SAVE -------------- //
    public function manage_venues_save(Request $request){
        if(session()->has('id')){
            $insert_array['users_business_id'] = $request->users_business_id;    
            $insert_array['name'] = $request->name;
            $insert_array['capacity'] = $request->capacity;
            $insert_array['location'] = $request->location;
            $insert_array['longitude'] = $request->longitude;
            $insert_array['lattitude'] = $request->lattitude;
            $insert_array['google_place_id'] = $request->google_place_id;   
            $insert_array['discount_percentage'] = !empty($request->discount_percentage) ? $request->discount_percentage : null;
            $insert_array['website'] = $request->website;
            $insert_array['menu_link'] = $request->menu_link;
            $insert_array['phone_number'] = $request->phone_number;
            $insert_array['description'] = $request->description;
            $insert_array['important_info'] = $request->important_info;
            $insert_array['restaurant_note'] = $request->restaurant_note;
            $insert_array['status'] = $request->status;    
            $insert_data_id = DB::table('venues')->insertGetId($insert_array);  
            $id =  $insert_data_id;
            
            if(isset($_REQUEST['venue_type'])) {
                $venueTypes = $_REQUEST['venue_type'];

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_type"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_music'])) {
                $venueTypes = $_REQUEST['venues_music'];   

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_music"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_budget'])) {
                $venueBudget = $_REQUEST['venues_budget'];
            
                foreach($venueBudget as $venue_budget) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venue_budget,
                        'keyword_type' => "venues_budget"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_cusine'])) {
                $venueTypes = $_REQUEST['venues_cusine'];

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_cusine"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_food'])) {
                $venueFoodArray = $_REQUEST['venues_food'];
                foreach($venueFoodArray as $venueFood) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueFood,
                        'keyword_type' => "venues_food"
                    ]);
                }
            }
            if(isset($_REQUEST['payment_method'])) {
                $payment_method = $_REQUEST['payment_method'];
                foreach($payment_method as $method) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $method,
                        'keyword_type' => "payment_method"
                    ]);
                }
            }

            if ($request->has('hours')) {
                $hours = $request->hours;

                DB::beginTransaction();

                $transactionSuccess = true;

                foreach ($hours as $day => $dayHours) {
                    $startHour = $dayHours['start'];
                    $closeHour = $dayHours['close'];

                    $insertResult = DB::table('venues_hours')->insert([
                        'venues_hours_days' => $day,
                        'venues_id' => $id,
                        'start_hours' => $startHour,
                        'close_hours' => $closeHour
                    ]);

                    if (!$insertResult) {
                        $transactionSuccess = false;
                        break; 
                    }
                }
            
                if ($transactionSuccess) {
                    DB::commit();
                } else {
                    DB::rollback();      

                }
            }


            if ($request->hasfile('images')) {
                foreach($request->file('images') as $file){
                    if ($file->isValid()) {
                        $path = public_path('uploads/venues/');
                        //$image_name = $insert_data_id . '-'. rand() .'-' . $file->getClientOriginalName();
                        $image_name = $insert_data_id . '-'. rand() .'.jpeg';
                        if ($file->move($path, $image_name)) {
                            $images_array['venues_id'] = $id;
                            $images_array['name'] = 'uploads/venues/' . $image_name;
                            $images_array['status'] = 'Active';
                            $insert_data_id = DB::table('venues_images')->insert($images_array);
                        }
                    }
                }
            }

            if($insert_data_id){
                Session::flash('success', ' Data Added successfully'); 
                return redirect('admin/manage_venues');
            } else {
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/manage_venues');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE VENUES SAVE -------------- //

    // ------------- MANAGE VENUES VIEW -------------- //
    public function manage_venues_views($id){
        if (session()->has('id')) {
            $fetch_data = db::table('venues')->where('venues_id', '=', $id)->orderBy('venues_id', 'DESC')->get();
            return view('admin.manage_venues_views', compact('fetch_data'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE VENUES VIEW -------------- //

    // ------------- UPDATE VENUES -------------- //
    public function manage_venues_update($id, Request $request){
        if(session()->has('id')){
            // dd($request->all());
            // exit();
            if(!empty($id)){
                $update_array['name'] = $request->name;
                $update_array['capacity'] = $request->capacity;
                $update_array['location'] = $request->location;
                $update_array['longitude'] = $request->longitude;
                $update_array['lattitude'] = $request->lattitude;
                $update_array['google_place_id'] = $request->google_place_id;
                $update_array['open_hours'] = $request->open_hours;
                $update_array['close_hours'] = $request->close_hours;
                $update_array['discount_percentage'] = $request->discount_percentage;
                $update_array['website'] = $request->website;
                $update_array['menu_link'] = $request->menu_link;
                $update_array['phone_number'] = $request->phone_number;
                $update_array['description'] = $request->description;
                $update_array['important_info'] = $request->important_info;
                $update_array['restaurant_note'] = $request->restaurant_note;
                
                if(isset($_REQUEST['venue_type'])) {
                    $venueTypesArray = $_REQUEST['venue_type'];
                    $venueId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_type')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_type')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'venues_type'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venues_music'])) {
                    $venueMusicArray = $_REQUEST['venues_music'];   
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue music types from the database
                    $existingVenueMusic = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_music')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue music types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueMusic, $venueMusicArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_music')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue music types
                    foreach($venueMusicArray as $venueMusic) {
                        // Check if the venue music type already exists in the database
                        if (!in_array($venueMusic, $existingVenueMusic)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueMusic,
                                'keyword_type' => 'venues_music'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venues_budget'])) {
                    $venueBudgetArray = $_REQUEST['venues_budget'];   
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue budget types from the database
                    $existingVenueBudget = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_budget')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue budget types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueBudget, $venueBudgetArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_budget')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue budget types
                    foreach($venueBudgetArray as $venueBudget) {
                        // Check if the venue budget type already exists in the database
                        if (!in_array($venueBudget, $existingVenueBudget)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueBudget,
                                'keyword_type' => 'venues_budget'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venue_cuisine'])) {
                    $venueCuisineArray = $_REQUEST['venue_cuisine'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue cuisine types from the database
                    $existingVenueCuisine = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_cusine')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue cuisine types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueCuisine, $venueCuisineArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_cusine')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue cuisine types
                    foreach($venueCuisineArray as $venueCuisine) {
                        // Check if the venue cuisine type already exists in the database
                        if (!in_array($venueCuisine, $existingVenueCuisine)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueCuisine,
                                'keyword_type' => 'venues_cusine'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venue_food'])) {
                    $venueFoodArray = $_REQUEST['venue_food'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue food types from the database
                    $existingVenueFood = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_food')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue food types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueFood, $venueFoodArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_food')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue food types
                    foreach($venueFoodArray as $venueFood) {
                        // Check if the venue food type already exists in the database
                        if (!in_array($venueFood, $existingVenueFood)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueFood,
                                'keyword_type' => 'venues_food'
                            ]);
                        }
                    }
                }
                
                if(isset($_REQUEST['payment_method'])) {
                    $paymentMethodArray = $_REQUEST['payment_method'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing payment methods from the database
                    $existingPaymentMethods = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'payment_method')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted payment methods with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingPaymentMethods, $paymentMethodArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'payment_method')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted payment methods
                    foreach($paymentMethodArray as $paymentMethod) {
                        // Check if the payment method already exists in the database
                        if (!in_array($paymentMethod, $existingPaymentMethods)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $paymentMethod,
                                'keyword_type' => 'payment_method'
                            ]);
                        }
                    }
                }
    
                if ($request->has('hours')) {
                    // Retrieve the existing hours data for the specified venue ID
                    $existingHours = DB::table('venues_hours')
                        ->select('venues_hours_id', 'venues_hours_days', 'start_hours', 'close_hours')
                        ->where('venues_id', $id)
                        ->where('status', 'Active')
                        ->get();
                
                    if (count($request->hours) !== count($existingHours)) {
                        // Handle mismatch error here, such as returning a response or throwing an exception
                    }
                    $success = true;
                    // Begin a transaction
                    DB::beginTransaction();
                
                    // Update the existing hours data
                    foreach ($existingHours as $index => $hour) {   
                        // Initialize startHour and closeHour with existing values as defaults
                        $startHour = $hour->start_hours;
                        $closeHour = $hour->close_hours;           
                    
                        // Check if the corresponding data exists in the request
                        if (isset($request->hours[$index + 1])) {
                            // Override with request data if available
                            $startHour = $request->hours[$index + 1]['start'] ?? $startHour;
                            $closeHour = $request->hours[$index + 1]['close'] ?? $closeHour;
                        }
                    
                        // Perform the update query
                        $updateResult = DB::table('venues_hours')
                            ->where('venues_hours_id', $hour->venues_hours_id)
                            ->update([
                                'start_hours' => $startHour,
                                'close_hours' => $closeHour,         
                            ]);
                    
                        // Update $success variable if update is successful
                        $success = $success && $updateResult;   
                    }
                
                    // Commit the transaction
                    DB::commit();
                }
                
    
                if(isset($_POST['Delete'])){
                    $update_array['status'] = 'Deleted';
                } else { 
                    $update_array['status'] = $request->status;
                }
    
                $update_data = DB::table('venues')->where('venues_id', '=', $id)->update($update_array);
                
                // Introduce a variable to track the success of either update operation
                $success = $update_data; // Set it to the result of venue data update
    
                if ($request->hasFile('newImages')) {
                    foreach ($request->file('newImages') as $file) {
                        if ($file->isValid()) {
                            // Generate a unique image name
                            $image_name = $id . '-' . uniqid() . '.' . $file->getClientOriginalExtension();
                            
                            // Move the image to the desired path
                            $path = public_path('uploads/venues/');
                            if ($file->move($path, $image_name)) {
                                // Save the new image information to the database
                                $images_array = [
                                    'venues_id' => $id,
                                    'name' => 'uploads/venues/' . $image_name,
                                    'status' => 'Active'
                                ];
                                
                                $update_images = DB::table('venues_images')->insert($images_array);
                                
                                // Update $success variable if image insertion is successful
                                $success = $success || $update_images;
                            }
                        }
                    }
                }         
    
                // Redirect back to the edit page after the update
    
                if($success){
                    Session::flash('success', 'Data Updated successfully'); 
                } else {
                    Session::flash('error', 'Oops! Something went wrong'); 
                }
                return redirect('admin/manage_venues');
            } else {
                Session::flash('error', 'No Data Found'); 
                return redirect('admin/manage_venues');
            }
        } else {
            return redirect('admin');
        }
    }
    
    // ------------- UPDATE VENUES -------------- //
    // ------------delete Venue Images ---------
    public function delete_venue_images($id)
{
    // Find the image by ID
    $image = DB::table('venues_images')->where('venues_images_id', $id)->first();

    if ($image) {
        // Remove image file
        if (file_exists(public_path($image->name))) {
            unlink(public_path($image->name));
        }

        // Delete image from the database
        DB::table('venues_images')->where('venues_images_id', $id)->delete();

        return response()->json(['success' => 'Image deleted successfully.'],200);
    }

    return response()->json(['error' => 'Image not found.'], 404);
}
    // ------------delete Venue Images ---------

    // ------------- MANAGE EVENTS -------------- //
    public function manage_events($param1 = '', $param2 = ''){
        if (session()->has('id')) {
            if($param1 == 'views'){
                $fetch_data = db::table('venues')->where('venues_id', '=', $param2)->orderBy('venues_id', 'DESC')->get();
                return view('admin.manage_events_views', compact('fetch_data'));
            } else {
                $fetch_data = db::table('events')->where('status', '!=','Deleted')->orderBy('events_id', 'DESC')->get();
                return view('admin.manage_events', compact('fetch_data'));
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE EVENTS -------------- //

    // ------------- MANAGE EVENTS ADD -------------- //
    public function manage_events_add(){
        if (session()->has('id')) {
            $users_business = db::table('users_business')->where('status', '!=','Deleted')->orderBy('users_business_id', 'DESC')->get();
            return view('admin.manage_events_add', compact('users_business'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE EVENTS ADD -------------- //

    // ------------- MANAGE VENUES SAVE -------------- //
    public function manage_events_save(Request $request){
        if(session()->has('id')){
            $insert_array['users_business_id'] = $request->users_business_id;
            $insert_array['name'] = $request->name;
            $insert_array['venue_name'] = $request->venue_name;
            $insert_array['location'] = $request->location;
            $insert_array['longitude'] = $request->longitude;
            $insert_array['lattitude'] = $request->lattitude;
            $insert_array['event_date'] = $request->event_date;
            $insert_array['event_start_time'] = $request->event_start_time;
            $insert_array['event_end_time'] = $request->event_end_time;
            $insert_array['discount_percentage'] = $request->discount_percentage;
            $insert_array['website'] = $request->website;
            $insert_array['phone_number'] = $request->phone_number;
            $insert_array['description'] = $request->description;
            $insert_array['refund_policy'] = $request->refund_policy;
            $insert_array['date_added'] = date('Y-m-d H:i:s');
            $insert_array['status'] = $request->status;
            $insert_data_id = DB::table('events')->insertGetId($insert_array);
            $event_id = $insert_data_id;
            
            if(isset($_REQUEST['event_type'])) {
                $EventTypes = $_REQUEST['event_type'];

                foreach($EventTypes as $Type) {
                    DB::table('events_keywords')->insert([
                        'events_id' => $event_id,
                        'keyword_value' => $Type,
                        'keyword_type' => "event_exp"
                    ]);
                }
            }
            if(isset($_REQUEST['event_music'])) {
                $EventTypes = $_REQUEST['event_music'];

                foreach($EventTypes as $Type) {
                    DB::table('events_keywords')->insert([
                        'events_id' => $event_id,
                        'keyword_value' => $Type,
                        'keyword_type' => "event_music"
                    ]);
                }
            }

            if ($request->hasfile('images')) {
                foreach($request->file('images') as $file){
                    if ($file->isValid()) {
                        $path = public_path('uploads/events/');
                        //$image_name = $insert_data_id . '-'. rand() .'-' . $file->getClientOriginalName();
                        $image_name = $events_id . '-'. rand() .'.jpeg';
                        if ($file->move($path, $image_name)) {
                            $images_array['events_id'] = $events_id;
                            $images_array['name'] = 'uploads/events/' . $image_name;
                            $images_array['status'] = 'Active';
                            $events_id = DB::table('events_images')->insert($images_array);
                        }
                    }
                }
            }

            if($events_id){
                Session::flash('success', ' Data Added successfully'); 
                return redirect('admin/manage_events');
            } else {
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/manage_events');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE VENUES SAVE -------------- //

    // ------------- MANAGE EVENTS VIEW -------------- //
    public function manage_events_views($id){
        if (session()->has('id')) {
            $fetch_data = db::table('events')->where('events_id', '=', $id)->orderBy('events_id', 'DESC')->get();
            return view('admin.manage_events_views', compact('fetch_data'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE EVENTS VIEW -------------- //

    // ------------- UPDATE EVENT -------------- //
    public function manage_events_update(Request $request,$id){
        if(session()->has('id')){ 
            if(!empty($id)){
                $update_array['name'] = $request->name;
                $update_array['venue_name'] = $request->venue_name;
                $update_array['location'] = $request->location;
                $update_array['longitude'] = $request->longitude;
                $update_array['lattitude'] = $request->lattitude;
                $update_array['event_date'] = $request->event_date;
                $update_array['event_start_time'] = $request->event_start_time;
                $update_array['event_end_time'] = $request->event_end_time;
                $update_array['discount_percentage'] = $request->discount_percentage;
                $update_array['website'] = $request->website;
                $update_array['phone_number'] = $request->phone_number;
                $update_array['description'] = $request->description;
                $update_array['refund_policy'] = $request->refund_policy;
                
                if(isset($_REQUEST['event_type'])) {
                    $venueTypesArray = $_REQUEST['event_type'];
                    $EventId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('events_keywords')
                        ->where('events_id', $EventId)
                        ->where('keyword_type', 'event_exp')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('events_keywords')
                            ->where('events_id', $EventId)
                            ->where('keyword_type', 'event_exp')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('events_keywords')->insert([
                                'events_id' => $EventId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'event_exp'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['event_music'])) {
                    $venueTypesArray = $_REQUEST['event_music'];
                    $EventId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('events_keywords')
                        ->where('events_id', $EventId)
                        ->where('keyword_type', 'event_music')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('events_keywords')
                            ->where('events_id', $EventId)
                            ->where('keyword_type', 'event_music')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('events_keywords')->insert([
                                'events_id' => $EventId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'event_music'
                            ]);
                        }
                    }
                }
                if(isset($_POST['Delete'])){
                    $update_array['status'] = 'Deleted';
                } else { 
                    $update_array['status'] = $request->status;
                }
                $update_data = DB::table('events')->where('events_id', '=', $id)->update($update_array);

                if ($request->hasfile('images')) {
                    //DELETE OLD 
                    DB::table('events_images')->where('events_id', $id)->delete();
                    //DELETE OLD

                    //ADD NEW
                    foreach($request->file('images') as $file){
                        if ($file->isValid()) {
                            $path = public_path('uploads/events/');
                            //$image_name = $id . '-'. rand() .'-' . $file->getClientOriginalName();
                            $image_name = $id . '-'. rand() .'.jpeg';
                            if ($file->move($path, $image_name)) {
                                $images_array['events_id'] = $id;
                                $images_array['name'] = 'uploads/events/' . $image_name;
                                $images_array['status'] = 'Active';
                                $update_data = DB::table('events_images')->insert($images_array);
                            }
                        }
                    }
                    //ADD NEW
                }

                if($update_data){
                    Session::flash('success', ' Data Updated successfully'); 
                    return redirect('admin/manage_events');
                } else {
                    Session::flash('error', ' Oops! something went wrong'); 
                    return redirect('admin/manage_events');
                }
            } else {
                Session::flash('error', ' No Data Found'); 
                return redirect('admin/manage_events');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- UPDATE EVENT -------------- //
    // -------------  EVENT BOOKING -------------- //


    public function event_bookings(){
        if (session()->has('id')) {
            $total_event_bookings          = number_format(DB::table('event_bookings')->count());
            $fetch_data                     = DB::table('event_bookings')->orderBy('event_booking_id','DESC')->get();
            
            
            return view('admin.event_booking', compact('fetch_data', 'total_event_bookings'));
        } else {
            return redirect('/');
        }
    } 
    public function event_tickets(){
        if (session()->has('id')) {
            $my_venues                      = number_format(DB::table('events')->select('events_id')->where('users_business_id', session('id'))->count());
            // $my_venues_ids                  = DB::table('events')->select('events_id')->where('users_business_id', session('id'))->get();
            $my_venues_ids                  = DB::table('events')->select('events_id')->get();
            $my_venues_ids_array            = json_decode(json_encode($my_venues_ids), true);

            $total_events_bookings          = number_format(DB::table('event_bookings')->whereIn('events_id', $my_venues_ids_array)->count());
            $fetch_data                     = DB::table('event_bookings')->orderBy('event_booking_id','DESC')->whereIn('events_id', $my_venues_ids_array)->get();
            
            return view('admin.event_tickets', compact('fetch_data', 'total_events_bookings'));
        } else {
            return redirect('/');
        }
    }
    // -------------  EVENT BOOKING -------------- //

    // ------------- ACCOUNT SETTINGS -------------- //
    public function account_settings(){
        if(session()->has('id')){
            $fetch_data = DB::table('users_system')->where('users_system_id',session('id'))->get();
            return view('admin.account_settings',compact('fetch_data'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- ACCOUNT SETTINGS -------------- //

    // ------------- UPDATE ACCOUNT SETTINGS -------------- //
    public function account_settings_update(Request $req,$id){
        $insert=array();
        $insert['first_name'] = $req->first_name;
        $insert['email'] = $req->email;
        $insert['password'] = $req->password;
        
        $insert['city'] = $req->city;
        $insert['address'] = $req->address;
        $insert['mobile'] = $req->mobile;

        if ($req->hasfile('image')) {
            $file = $req->file('image');
            if ($file->isValid()) {
                $ext = $file->extension();
                $path = public_path('uploads/users_system/');
                $prefix = 'user-' . md5(time());
                $img_name = $prefix . '.' . $ext;
                if ($file->move($path, $img_name)) {
                    $insert['user_image'] = 'uploads/users_system/' . $img_name;
                }
            }
        }

        $a = DB::table('users_system')->where('users_system_id','=',$id)->update($insert);
        if ($a) {
            Session::flash('success', ' Profile Updated successfully'); 
            return redirect('admin/account_settings');
        } else {
            Session::flash('error', ' oops! something went wrong'); 
            return redirect('admin/account_settings');
        }
    }
    // ------------- UPDATE ACCOUNT SETTINGS -------------- //

    // ------------- MANAGE SYSTEM USERS -------------- //
    public function users_system(Request $request){
        if ($request->session()->has('id')) {
            $users= db::table('users_system')->orderBy('users_system_id', 'DESC')->get();
            return view('admin.users_system', compact('users'));
        } else {
            return view('admin.login');
        }
    }
    // ------------- MANAGE SYSTEM USERS -------------- //

    // ------------- UPDATE SYSTEM USERS -------------- //
    public function users_system_update(Request $req){
        $insert=array();
        $insert['total_conncash'] = $req->total_conncash;
        $insert['status'] = $req->status;

        if($req->status=='Active'){
            $insert['status'] = 'Active';
        }

        if($req->status=='Inactive'){
            $insert['status'] = 'Inactive';
        }
        
        $a = DB::table('users_system')->where('users_system_id','=',$req->users_system_id)->update($insert);
        if ($a) {
            return back()->with('success', 'Data Updated successfully');
        } else {
             return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // ------------- UPDATE SYSTEM USERS -------------- //

    // ------------- DELETE SYSTEM USERS -------------- //
    public function users_system_delete(Request $req){
        if(session()->has('id')){
            if(!empty($req->users_id)){
                $checkdata = DB::table('users_system')->where('users_system_id', $req->users_system_id)->where('status', '!=','Deleted')->get();

                if(count($checkdata) != 0){
                    $del=DB::table('users_system')->where('users_system_id', '=', $req->users_system_id)->update(array( 'status' => 'Deleted'));
                    if($del){
                        Session::flash('success', ' Data Deleted successfully'); 
                        return back()->with('success', 'Data Deleted successfully');
                    }else{
                        Session::flash('error', ' Oops! something went wrong'); 
                        return back()->with('error', 'Oops! something went wrong');
                    }
                } else {
                    Session::flash('error', ' This record is already deleted in status'); 
                    return back()->with('error', 'This record is already deleted in status');
                }
            } else {
                Session::flash('error', ' Not Found'); 
                return back()->with('error', 'Not Found');
            }
        } else {
            return redirect('admin');
        }
    }
    // ------------- DELETE SYSTEM USERS -------------- //

    // ------------- MANAGE SYSTEM SETTINGS -------------- //
    public function system_settings(Request $request){
        if ($request->session()->has('id')) {
            $system_settings = DB::table('system_settings')->get();
            return view('admin.system_settings', compact('system_settings'));
        } else {
            return redirect('admin');
        }
    }
    // ------------- MANAGE SYSTEM ROLES EDIT -------------- //

    // ------------- MANAGE SYSTEM USERS ROLES DATA -------------- //
    public function system_settings_edit(Request $req){
        $page_name  = $req->page_name;
        // dd($req->all());    

        if(isset($req->free_package)){
            $data['description']          = $req->free_package;
            DB::table('system_settings')->where('type', 'free_package')->update($data);
        } 
        if(isset($req->reservation_feature)){
            $data['description']          = $req->reservation_feature;
            DB::table('system_settings')->where('type', 'reservation_feature')->update($data);
        } 
        if(isset($req->email_templates)){
            $data['description']          = $req->email_templates;
            DB::table('system_settings')->where('type', 'email_templates')->update($data);
        } 
        if(isset($req->radius_unit)){
            $data['description']          = $req->radius_unit;
            DB::table('system_settings')->where('type', 'radius_unit')->update($data);  
        } 
        if(isset($req->radius)){
            $data['description']          = $req->radius;
            DB::table('system_settings')->where('type', 'radius')->update($data);  
        } 
        if(isset($req->stripe_keys)){
            $data['description']          = $req->stripe_keys;
            DB::table('system_settings')->where('type', 'stripe_keys')->update($data);  
        } 

        if(isset($req->system_currency)){
            $data['description']          = $req->system_currency;
            DB::table('system_settings')->where('type', 'system_currency')->update($data);
        } 

        if(isset($req->social_login)){
            $data['description']          = $req->social_login;
            DB::table('system_settings')->where('type', 'social_login')->update($data);
        } 

        if(isset($req->cron_job)){
            $data['description']          = $req->cron_job;
            DB::table('system_settings')->where('type', 'cron_job')->update($data);
        } 

        if (isset($req->image)) {
            $image              = $req->file('image');
            $image1_name        = $image->getClientOriginalName();
            $destinationPath    = public_path().'/uploads/system_image' ;
            $image_n            = $image1_name;
            $uploaded           = $image->move($destinationPath, $image1_name);
            
            $data['description'] = 'uploads/system_image/' . $image_n;
            DB::table('system_settings')->where('type', 'system_image')->update($data);
        }   

        if (isset($req->image_favicon)) {
            $image              = $req->file('image_favicon');
            $image1_name        = $image->getClientOriginalName();
            $destinationPath    = public_path().'/uploads/system_image_favicon' ;
            $image_n            = $image1_name;
            $uploaded           = $image->move($destinationPath, $image1_name);
            
            $data['description'] = 'uploads/system_image_favicon/' . $image_n;
            DB::table('system_settings')->where('type', 'system_image_favicon')->update($data);
        }   

        session()->flash('success', 'System settings updated successfully!');
        return redirect('admin/'.$page_name);
    }
    
    // ------------- MANAGE SYSTEM USERS ROLES DATA -------------- //
    // Show Ticket
    // public function download_file($id)
    // {
    //     $data = DB::table('event_bookings')->where('event_booking_id', $id)->first();
    //     $path = env('ASSET_URL').'/';
    //     $filename = $data->event_ticket;

    //     return response()->download($path, $filename);
    // }
    public function download_file($id)
{
    $data = DB::table('event_bookings')->where('event_booking_id', $id)->first();

  
    $url = env('ASSET_URL'); // Assuming the environment variable stores the URL to the file
    $filename = $data->event_ticket;

    $fileUrl = $url . '/' . $filename; // Construct the complete file URL

    $fileContent = file_get_contents($fileUrl);

    return response($fileContent)
        ->header('Content-Type', 'application/pdf')
        ->header('Content-Disposition', 'attachment; filename="' . $filename . '"');
}

    
    
    // Show Ticket

    //    ---------------REFUND REQUEST-------------
public function refund_request(){
    if (session()->has('id')) {
      
        $get_data  = DB::table('refund_requests')->orderBy('refund_requests_id','ASC')->get();
        $fetch_data = [];
        foreach ($get_data as $key => $value) {
            $value->user_customer =  DB::table('users_customers')->where('users_customers_id',$value->users_customers_id)->first();
            $value->events =  DB::table('events')->where('events_id',$value->events_id)->first();
            $event_bookings =  DB::table('event_bookings')->where('event_booking_id',$value->event_booking_id)->first();
            
                $value->event_bookings=$event_bookings;
            
            $fetch_data[]=$value;
        }
        return view('admin.request_refund', compact('fetch_data'));
    } else {
        return redirect('/'); 
    }
}

    //    ---------------REFUND REQUEST-------------

     /** SUPPORT **/
     public function support(){
        if (!session()->has('id')) {
          return redirect('admin/admin');
        } else {
          return view('admin.support');
        }
    }
    /** SUPPORT **/  

    //  Email Templates
    public function email_templates()
    {
        // Fetch your email templates data here
        $email_templates = DB::table('email_templates')->orderBy('email_templates_id','DESC')->get();

        return view('admin.email_templaes', compact('email_templates'));
    }

    public function edit_template(Request $request,$id)
    { 
        if(session()->has('id')){
            if(!empty($id)){
                $email_template['type'] = $request->type; 
                $email_template['subject'] = (float) $request->subject;
                $email_template['body'] = $request->body; 
                $update_data = DB::table('email_templates')->where("email_templates_id",$id)->update($email_template);
                if($update_data){
                    Session::flash('success', ' Data Updated successfully'); 
                    return redirect('admin/email_templates');
                } else {
                    Session::flash('error', ' Oops! something went wrong'); 
                    return redirect('admin/email_templates');
                }
            } else {
                Session::flash('error', ' No Data Found'); 
                return redirect('admin/email_templates');
            }
        } else {
            return redirect('/');
        }
        
        // $template = DB::table('email_templates')->find($id);

        // return response()->json(['success' => true, 'template' => $template]);
    }


    //  Email Templates
    public function stamps_packs_update(Request $request ,$id){
        if(session()->has('id')){
            if(!empty($id)){
                if ($request->hasfile('stamps_packs_image')) {
                $stamps_packs = $request->stamps_packs_image;
                $prefix = time();
                $img_name = $prefix . '_stamps_packs.jpeg';
                $image_path = public_path('uploads/stamps_packs');
                $stamps_packs->move($image_path,$img_name);
                $stamps_array['stamps_packs_image'] = 'uploads/stamps_packs/' . $img_name;
                }
                $stamps_array['stamps_packs_name'] = $request->packs_name; 
                $stamps_array['stamps_packs_price'] = (float) $request->packs_price;
                $stamps_array['status'] = $request->status; 
                $update_data = DB::table('stamps_packs')->where("stamps_packs_id",$id)->update($stamps_array);
                // dd($update_data);
                if(isset($_POST['Delete'])){
                    $update_array['status'] = 'Deleted';
                } else { 
                    $update_array['status'] = $request->status;
                }
                if($update_data){
                    Session::flash('success', ' Data Updated successfully'); 
                    return redirect('admin/stamps_packs');
                } else {
                    Session::flash('error', ' Oops! something went wrong'); 
                    return redirect('admin/stamps_packs');
                }
            } else {
                Session::flash('error', ' No Data Found'); 
                return redirect('admin/stamps_packs');
            }
        } else {
            return redirect('/');
        }
    }
    // --------------------------------------------Crowd Crafting------------------------------------------------//  
    // -----------------------------------------------------------Venue Crafting---------------------------------------------------//
    // venue type
    public function venue_type()
    {
        // Fetch your email templates data here
        $venue_type = DB::table('venues_type')->orderBy('venues_type_id','DESC')->get();

        return view('admin.venues_types', compact('venue_type'));
    }
    public function venue_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['venues_type_name'] = $request->type;        
            $insert_data_id = DB::table('venues_type')->insertGetId($insert_array);  
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/venue_type');
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function venue_type_update($venues_type_id, $status){
        $update['status'] = $status;
        $updated = DB::table('venues_type')->where('venues_type_id', '=', $venues_type_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // venue type
    // Venue Music
    public function music_type()
    {
        // Fetch your email templates data here
        $music_type = DB::table('venues_music')->orderBy('venues_music_id','DESC')->get();

        return view('admin.music_type', compact('music_type'));
    }
    public function music_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['music_type'] = $request->type;        
            $insert_data_id = DB::table('venues_music')->insertGetId($insert_array);  
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/music_type');    
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function music_type_update($venues_music_id, $status){
        $update['status'] = $status;
        $updated = DB::table('venues_music')->where('venues_music_id', '=', $venues_music_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // Venue Music
    // Venue Budget
    public function budget_type()
    {
        // Fetch your email templates data here
        $venues_budget = DB::table('venues_budget')->orderBy('venues_budget_id','DESC')->get();    

        return view('admin.budget_type', compact('venues_budget'));
    }
    public function budget_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['budget_range'] = $request->type;        
            $insert_data_id = DB::table('venues_budget')->insertGetId($insert_array);  
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/budget_type');          
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function budget_type_update($venues_budget_id, $status){
        $update['status'] = $status;
        $updated = DB::table('venues_budget')->where('venues_budget_id', '=', $venues_budget_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // Venue Budget
    // Cuisine Type
    public function cuisine_type()
    {
        // Fetch your email templates data here
        $venues_cusine = DB::table('venues_cusine')->orderBy('venues_cusine_id','DESC')->get();    

        return view('admin.cuisine_type', compact('venues_cusine'));
    }
    public function cuisine_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['cusine'] = $request->type;        
            $insert_data_id = DB::table('venues_cusine')->insertGetId($insert_array);     
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/cuisine_type');          
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function cuisine_type_update($venues_cusine_id, $status){
        $update['status'] = $status;
        $updated = DB::table('venues_cusine')->where('venues_cusine_id', '=', $venues_cusine_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // Cuisine Type
    // Food Type
    public function food_type()
    {
        // Fetch your email templates data here
        $venues_food = DB::table('venues_food')->orderBy('venues_food_id','DESC')->get();    

        return view('admin.food_type', compact('venues_food'));
    }
    public function food_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['food_type'] = $request->type;        
            $insert_data_id = DB::table('venues_food')->insertGetId($insert_array);          
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/food_type');          
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function food_type_update($venues_food_id, $status){
        $update['status'] = $status;
        $updated = DB::table('venues_food')->where('venues_food_id', '=', $venues_food_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // Food Type
    // ------------------------------------------------------Venue Crafting--------------------------------------------------------//
    // ------------------------------------------------------Event Crafting---------------------------------------------------------//
    public function event_type()
    {
        // Fetch your email templates data here
        $event_type = DB::table('event_type')->orderBy('event_type_id','DESC')->get();    

        return view('admin.event_type', compact('event_type'));
    }
    public function event_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['event_type'] = $request->type;        
            $insert_data_id = DB::table('event_type')->insertGetId($insert_array);          
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/event_type');          
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function event_type_update($event_type_id, $status){
        $update['status'] = $status;
        $updated = DB::table('event_type')->where('event_type_id', '=', $event_type_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    // Event Type
    //  Event Music
    public function event_music_type()
    {
        // Fetch your email templates data here
        $event_music = DB::table('event_music')->orderBy('event_music_id','DESC')->get();    

        return view('admin.event_music', compact('event_music'));
    }
    public function event_music_type_add(Request $request)
    {
        if(session()->has('id')){
            $insert_array['event_music'] = $request->type;        
            $insert_data_id = DB::table('event_music')->insertGetId($insert_array);          
            if($insert_data_id){
                Session::flash('success', ' Data Updated successfully'); 
                return redirect('admin/event_music_type');          
            }else{
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('admin/dashboard');
             }
        } else {
        Session::flash('error', ' Oops! something went wrong'); 
        return redirect('admin/dashboard');
        }
    }
    public function event_music_type_update($event_music_id, $status){
        $update['status'] = $status;
        $updated = DB::table('event_music')->where('event_music_id', '=', $event_music_id)->update($update);
        if ($updated) {
            Session::flash('success', ' Data Updated successfully'); 
            return back()->with('success', 'Data Updated successfully');
        } else {
            Session::flash('error', ' Oops! something went wrong'); 
            return back()->with('errors', 'Oops! something went wrong');
        }
    }
    //  Event Music
    // ------------------------------------------------------Event Crafting---------------------------------------------------------//    
}