<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Session;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;


use App\Models\Admin;
use App\Models\Group;
use App\Models\MutedMember;
use App\Models\Bookmark;
use App\Models\ReportThread;
use App\Models\Follower;
use App\Models\Comment;
use App\Models\Reply;
use App\Models\CommentLike;
use App\Models\ReplyLike;
use App\Models\ViewPost;
use App\Models\Notification;
use App\Models\HappyReaction;
use App\Models\SadReaction;
use App\Models\RecentSearch;
use App\Models\ContactUsQuery;
use App\Mail\ReportMail;
use App\Models\GroupReport;

use App\Models\Ethnicity;
use App\Models\BodyType;
use App\Models\Position;
use App\Models\Relationship;
use App\Models\Seeking;
use App\Models\GroupSeeking;
use App\Models\Tribe;
use App\Models\GroupPicture;
use App\Models\GroupTribe;
use App\Models\PrivateGalleryAccess;

class AdminGroupController extends Controller
{

    //USERS MODULE
    public function manage_groups(){
        $groups = Group::join('group_categories','group_categories.group_category_id','groups.group_category_id')
            ->join('users','users.users_id','groups.users_id')
            ->orderBy('group_id', 'DESC')->get();


//        return view('groups.manage_groups', ['groups'=> $groups]);
        return view('groups.manage_groups', compact('groups'));
    }


    public function active_groups(){
        $groups = Group::join('blocked_groups','groups.group_id','!=','blocked_groups.blocked_group_id')->where('status', 'Active')->orderBy('group_id', 'DESC')->get();
        return view('groups.active_groups', ['groups'=> $groups]);
    }



    public function inactive_groups(){
        $groups = Group::where('status', 'Inactive')->orderBy('group_id', 'DESC')->get();
        return view('groups.inactive_groups', ['groups'=> $groups]);
    }


    public function group_gallery($id){

        $visiblePictures = GroupPicture::leftjoin('groups','groups.group_id','group_pictures.group_id')
            ->where([ ['group_pictures.group_id', $id], ['picture_type', 'Visible']])
            ->get();

        $privatePictures = GroupPicture::leftjoin('groups','groups.group_id','group_pictures.group_id')
            ->where([ ['group_pictures.group_id', $id], ['picture_type', 'Private']])
            ->get();

        $groups = Group::where('group_id', $id)->first();

        return view('groups.groups_gallery', compact('visiblePictures','privatePictures','groups'));
    }


    //USERS MODULE
    public function report_groups(){
//nabeel changed
        $groups = GroupReport::join('users','users.users_id','group_reports.users_id')
            ->join('groups','groups.group_id','group_reports.group_id')
            ->join('group_categories','group_categories.group_category_id','groups.group_category_id')
//            ->join('users','users.users_id','groups.users_id')
//            ->orderBy('group_id', 'DESC')
            ->get();

//        $groups = Group::join('group_categories','group_categories.group_category_id','groups.group_category_id')
//            ->join('users','users.users_id','groups.users_id')
//            ->orderBy('group_id', 'DESC')->get();
//        nabeel changed

//        $groups = GroupReport::join('groups','groups.group_id','group_reports.reported_to_group_id')->orderBy('group_id', 'DESC')->get();
        return view('groups.report_groups', compact('groups'));
    }

    //USERS MODULE
    public function blocked_groups(){
//        $groups = BlockGroup::join('groups','groups.group_id','blocked_groups.blocked_group_id')->orderBy('group_id', 'DESC')->get();
//        return view('groups.blocked_groups', compact('groups'));
    }



    // Get views Functions
    public function form(){
        return view('form');
    }
    public function datatable(){
        return view('data-table');
    }




}
