<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Session;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Validator;

use App\Models\Admin;
use App\Models\User;
use App\Models\MutedMember;
use App\Models\Group;
use App\Models\Bookmark;
use App\Models\ReportThread;
use App\Models\Follower;
use App\Models\Comment;
use App\Models\Reply;
use App\Models\CommentLike;
use App\Models\ReplyLike;
use App\Models\ViewPost;
use App\Models\Notification;
use App\Models\HappyReaction;
use App\Models\SadReaction;
use App\Models\RecentSearch;
use App\Models\ContactUsQuery;
use App\Mail\ReportMail;
use App\Models\UserReport;
use App\Models\BlockUser;

use App\Models\Ethnicity;
use App\Models\BodyType;
use App\Models\Position;
use App\Models\Relationship;
use App\Models\Seeking;
use App\Models\UserSeeking;
use App\Models\Tribe;
use App\Models\Feature;
use App\Models\ImportantRule;
use App\Models\GroupCategory;



use App\Models\UserPicture;
use App\Models\UserTribe;
use App\Models\PrivateGalleryAccess;

class AdminRegistrationController extends Controller
{

//    Tribe Functions Start
    public function tribe_index(){
        $tribes = Tribe::orderBy("tribe_id","ASC")->get();
        return view('registration.tribe',compact('tribes'));
    }

    public function tribe_store(Request $request){

        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string','unique:tribes,tribe'],
        ]);
        
        if ($validator->fails()){
            return response()->json([
                'status'=>400,
                'errors'=>$validator->messages()
            ]);
        }else{

            $tribe = new Tribe;
            $tribe->tribe = $request->name;
            $tribe->timestamps = false;
            $tribe->save();

            return response()->json([
                'status'=>200,
                'employee'=>$tribe
            ]);
        }
    }

    public function tribe_edit($id){

        $emp = Tribe::where('id','=',$id)->first();

        if ($emp){
            return response()->json([
                'status'=>200,
                'employee'=>$emp
            ]);
        }else{
            return response()->json([
                'status'=>400,
                'message'=>"Not Found"
            ]);
        }

    }

    public function tribe_update(Request $request,$id){

         
        $tribe = Tribe::find($id);
        $tribe = new Tribe;
        $tribe->tribe = $request->name;
        $tribe->timestamps = false;
        $tribe->save();

            return response()->json([
                'status'=>200,
                'errors'=>"Tribe Updated"
            ]);




    }

    public function tribe_delete($id){

        // $emp = Tribe::where('id','=',$id)->first();

        // if ($emp){
        //     $emp->delete();
        //     return response()->json([
        //         'status'=>200,
        //         'message'=>"Employee Deleted Successfully"
        //     ]);
        // }else{
        //     return response()->json([
        //         'status'=>400,
        //         'message'=>"Not Found"
        //     ]);
        // }
        $data=Tribe::find($id);
        $data->delete();
        session()->flash('message','Your Tribe Deleted Successfully');
        return redirect('tribe'); 

    }
//    Tribe Functions End

    // Get views Functions
    public function form(){
        return view('form');
    }
    public function datatable(){
        return view('data-table');
    }
    public function index(){
        $group_categories = GroupCategory::orderBy("group_category_id","ASC")->get();
        return view('registration.category',compact('group_categories'));
    }
    public function save(Request $request){
        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string'],
            'image'=>['required']
        ]);
        
        if ($validator->fails()){
            return response()->json([
                'status'=>400,
                'errors'=>$validator->messages()
            ]);
        }else{
            $image = $request->file('image');
            $image_name = $image->getClientOriginalName();
            $destinationPath = public_path().'/img';
            $imageSave = "https://flockdock.eigix.net/public/img/".$image_name;
            $image->move($destinationPath, $image_name);
            $GroupCategory = new GroupCategory;
            $GroupCategory->category = $request->name;
            $GroupCategory->category_image = $imageSave;
            $GroupCategory->timestamps = false;
            $GroupCategory->save();

            return response()->json([
                'status'=>200,
                'employee'=>$GroupCategory
            ]);
        }
    }
    public function update(Request $request)
    {
        {  
            $data=GroupCategory::find($request->id);
            $image = $request->file('image');
            $image_name = $image->getClientOriginalName();
            $destinationPath = public_path().'/img';
            $imageSave = "https://flockdock.eigix.net/public/img/".$image_name;
            $image->move($destinationPath, $image_name);
            // $data->id=session()->get('id');
            $data->category=$request->name;
            $data->category_image = $imageSave;
            $data->update();
            session()->flash('message','Your Category Updated Successfully');
            return redirect('category');
        }
    }
    public function category_delete($id){
        $data=GroupCategory::find($id);
        $data->delete();
        session()->flash('message','Your Category Deleted Successfully');
        return redirect('category'); 

    }
    public function feature_index(){
        $features = Feature::orderBy("feature_id","ASC")->get();
        return view('registration.feature',compact('features'));
    }
    public function feature_store(Request $request){ 
        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string','unique:features,feature'],
        ]);
        
        if ($validator->fails()){
            return response()->json([
                'status'=>400,
                'errors'=>$validator->messages()
            ]);
        }else{

            $feature = new feature;
            $feature->feature = $request->name;
            $feature->timestamps = false;
            $feature->save();

            return response()->json([
                'status'=>200,
                'employee'=>$feature
            ]);
        }
    }
    public function feature_delete($id){
        $data=feature::find($id);
        $data->delete();
        session()->flash('message','Your feature Deleted Successfully');
        return redirect('feature'); 

    }
    public function rule_index()
    {
        $important_rules = ImportantRule::orderBy("important_rule_id","ASC")->get();
        return view('registration.rule',compact('important_rules'));   
    }

    public function rule_store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string'],
        ]);
        
        if ($validator->fails()){
            return response()->json([
                'status'=>400,
                'errors'=>$validator->messages()
            ]);
        }else{

            $ImportantRule = new ImportantRule;
            $ImportantRule->important_rule = $request->name;
            $ImportantRule->timestamps = false;
            $ImportantRule->save();

            return response()->json([
                'status'=>200,
                'employee'=>$ImportantRule
            ]);
        }  
    }
    public function rule_delete($id){
        $data=ImportantRule::find($id);
        $data->delete();
        session()->flash('message','Your rule Deleted Successfully');
        return redirect('rule'); 

    }





}
