<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Mail;
use App\Mail\SendMail;
use DB;
use Illuminate\Support\Facades\Session;
use Carbon\Carbon;
use App\Helpers\Helper;
use Stripe\Stripe;
use Stripe\Customer;
use Stripe\PaymentIntent;
use Stripe\EphemeralKey;

class ApiController extends Controller{
    
  /* SEND NOTIFICATIONS */
  public function send_notification($data){
    DB::table('notifications')->insert($data);
  }
  /* SEND NOTIFICATIONS */
  
  function calculate_distance($lat_from , $long_from , $lat_to , $long_to , $unit = 'Miles'){
    $radius_unit  = DB::table('system_settings')->select('description')->where('type', 'radius_unit')->get()->first();
    $unit = $radius_unit ? $radius_unit->description : $unit;  

    $theta = $long_to - $long_from;
    $distance = sin(deg2rad($lat_from)) * sin(deg2rad($lat_to)) + cos(deg2rad($lat_from)) * cos(deg2rad($lat_to)) * cos(deg2rad($theta));
    $distance = acos($distance);
    $distance = rad2deg($distance);
    $miles = $distance * 60 * 1.1515; 

    // echo "Theta: $theta, Distance (radians): $distance, Distance (miles): $miles\n";

    if ($unit == 'KM') {
        return number_format((float)($miles * 1.609344), 2, '.', '');
    } else if ($unit == 'N') {
        return number_format((float)($miles * 0.8684), 2, '.', '');
    } else if ($unit == 'Miles') {
        return number_format((float)$miles, 2, '.', '');
    } else {
        return '1.2 Miles';
    }
}
//   function calculate_distance_debug($lat_from =30.2273016 , $long_from =71.4782754 , $lat_to=30.2273016 , $long_to =71.4782754 , $unit = 'KM'){  
//     $radius_unit  = DB::table('system_settings')->select('description')->where('type', 'radius_unit')->get()->first();
//     $unit = $radius_unit ? $radius_unit->description : $unit;  
//     echo  $unit;
//     exit();

//     $theta = $long_to - $long_from;
//     $distance = sin(deg2rad($lat_from)) * sin(deg2rad($lat_to)) + cos(deg2rad($lat_from)) * cos(deg2rad($lat_to)) * cos(deg2rad($theta));
//     $distance = acos($distance);
//     $distance = rad2deg($distance);
//     $miles = $distance * 60 * 1.1515; 

//     // echo "Theta: $theta, Distance (radians): $distance, Distance (miles): $miles\n";

//     if ($unit == 'KM') {
//         return number_format((float)($miles * 1.609344), 2, '.', '');
//     } else if ($unit == 'N') {
//         return number_format((float)($miles * 0.8684), 2, '.', '');
//     } else if ($unit == 'Miles') {
//         return number_format((float)$miles, 2, '.', '');
//     } else {
//         return '1.2 Miles';
//     }
// }
  


  /* CACLULATE DISTANCE */
  // public function calculate_distance($lon1 , $lat1, $lon2 , $lat2, $unit = 'M'){
  //   $theta = $lon1 - $lon2;
  //   $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
  //   $dist = acos($dist);
  //   $dist = rad2deg($dist);
  //   $miles = $dist * 60 * 1.1515;
  //   $unit = strtoupper($unit);

  //   if ($unit == "K") {
  //     return ($miles * 1.609344);
  //   } else if ($unit == "N") {
  //     return ($miles * 0.8684);
  //   } else if ($unit == "M") {
  //     return $miles;
  //   } else {
  //     return '1.2 Miles'; 
  //   }
  // }
  /* CACLULATE DISTANCE */

  /*** SIGNUP with Google/facebook  ***/
  public  function users_customers_signup_social(Request $req){
    if (isset($req->email) && isset($req->password) && isset($req->status) && isset($req->one_signal_id) && isset($req->account_type) && isset($req->social_username)
     && isset($req->social_profile) && isset($req->social_acc_type) && isset($req->verify_code) && isset($req->google_access_token)) {
      $email=DB::table('users_customers')->where('email', $req->email)->get()->count();
      if ($email==0) {

        $randomString = Str::random(12);    
        $md5Token = md5($randomString);
        $auth_key = 'authentication_key_' .$md5Token;
        $data=array(   
          'email'=>$req->email,
          'password'=>$req->password,
          'status'=>$req->status,
          'one_signal_id'=>$req->one_signal_id,
          'account_type'=>$req->account_type,
          'username'=>$req->social_username,
          'profile_picture'=>$req->social_profile,
          'social_acc_type'=>$req->social_acc_type,
          'authentication_token'=>$auth_key,
          'verify_code'=>$req->verify_code,
          'google_access_token'=>$req->google_access_token
        );

        $registerId   = DB::table('users_customers')->insertGetId($data);
        $register     = DB::table('users_customers')->where('users_customers_id', $registerId)->get();
        $response["code"] = 200;   
        $response["status"] = "success";
        $response["data"] = $register;
      } else {
        $register     = DB::table('users_customers')->where('email', $req->email)->get();

        $response["code"] = 200;   
        $response["status"] = "success";
        $response["data"] = $register;
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
    
    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  /*** SIGNUP with Google/facebook  ***/

  /* SIGNUP USERS CUSTOMERS */
  public function users_customers_signup(Request $req){
   
    if (isset($req->email) && isset($req->password) && isset($req->account_type)) {
      $email = DB::table('users_customers')->where('email', $req->email)->get()->count();

      if($email == 0) {
        $randomString = Str::random(12);    
        $md5Token = md5($randomString);
        $auth_key = 'authentication_key_' .$md5Token;
        $data = array(
          
          'email'=>$req->email,
          'account_type'=>$req->account_type,
          'password'=> md5($req->password),
          'authentication_token'=> $auth_key,  
          'date_added'=>date('Y-m-d H:i:s'),
          'notifications'=>'Yes',
          'status'=>'Active'
        );

        $users_customers_id   = DB::table('users_customers')->insertGetId($data);
        $users_customers      = DB::table('users_customers')->where('users_customers_id', $users_customers_id)->get();
        $response["code"]     = 200;   
        $response["status"]   = "success";
        $response["data"]     = $users_customers;
      } else {
        $response["code"]     = 401;
        $response["status"]   = "error";
        $response["message"]  = "Email already exists.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
    
    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  /* SIGNUP USERS CUSTOMERS */
    
  /* LOGIN USERS CUSTOMERS */
  public function users_customers_login(Request $req){
    if (isset($req->email) && isset($req->password)) {
      $email = DB::table('users_customers')->where('email', $req->email)->get()->count();
      if ($email>0) {
        $data=DB::table('users_customers')->where('email', $req->email)->get();
        $password=$data[0]->password;
        $id = $data[0]->users_customers_id;
        if (md5($req->password) == $password) {
          $userDetail=DB::table('users_customers')->where('users_customers_id', $id)->get()->first();
          if (isset($userDetail) && $userDetail != null) {
            if($userDetail->status == 'Active'){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $userDetail;
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "User Account is inactive.";
            } 
          } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "User do not exist.";
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Password do not match.";
        }
      }else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Email does not exits.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
  /* LOGIN USERS CUSTOMERS */

  /* UPDATE PROFILE */
  public function update_profile(Request $req){
    if(isset($req->users_customers_id) && isset($req->email) && isset($req->full_name) && isset($req->username) && isset($req->notifications) && isset($req->be_seen)) {
      $updateData['users_customers_id'] = $req->users_customers_id;
      $updateData['email']              = $req->email;
      $updateData['full_name']          = $req->full_name;
      $updateData['username']           = $req->username;
      $updateData['notifications']      = $req->notifications;
      $updateData['be_seen']            = $req->be_seen;
      $updateData['ai_feature']         = $req->ai_feature;

      if(isset($req->profile_picture)){
        $profile_picture = $req->profile_picture;
        $prefix = time();
        $img_name = $prefix . '.jpeg';
        $image_path = public_path('uploads/users_customers/') . $img_name;

        file_put_contents($image_path, base64_decode($profile_picture));
        $updateData['profile_picture'] = 'uploads/users_customers/'. $img_name;
      }

      DB::table('users_customers')->where('users_customers_id', $req->users_customers_id)->update($updateData);
      $updatedData = DB::table('users_customers')->where('users_customers_id', $req->users_customers_id)->get();
 
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $updatedData;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* UPDATE PROFILE */

  /* FORGETPASSWORD API */
  // public function forgot_password(Request $req){
  //   if (isset($req)) {
  //     $email=DB::table('users_customers')->where('email', $req->email)->get()->count();
  //     if ($email>0) {
  //       $data = DB::table('users_customers')->where('email', $req->email)->get();
  //       $id = $data[0]->users_customers_id;
  //       $onlyEmail = $req->email;
  //       $otp = rand(1000,9999);
  //       $details = [
  //           "title"=>"Email Verification Code",
  //           "body"=> $otp
  //       ];
  //       $otpSended= Mail::to($onlyEmail)->send(new SendMail($details));
  //       $otpData=array(
  //        'verify_code'=>$otp
  //       );
  //       $UserotpUpdate=DB::table('users_customers')->where('users_customers_id', $id)->update($otpData);

  //       $details = array('otp' => $otp, 'message' => 'OTP sent in the email.');
  //       $response["code"] = 200;
  //       $response["status"] = "success";
  //       $response["data"] = $details;
  //     }else{
  //       $response["code"] = 404;
  //       $response["status"] = "error";
  //       $response["message"] = "Email does not exists.";
  //     }
  //   }else{
  //     $response["code"] = 404;
  //     $response["status"] = "error";
  //     $response["message"] = "Please enter email address.";
  //   }
    
  //   return response()
  //     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
  //     ->header('Content-Type', 'application/json');
  // }
  public function forgot_password(Request $req){
    if (isset($req)) {
        $email = DB::table('users_customers')->where('email', $req->email)->get()->count();

        if ($email > 0) {
          // Retrieve the email template from the database based on type
          $template = DB::table('email_templates')
              ->where('type', 'forgot_password')      
              ->first();
      
          if (!$template) {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "Email template not found for forget password.";
              return response()
                  ->json([
                      'status' => $response["status"],
                      'message' => $response["message"]
                  ])
                  ->header('Content-Type', 'application/json');
          }
      
          // Get user data
          $userData = DB::table('users_customers')->where('email', $req->email)->first();
      
          // Replace tags in the template with actual data
          $templateBody = str_replace('{user_name}', $userData->username, $template->body);
          $otp = rand(1000, 9999);
          $templateBody = str_replace('{otp}', $otp, $templateBody); // Assuming you want to replace the OTP
      
          $details = [
              "title" => $template->subject,
              "body" => $templateBody
          ];
      
          // Send email with the modified template
          $otpSended = Mail::to($req->email)->send(new SendMail($details));
      
          // Update the OTP in the database
          $UserotpUpdate = DB::table('users_customers')->where('users_customers_id', $userData->users_customers_id)
              ->update(['verify_code' => $templateBody]);
      
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = [
              'message' => 'OTP sent in the email.',
              'otp' => $otp // Include the OTP in the response
          ];
      } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Email does not exist.";
      }
      
      return response()
          ->json([
              'status' => $response["status"],
              isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]
          ])
          ->header('Content-Type', 'application/json');
}
  }

  /* FORGETPASSWORD API */

  /* MODIFY PASSWORD */
  public function modify_password(Request $req){
    if (isset($req->email) && isset($req->otp) && isset($req->password) && isset($req->confirm_password)) {
      $forgetOtp = DB::table('users_customers')->select('verify_code')->where('email', $req->email)->get();
      $otpforgetdb = $forgetOtp[0]->verify_code;
      if ($otpforgetdb == $req->otp) {
        if ($req->confirm_password == $req->password) {
          $otpData=array(
           'verify_code'=>'',
           'password' => md5($req->password)
          );
          
          $UserotpUpdate =DB::table('users_customers')->where('email', $req->email)->update($otpData);
          $users_customers = DB::table('users_customers')->where('email', $req->email)->get();
          
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $users_customers;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Password and confirm password do not match.";
        }
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Otp do not match.";
      }
    }else{
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are required.";
    }
    
    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  /* MODIFY PASSWORD */

  /* CHANGE PASSWORD */
  public function change_password(Request $req){
    if (isset($req->email) && isset($req->old_password) && isset($req->password) && isset($req->confirm_password)) {
      $old_password = DB::table('users_customers')->select('password')->where('email', $req->email)->get();
      $old_passwordDB = $old_password[0]->password;
      if ($old_passwordDB == md5($req->old_password)) {
        if ($req->confirm_password == $req->password) {
          $otpData=array('password' => md5($req->password));          
          $UserotpUpdate =DB::table('users_customers')->where('email', $req->email)->update($otpData);
          $users_customers = DB::table('users_customers')->where('email', $req->email)->get();
          
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $users_customers;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Password and confirm password do not match.";
        }
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Old password is not correct.";
      }
    }else{
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are required.";
    }
    
    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  /* CHANGE PASSWORD */

  /* DELETE ACCOUNT API */
  public function delete_account(Request $req){
    if (isset($req->user_email) && isset($req->delete_reason) && isset($req->comments)) {
      $users_customers = DB::table('users_customers')->where('email', $req->user_email)->get()->count();
      if ($users_customers>0) {
        $users_customers_delete = DB::table('users_customers_delete')->where('email', $req->user_email)->get()->count();
        if ($users_customers_delete == 0) { 
          $data = array(
            'email'=>$req->user_email,
            'delete_reason'=> $req->delete_reason,
            'comments'=> $req->comments,
            'date_added'=>date('Y-m-d H:i:s'),
            'status'=>'Pending'
          );
          $users_customers_id   = DB::table('users_customers_delete')->insertGetId($data);

          $response["code"] = 200;
          $response["status"] = "success";
          $response["message"] = "Delete account request recieved successfully.";
        }else{
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Delete account request already sent. Please wait out team will get back to you in 24 hours.";
        }
      }else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Email does not exists.";
      }
    }else{
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are required.";
    }
    
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* DELETE ACCOUNT API */
  /* GET ADMIN LIST   */

  public function get_admin_list(Request $req){
    $admin_list = DB::table('users_system')->where('status', 'Active')->get();
    if ($admin_list) {
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $admin_list;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "No active admin found.";
    }
    
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
}
/* GET ADMIN LIST */

/** CHAT HEADS ADMIN **/
public function getAllChatLive(Request $req){  
    if (isset($req->users_customers_id)){
      $final_chat_array = array();
      $chat_list = DB::table('chat_list_live')->where('sender_id', $req->users_customers_id)->get();

      foreach($chat_list as $key => $chat){
        $chat_array = array();
        $chat_array['sender_id'] = $chat->sender_id;
        $chat_array['receiver_id'] = $chat->receiver_id;

        $receiver_data = DB::table('users_system')->where('users_system_id',$chat->receiver_id)->get();
        $chat_array['first_name'] = $receiver_data[0]->first_name;
        $chat_array['user_image'] = $receiver_data[0]->user_image;
          
        $chat_message = DB::table('chat_messages_live')
          ->where([['sender_id', $req->appUserId],['receiver_id', $chat->receiver_id]])
          ->orWhere([['sender_id', $chat->receiver_id], ['receiver_id', $req->appUserId]])
          ->get()->last();
        if (!empty($chat_message)) {
          $date_request = Helper::get_day_difference($chat_message->send_date);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = $chat_message;
        } else {
          $date_request = Helper::get_day_difference($chat->date_request);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = 'No Message sent or recieved.';
        }

        $final_chat_array[] = $chat_array;
      }

      if (!empty($final_chat_array)) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $final_chat_array;
      } else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "No chat found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Enter All Fields.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
}
/** CHAT HEADS ADMIN **/

/** CHAT MESSAGES **/
public function user_chat_live(Request $req){
  if (isset($req->requestType)) {
    $request_type = $req->requestType;
    switch ($request_type) {
      case "startChat":
        if(isset($req->users_customers_id) && isset($req->other_users_customers_id)){
          $check_request = DB::table('chat_list_live')->where([ ['sender_id', $req->users_customers_id], ['receiver_id', $req->other_users_customers_id]])->orWhere([ ['sender_id', $req->other_users_customers_id], ['receiver_id', $req->users_customers_id]])->count();
          if($check_request > 0){
            $response["code"] = 200;
            $response["status"] = "success";
            $response["message"] = 'chat already started';    
          } else {
            $data_save = array(
                'sender_id'=> $req->users_customers_id,
                'receiver_id'=> $req->other_users_customers_id,
                'date_request'=> date('Y-m-d'),
                'created_at' => Carbon::now()
            );
            $requestSend = DB::table('chat_list_live')->insert($data_save);
            
            if($requestSend){
                $response["code"] = 200;
                $response["status"] = "success";
                $response["message"] = 'Chat Started!';
              } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = 'Error in starting chat';
              }
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = 'All fields are required';      
        }
      break;   
      
      case "sendMessage":
        if(isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->content) && isset($req->messageType) && isset($req->sender_type)){
          $message_details = array(
            'sender_type'=> $req->sender_type,
            'sender_id'=> $req->users_customers_id,
            'receiver_id'=> $req->other_users_customers_id,
            'message'=>  json_encode($req->content) ,
            'message_type'=> $req->messageType,
            'send_date'=> date('Y-m-d'),
            'send_time'=> date('H:i:s'),
            'created_at'=> date('Y-m-d H:i:s'),
            'status'=> 'Unread'
          );

          $insertedId = DB::table('chat_messages_live')->insertGetId($message_details);
          if($insertedId){

            //NEW MESSAGE Notifications
            $dataInsert=array(
              'senders_id'=>$req->users_customers_id,
              'receivers_id'=>$req->other_users_customers_id,
              'message'=> 'A new message has been recieved.',
              'date_added'=>date('Y-m-d H:i:s'),
              'date_modified'=>date('Y-m-d H:i:s'),
              'status'=>'Unread'
            );
            $this->send_notification($dataInsert);
            //NEW MESSAGE Notifications

            $messageDetails =  DB::table('chat_messages_live')->where('chat_messages_live_id', $insertedId)->first();
            $messageDetails->message = json_decode($messageDetails->message);
            if($messageDetails->message_type == 'attachment'){
              $messageDetails->message = config('base_urls.chat_attachments_base_url').$messageDetails->message;
            }

            $response["code"] = 200;
            $response["status"] = "success";
            $response["message"] = 'Message sent successfully.';  
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'Oops! Something went wrong.';  
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = 'All fields are required';  
        }
      break;
                                     
      case "getMessages":
        if(isset($req->users_customers_id) && isset($req->other_users_customers_id)){
          $chat_array =array();
          $day_array =array();
          $result = DB::table('chat_messages_live')->where([
            ['sender_id',$req->other_users_customers_id],    
            ['receiver_id', $req->users_customers_id]
          ])->update(array('status' => 'Read'));  
          
          $all_chat = DB::table('chat_messages_live')->where([
              ['sender_id',$req->users_customers_id],
              ['receiver_id',$req->other_users_customers_id],
          ])->orWhere([
              ['sender_id',$req->other_users_customers_id],
              ['receiver_id',$req->users_customers_id],
          ])->orderBy('chat_messages_live_id','ASC')->get();

          if(sizeof($all_chat) > 0){
            foreach($all_chat as $key => $chat){

              $get_data['sender_type'] = $chat->sender_type;

              $chat->message = json_decode($chat->message);
              $day = Helper::get_day_difference($chat->send_date);

              if (in_array($day, $day_array, TRUE)){
                $get_data['date']= '';
              } else {
                array_push($day_array, $day);
                $get_data['date']= $day;
              } 
              
              $get_data['time'] =  date('h:i A',strtotime($chat->send_time));
              $get_data['msgType'] = $chat->message_type;

              if($chat->message_type=='attachment'){
                $attachment = config('base_urls.chat_attachments_base_url') . $chat->message;
                $get_data['message'] = $attachment;
              } else {
                $get_data['message'] = $chat->message;
              }

              if($chat->sender_type == 'Admin'){
                $receiver_data = DB::table('users_system')->where('users_system_id',$req->other_users_customers_id)->get();
                $get_data['users_data'] = $receiver_data[0];
              } else {
                $sender_data = DB::table('users_customers')->where('users_customers_id',$req->users_customers_id)->get();
                $get_data['users_data'] = $sender_data[0];
              }
              array_push($chat_array, $get_data);
              
              if(!empty($chat_array)){
                $result =  DB::table('chat_messages_live')->where([
                  ['sender_id',$req->other_users_customers_id],
                  ['receiver_id',$req->users_customers_id]
                ])->update(array('status'=>'Read'));
              }
            }
            
            if($chat_array){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $chat_array; 
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = 'Error in chat array'; 
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'no chat history'; 
          }                       
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = 'All fields are needed'; 
        }
      break;

      case "updateMessages":
        if(isset($req->users_customers_id) && isset($req->other_users_customers_id)){
          $user_id = $req->users_customers_id;
          $other_user_id  = $req->other_users_customers_id;
          $chat_array =array();
          $all_chat =  DB::table('chat_messages_live')->where([
                ['sender_id', $other_user_id],
                ['receiver_id',$user_id],
                ['status','Unread']
          ])->orderBy('chat_messages_live_id', 'ASC')->get();
          
          if(sizeof($all_chat) > 0){
            foreach($all_chat as $chat){
              $get_data['chat_messages_live_id'] = $chat->chat_messages_live_id;
              $get_data['sender_type'] = $chat->sender_type;

              $chat->message = json_decode($chat->message);                
              $get_data['time'] =  date('h:i A',strtotime($chat->send_date));
              $get_data['msgType'] = $chat->message_type;
              if($chat->message_type =='attachment'){
                $image = config('base_urls.chat_attachments_base_url') . $chat->message;
                $get_data['message'] = $image;
              } else { 
                $get_data['message'] = $chat->message;
              } 

              if($chat->sender_type == 'Admin'){
                $receiver_data = DB::table('users_system')->where('users_system_id',$other_user_id)->get();
                $get_data['users_data'] = $receiver_data[0];
              } else {
                $sender_data = DB::table('appUsers')->where('appUserId',$other_user_id)->get();
                $get_data['users_data'] = $sender_data[0];
              }   

              if(!empty($chat_array)){
                $result =  DB::table('chat_messages_live')->where([
                  ['sender_id',$other_user_id],
                  ['receiver_id',$user_id]
                  ])->update(array('status'=>'Read'));
              }
              array_push($chat_array, $get_data);
                         
              $chat_length   =  DB::table('chat_messages_live')->where([
                ['sender_id', $user_id],
                ['receiver_id',$other_user_id]
                ])->orderBy('chat_messages_live_id','ASC')->count();

              if($chat_array){
                $finalDataset = array(
                    "chat_length" => $chat_length,
                    "unread_messages" => $chat_array,
                );

                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = $finalDataset; 
              } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "Un Updated Chat Not Found!"; 
              }
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "No New Message Found!"; 
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "All fields are required!"; 
        }
      break;    
    }
  } else {
    $response["code"] = 404;
    $response["status"] = "error";
    $response["message"] = "Request type not found"; 
  }

  return response()
   ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
   ->header('Content-Type', 'application/json');
}
/** CHAT MESSAGES **/
  /* GET SOCIAL LOGIN */
  public function system_settings(){
    $system_settings   =  DB::table('system_settings')->get();
    if (!empty($system_settings)) {
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $system_settings;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "no data found.";
    }
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET SOCIAL LOGIN */
  // GET RESERVATIONS
  public function reservations(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id) && isset($req->page_number)) {
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
      $offset         = ($req->page_number - 1) * $records_limit->description;
      $venues         =  DB::table('venues')->where('status', 'Active')->skip($offset)->take($records_limit->description)->get();

      if (!empty($venues[0])) {
        $all_venues = array();
        foreach($venues as $venue){
          //VENUE IMAGES 
          $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
          $venue->images = $venues_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $venue->cover_images = $venues_images[0]->name;
          //CoVER IMAGE
          // venues_keywords
          $venue_keywords = DB::table('venues_keywords')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
          $venue->venue_keywords = $venue_keywords;

        // Venue timing
        $venues_hours = DB::table('venues_hours')
        ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
        ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
        ->where('venues_hours.status', 'Active')
        ->where('venues_hours.venues_id', $venue->venues_id)     
        ->get();
        $venue->venue_timing = $venues_hours;
        // Venue timing

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
          $venue->likes = $users_likes;
          //MY LIKES
          
          //DISTANCE MEASURING
          $venue->distance = $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);
          //DISTANCE MEASURING

          $all_venues[] = $venue;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_venues;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  // GET RESERVATIONS

  /* GET VENUES */
//   public function venues(Request $req){
//     if(isset($req->users_customers_id) && isset($req->page_number) && isset($req->longitude) && isset($req->lattitude)) {
//         $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
//         $offset         = ($req->page_number - 1) * $records_limit->description;
//         $venues         = DB::table('venues')->where('status', 'Active')->skip($offset)->take($records_limit->description)->get();
//         $radiusResult = DB::table('system_settings')->select('description')->where('type', 'radius')->first();
//         if ($radiusResult) {
//             $radius = $radiusResult->description;
//         } else {
//             $radius = 10; 
//         }
//         if (!empty($venues[0])) {
//             $all_venues = array();
//             foreach($venues as $venue){
//                 // Calculate distance for each venue
//                 $venue_distance =  $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);  
              

//                 // Check if the venue is within radius 
//                 if ($venue_distance <= $radius) {     
//                     //VENUE IMAGES 
//                     $venues_images = DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
//                     $venue->images = $venues_images;
//                     //VENUE IMAGES

//                     //COVER IMAGE
//                     if (!empty($venues_images[0])) {
//                         $venue->cover_images = $venues_images[0]->name;
//                     } else {
//                         $venue->cover_images = 'default-image.jpg'; // Default or placeholder image
//                     }
//                     //COVER IMAGE

//                     //MY LIKES
//                     $users_likes = DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
//                     $venue->likes = $users_likes;
//                     //MY LIKES
                
//                     //DISTANCE MEASURING
//                   //  $venue->temp = $req->lattitude. ' ' .$req->longitude. ' ' .$venue->lattitude. ' '.$venue->longitude;
//                     $venue->distance =$venue_distance;
//                     //DISTANCE MEASURING

//                     $all_venues[] = $venue;
//                 }
//             }

//             if (count($all_venues) > 0) {
//                 $response["code"] = 200;
//                 $response["status"] = "success";
//                 $response["data"] = $all_venues;
//             } else {
//                 $response["code"] = 404;
//                 $response["status"] = "error";
//                 $response["message"] = "No Venue Available";
//             }
//         } else {
//             $response["code"] = 404;
//             $response["status"] = "error";
//             $response["message"] = "no data found.";
//         }
//     } else {
//         $response["code"] = 404;
//         $response["status"] = "error";
//         $response["message"] = "All fields are needed.";
//     }

//     return response()
//         ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
//         ->header('Content-Type', 'application/json');
// }
public function venues(Request $req){
  // Check if all required fields are present
  if(isset($req->users_customers_id) && isset($req->page_number) && isset($req->longitude) && isset($req->lattitude)) {
      // Get settings
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first()->description ?? 20;
      $radiusResult = DB::table('system_settings')->select('description')->where('type', 'radius')->first();
      $radius = $radiusResult ? $radiusResult->description : 10;

      // Fetch all active venues
      $allVenues = DB::table('venues')->where('status', 'Active')->get();

      // Filter venues within the radius
      $filteredVenues = collect($allVenues)->filter(function ($venue) use ($req, $radius) {
          $venue_distance = $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);
          return $venue_distance <= $radius;
      });

      // Manually apply pagination
      $offset = ($req->page_number - 1) * $records_limit;
      $paginatedVenues = $filteredVenues->slice($offset, $records_limit);

      // Further process each venue (e.g., fetching images, likes, etc.)
      $processedVenues = [];
      foreach ($paginatedVenues as $venue) {  
        // Calculate distance for each venue
        $venue_distance = $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);  
    
        // Fetch venue images
        $venues_images = DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
        $venue->images = $venues_images;
        // venues_keywords
        $venue_keywords = DB::table('venues_keywords')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
        $venue->venue_keywords = $venue_keywords;

        // Venue timing
        $venues_hours = DB::table('venues_hours')
        ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
        ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
        ->where('venues_hours.status', 'Active')
        ->where('venues_hours.venues_id', $venue->venues_id)     
        ->get();
        $venue->venue_timing = $venues_hours;
        // Venue timing
    
        // Set cover image - use the first image if available, else a default image
        $venue->cover_image = !empty($venues_images[0]) ? $venues_images[0]->name : 'default-image.jpg';
    
        // Count likes for the venue
        $users_likes = DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->count();
        $venue->likes = $users_likes;
    
        // Set the calculated distance
        $venue->distance = $venue_distance;
    
        // Add the processed venue to the array
        $processedVenues[] = $venue;     
    }

      // Prepare response
      if (count($processedVenues) > 0) {
          $response = [
              "code" => 200,
              "status" => "success",
              "data" => $processedVenues
          ];
      } else {
          $response = [
              "code" => 404,
              "status" => "error",
              "message" => "No Venue Available"
          ];
      }
  } else {
      $response = [
          "code" => 404,
          "status" => "error",
          "message" => "All fields are needed."
      ];
  }

  return response()->json($response)->header('Content-Type', 'application/json');
}
// public function venues(Request $req){
//   // Check if all required fields are present
//   if(isset($req->users_customers_id) && isset($req->page_number) && isset($req->longitude) && isset($req->latitude)) {
//       // Get settings
//       $records_limit = DB::table('system_settings')->where('type', 'records_limit')->value('description') ?? 20;
//       $radius = DB::table('system_settings')->where('type', 'radius')->value('description') ?? 10;

//       // Fetch all active venues
//       $allVenues = DB::table('venues')->where('status', 'Active')->get();

//       // Filter venues within the radius
//       $filteredVenues = $allVenues->filter(function ($venue) use ($req, $radius) {
//           $venue_distance = $this->calculate_distance($req->latitude, $req->longitude, $venue->latitude, $venue->longitude);
//           return $venue_distance <= $radius;
//       });

//       // Manually apply pagination
//       $offset = ($req->page_number - 1) * $records_limit;
//       $paginatedVenues = $filteredVenues->slice($offset, $records_limit);

//       // Process each venue
//       $processedVenues = $paginatedVenues->map(function ($venue) use ($req) {
//           // Calculate distance for each venue
//           $venue->distance = $this->calculate_distance($req->latitude, $req->longitude, $venue->latitude, $venue->longitude);
      
//           // Fetch venue images
//           $venue->images = DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
          
//           // Fetch venue timing
//           $venue->venue_timing = DB::table('venues_hours')
//               ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
//               ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
//               ->where('venues_hours.status', 'Active')
//               ->where('venues_hours.venues_id', $venue->venues_id)     
//               ->get();
          
//           // Set cover image - use the first image if available, else a default image
//           $venue->cover_image = $venue->images->isNotEmpty() ? $venue->images->first()->name : 'default-image.jpg';
          
//           // Count likes for the venue
//           $venue->likes = DB::table('users_likes')->where('post_id', $venue->venues_id)
//               ->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->count();
          
//           return $venue;
//       });

//       // Prepare response
//       $response = $processedVenues->isNotEmpty() ? 
//           ["code" => 200, "status" => "success", "data" => $processedVenues] :
//           ["code" => 404, "status" => "error", "message" => "No Venue Available"];

//   } else {
//       $response = ["code" => 404, "status" => "error", "message" => "All fields are needed."];
//   }

//   return response()->json($response)->header('Content-Type', 'application/json');
// }


  /* GET VENUES */

  /* GET VENUES SUGGESTED */
  public function venues_suggested(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->venues_id) && isset($req->users_customers_id)) {
      $venue_data = DB::table('venues')->where('venues_id', $req->venues_id)->get()->first();
      $venues     = DB::table('venues')->where('status', 'Active')->where('venues_id', '!=',$req->venues_id)->where('longitude', $venue_data->longitude)->where('lattitude', $venue_data->lattitude)->get();

      if (!empty($venues[0])) {
        $all_venues = array();
        foreach($venues as $venue){
          //VENUE IMAGES
          $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
          $venue->images = $venues_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $venue->cover_images = $venues_images[0]->name;
          //CoVER IMAGE

                  // Venue timing
            $venues_hours = DB::table('venues_hours')
            ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
            ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
            ->where('venues_hours.status', 'Active')
            ->where('venues_hours.venues_id', $venue->venues_id)     
            ->get();
            $venue->venue_timing = $venues_hours;
        // Venue timing

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
          $venue->likes = $users_likes;
          //MY LIKES
          
          //DISTANCE MEASURING
          $venue->distance = $this->calculate_distance($req->longitude, $req->lattitude, $venue->longitude, $venue->lattitude);
          //DISTANCE MEASURING

          $all_venues[] = $venue;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_venues;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET VENUES SUGGESTED */

  /* GET SAVED VENUES */
  public function venues_saved(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id)) {
      $venues   =  DB::table('venues')->where('status', 'Active')->get();
      if (!empty($venues[0])) {
        $all_venues = array();
        foreach($venues as $venue){
          $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
          if($users_likes > 0){
            //MY LIKES
            $venue->likes = $users_likes;
            //MY LIKES

            //VENUE IMAGES
            $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
            $venue->images = $venues_images;
            //VENUE IMAGES
            // Venue timing
                $venues_hours = DB::table('venues_hours')
                ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
                ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
                ->where('venues_hours.status', 'Active')
                ->where('venues_hours.venues_id', $venue->venues_id)     
                ->get();
                $venue->venue_timing = $venues_hours;
            // Venue timing

            //CoVER IMAGE
            $venue->cover_images = $venues_images[0]->name;
            //CoVER IMAGE

            //DISTANCE MEASURING
            $venue->distance = $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);
            // $venue->distance = $this->calculate_distance($req->longitude, $req->lattitude, $venue->longitude, $venue->lattitude);
            //DISTANCE MEASURING

            $all_venues[] = $venue;
          }
        }

        if(!empty($all_venues)){
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $all_venues;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "no data found.";
        }
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET SAVED VENUES */

  /* LIKE UNLIKE VENUES */
  public function venues_like_unlike(Request $req){
    if(isset($req->users_customers_id) && isset($req->venues_id)) {
      $users_likes   =  DB::table('users_likes')->where('post_id', $req->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
      if($users_likes > 0){
        DB::table('users_likes')->where('post_id', $req->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->delete();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Unliked';
      } else {
        DB::table('users_likes')->insertGetId(array('users_customers_id'=>$req->users_customers_id, 'post_id'=> $req->venues_id, 'type'=>'Venues'));
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Liked';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* LIKE UNLIKE VENUES */

  /* GET EVENTS */
  public function events(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id) && isset($req->page_number)) {
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
      $offset         = ($req->page_number - 1) * $records_limit->description;
      $events         = DB::table('events')->where('status', 'Active')->where('event_date', '>=', date('Y-m-d'))->skip($offset)->take($records_limit->description)->get();
      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          //VENUE IMAGES
          $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
          $event->images = $events_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $event->cover_images = $events_images[0]->name;
          //CoVER IMAGE

          $event_keywords = DB::table('events_keywords')->where('events_id',$event->events_id)->where('status', 'Active')->get();
          $event->event_keywords = $event_keywords;

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $event->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          $event->likes = $users_likes;
          //MY LIKES

          //DISTANCE MEASURING
          $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
          //DISTANCE MEASURING

          $all_events[] = $event;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_events;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS */

  /* GET EVENTS SAVED*/
  public function events_saved(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id)) {
      $events   =  DB::table('events')->where('status', 'Active')->where('event_date', '>=', date('Y-m-d'))->get();
      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          $users_likes   =  DB::table('users_likes')->where('post_id', $event->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          if($users_likes > 0){
            //MY LIKES
            $event->likes = $users_likes;
            //MY LIKES

            //VENUE IMAGES
            $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
            $event->images = $events_images;
            //VENUE IMAGES

            //CoVER IMAGE
            $event->cover_images = $events_images[0]->name;
            //CoVER IMAGE

            //DISTANCE MEASURING
            $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
            //DISTANCE MEASURING

            $all_events[] = $event;
          }
        }

        if(!empty($all_events)){
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $all_events;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "no data found.";
        }
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS SAVED*/

  /* LIKE UNLIKE EVENTS */
  public function events_like_unlike(Request $req){
    if(isset($req->users_customers_id) && isset($req->events_id)) {
      $users_likes   =  DB::table('users_likes')->where('post_id', $req->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
      if($users_likes > 0){
        DB::table('users_likes')->where('post_id', $req->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->delete();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Unliked';
      } else {
        DB::table('users_likes')->insertGetId(array('users_customers_id'=>$req->users_customers_id, 'post_id'=> $req->events_id, 'type'=>'Events'));
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Liked';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* LIKE UNLIKE EVENTS */

  /* VENUE AVAILABILITY */
  public function venue_availability_update(Request $req){
    if(isset($req->venues_id) && isset($req->status) && isset($req->users_customers_id)) {
      $VenueData      = array('availability' => $req->status);
      $UserotpUpdate  = DB::table('venues')->where('venues_id', $req->venues_id)->update($VenueData);
      
      $response["code"] = 200;
      $response["status"] = "success";
      $response["message"] = 'Venue status changed to ' . $req->status;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* VENUE AVAILABILITY */

  /* GET Notifications */
  public function notifications(Request $req){
    if(isset($req->users_customers_id)) {
      //$notifications   =  DB::table('notifications')->where('receivers_id', $req->users_customers_id)->get();
      $notifications   =  DB::table('notifications')->where('receivers_id', $req->users_customers_id)->where('users_type' , 'Users')->get();
      $users_system   =  DB::table('users_system')->where('status', 'Active')->get();

      // return $notifications;
      // return  $users_system ; 
      if (count($notifications)>0) {
        $all_notifications = array(); 
        foreach($notifications as $notification){
          if($notification->venues_id){

            //VENUE IMAGES
            $venues_images   =  DB::table('venues_images')->where('venues_id', $notification->venues_id)->where('status', 'Active')->get();
            $notification->images = $venues_images;
            //VENUE IMAGES
            
            //CoVER IMAGE
            $notification->cover_images = $venues_images[0]->name;
            //CoVER IMAGE
          }
          if($notification->events_id){

            //VENUE IMAGES
            $events_images   =  DB::table('events_images')->where('events_id', $notification->events_id)->where('status', 'Active')->get();
            $notification->images = $events_images;
            //VENUE IMAGES
            
            //CoVER IMAGE
            $notification->cover_images = $events_images[0]->name;
            //CoVER IMAGE
          }
          if(!$notification->venues_id && !$notification->events_id){
               $admin_image = $users_system[0]->user_image;
               $notification->admin_images = $admin_image; 
 
          }

          // //MY LIKES
          // $users_likes   =  DB::table('users_likes')->where('post_id', $notification->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
          // $notification->likes = $users_likes;
          // //MY LIKES

          $all_notifications[] = $notification;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_notifications;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET Notifications */

  /* GET VENUES BY ID */
  public function venues_by_id(Request $req){
    if(isset($req->venues_id)) {
      $venues         =  DB::table('venues')->where('venues_id', $req->venues_id)->get();

      if (!empty($venues[0])) {
        $all_venues = array();
        foreach($venues as $venue){
          //VENUE IMAGES
          $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
          $venue->images = $venues_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $venue->cover_images = $venues_images[0]->name;
          //CoVER IMAGE

            // Venue timing
            $venues_hours = DB::table('venues_hours')
            ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
            ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
            ->where('venues_hours.status', 'Active')
            ->where('venues_hours.venues_id', $venue->venues_id)     
            ->get();
            $venue->venue_timing = $venues_hours;
            // Venue timing

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
          $venue->likes = $users_likes;
          //MY LIKES
          
          //DISTANCE MEASURING
          $venue->distance = $this->calculate_distance($req->longitude, $req->lattitude, $venue->longitude, $venue->lattitude);
          //DISTANCE MEASURING

          $all_venues[] = $venue;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_venues;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET VENUES BY ID */

  /* CLAIM DISCOUNT */
  public function claim_discount(Request $req){
    if (isset($req->users_customers_id) && isset($req->venues_id)) {
      // Check if the user has claimed within the last 24 hours
      $lastClaimTime = DB::table('venues_claimed')
          ->where('users_customers_id', $req->users_customers_id)
          ->where('venues_id', $req->venues_id)
          ->value('claimed_date');
  
      if ($lastClaimTime) {
          $lastClaimTime = strtotime($lastClaimTime);
          $currentTime = time();
          $timeDiff = $currentTime - $lastClaimTime;
  
          // Check if 24 hours have passed since the last claim
          if ($timeDiff < 86400) { // 86400 seconds in 24 hours
              $response["code"] = 200;
              $response["status"] = "error";
              $response["message"] = 'You can only claim once every 24 hours.';
              return response()
                  ->json([
                      'status' => $response["status"],
                      'message' => $response["message"]
                  ])
                  ->header('Content-Type', 'application/json');
          }
      }
  
      // Generate a random number of length 8
      do {
          $randomNumber = mt_rand(10000000, 99999999);
  
          // Check if the random number already exists in 'venues_claimed' table
          $exists = DB::table('venues_claimed')
              ->where('claimed_token', $randomNumber)
              ->exists();
  
      } while ($exists);
  
      // Save data to 'venues_claimed' table
      $insertedId = DB::table('venues_claimed')
          ->insertGetId([
              'users_customers_id' => $req->users_customers_id,
              'venues_id' => $req->venues_id,
              'claimed_token' => $randomNumber,  
              'claimed_date' => now() 
          ]);
          $data = DB::table('venues_claimed') ->where('venues_claimed_id', $insertedId)->get();
  
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $data;
  } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
  }
  
  return response()
      ->json([
          'status' => $response["status"],
          isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]
      ])
      ->header('Content-Type', 'application/json');
}      
  
  /* CLAIM DISCOUNT */
  // Get Claimed discounts
  public function get_claimed_venues(Request $req){
    if(isset($req->users_customers_id)) {
      $venues_claimed   =  DB::table('venues_claimed')->where('users_customers_id', $req->users_customers_id)->get();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $venues_claimed;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  // Get Claimed discounts

  /* VENUE VISITORS */
  public function update_visitors(Request $req){
    if(isset($req->users_customers_id) && isset($req->venues_id)) {
      $venues_claimed   =  DB::table('venues_visits')->where('users_customers_id', $req->users_customers_id)->where('venues_id', $req->venues_id)->get()->count();
      if($venues_claimed == 0){
        DB::table('venues_visits')->insertGetId(array('users_customers_id'=>$req->users_customers_id, 'venues_id'=> $req->venues_id));
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Visited';
      } else { 
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Visited';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* VENUE VISITORS */

  /* GET VENUE VISITORS */
  public function get_visitors_list(Request $req){
    if(isset($req->venues_id)) {
      $venues_claimed   =  DB::table('venues_visits')->where('venues_id', $req->venues_id)->get()->count();
      if($venues_claimed > 0){
        $venues_users   =  DB::table('venues_visits')
                           ->select('users_customers.*')
                           ->join('users_customers', 'users_customers.users_customers_id', '=', 'venues_visits.users_customers_id')
                           ->where('venues_visits.venues_id', $req->venues_id)->get();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $venues_users;
      } else { 
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'No Visiter';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET VENUE VISITORS */

  /* EVENTS VISITORS */
  public function update_visitors_events(Request $req){
    if(isset($req->users_customers_id) && isset($req->events_id)) {
      $events_claimed   =  DB::table('events_visits')->where('users_customers_id', $req->users_customers_id)->where('events_id', $req->events_id)->get()->count();
      if($events_claimed == 0){
        DB::table('events_visits')->insertGetId(array('users_customers_id'=>$req->users_customers_id, 'events_id'=> $req->events_id));
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Visited';
      } else { 
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Visited';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* EVENTS VISITORS */

  /* GET EVENTS VISITORS */
  public function get_visitors_events_list(Request $req){
    if(isset($req->events_id)) {
      $events_claimed   =  DB::table('events_visits')->where('events_id', $req->events_id)->get()->count();
      if($events_claimed > 0){
        $events_users   =  DB::table('events_visits')
                           ->select('users_customers.*')
                           ->join('users_customers', 'users_customers.users_customers_id', '=', 'events_visits.users_customers_id')
                           ->where('events_visits.events_id', $req->events_id)->get();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $events_users;
      } else { 
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'No Visiter';
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS VISITORS */
  
  /***************************************************** V2 FEATURES ******************************************************************/
  
  /*** CHAT HEADS ***/
  public function getAllChat(Request $req){  
    if (isset($req->users_customers_id) && isset($req->venues_id)){
      $final_chat_array = array();
      $chat_list = DB::table('chat_list')->where('sender_id', $req->users_customers_id)->where('venues_id', $req->venues_id)->get();

      foreach($chat_list as $key => $chat){
        $chat_array = array();
        $chat_array['sender_id'] = $chat->sender_id;
        $chat_array['receiver_id'] = $chat->receiver_id;

        $receiver_data = DB::table('users_business')->where('users_business_id',$chat->receiver_id)->get();
        $chat_array['company_name'] = $receiver_data[0]->first_name;
        $chat_array['company_logo'] = $receiver_data[0]->user_image;
          
        $chat_message = DB::table('chat_messages')->where('sender_id', $req->users_customers_id)->where('sender_id', $req->users_customers_id)->get();
        if (!empty($chat_message[0])) {
          $date_request = Helper::get_day_difference($chat_message[0]->send_date);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = $chat_message[0]->message;
        } else {
          $date_request = Helper::get_day_difference($chat->date_request);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = 'No Message sent or recieved.';
        }

        $final_chat_array[] = $chat_array;
      }

      if (!empty($final_chat_array)) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $final_chat_array;
      } else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "chat unavailable.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Enter All Fields.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
  /*** CHAT HEADS ***/

  /*** CHAT MESSAGES ***/
  public function user_chat(Request $req){
    if (isset($req->requestType)) {
      $request_type = $req->requestType;
      switch ($request_type) {
        case "startChat":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->venues_id)){
            $check_request = DB::table('chat_list')->where([ ['sender_id', $req->users_customers_id], ['receiver_id', $req->other_users_customers_id], ['venues_id', $req->venues_id]])->orWhere([ ['sender_id', $req->other_users_customers_id], ['receiver_id', $req->users_customers_id], ['venues_id', $req->venues_id]])->count();
            if($check_request > 0){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["message"] = 'chat already started';    
            } else {
              $data_save = array(
                  'sender_id'=> $req->users_customers_id,
                  'receiver_id'=> $req->other_users_customers_id,
                  'venues_id'=> $req->venues_id,
                  'date_request'=> date('Y-m-d'),
                  'created_at' => Carbon::now()
              );
              $requestSend = DB::table('chat_list')->insert($data_save);
              
              if($requestSend){
                  $response["code"] = 200;
                  $response["status"] = "success";
                  $response["message"] = 'chat started';
                } else {
                  $response["code"] = 404;
                  $response["status"] = "error";
                  $response["message"] = 'Error in starting chat';
                }
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are required';      
          }
        break;   
        
        case "sendMessage":
          if(isset($req->venues_id) && isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->content) && isset($req->messageType)){
            $message_details = array(
              'venues_id'=> $req->venues_id,
              'sender_id'=> $req->users_customers_id,
              'receiver_id'=> $req->other_users_customers_id,
              'sender_type'=> $req->sender_type,
              'message'=>  json_encode($req->content) ,
              'message_type'=> $req->messageType,
              'send_date'=> date('Y-m-d'),
              'send_time'=> date('H:i:s'),
              'created_at'=> date('Y-m-d H:i:s'),
              'status'=> 'Unread'
            );

            $insertedId = DB::table('chat_messages')->insertGetId($message_details);
           
            if($insertedId){
              //NEW MESSAGE Notifications
              $dataInsert=array(
                'venues_id'=>$req->venues_id,
                'senders_id'=>$req->users_customers_id,
                'receivers_id'=>$req->other_users_customers_id,
                'message'=> 'A new message has been recieved.',
                'date_added'=>date('Y-m-d H:i:s'),
                'date_modified'=>date('Y-m-d H:i:s')
              );
              $this->send_notification($dataInsert);
              //NEW MESSAGE Notifications

              $messageDetails =  DB::table('chat_messages')->where('chat_message_id', $insertedId)->first();
              $messageDetails->message = json_decode($messageDetails->message);
              if($messageDetails->message_type == 'attachment'){
                $messageDetails->message = config('base_urls.chat_attachments_base_url').$messageDetails->message;
              }

              $response["code"] = 200;
              $response["status"] = "success";
              $response["message"] = "Message Sent Successfully";     
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = 'Oops! Something went wrong.';  
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are required';  
          }
        break;
                                       
        case "getMessages":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->venues_id)){
            $chat_array =array();
            $day_array =array();
            $result = DB::table('chat_messages')->where([['sender_id',$req->other_users_customers_id], ['receiver_id', $req->users_customers_id], ['venues_id', $req->venues_id]])->update(array('status' => 'Read'));  
            
            $all_chat = DB::table('chat_messages')->where([['sender_id',$req->users_customers_id],['receiver_id',$req->other_users_customers_id], ['venues_id', $req->venues_id]])->orWhere([['sender_id',$req->other_users_customers_id], ['receiver_id',$req->users_customers_id], ['venues_id', $req->venues_id]])->orderBy('chat_message_id','ASC')->get();

            if(sizeof($all_chat) > 0){
              foreach($all_chat as $key => $chat){
                $get_data['sender_type'] = $chat->sender_type;

                $chat->message = json_decode($chat->message);
                $day = Helper::get_day_difference($chat->send_date);

                if (in_array($day, $day_array, TRUE)){
                  $get_data['date']= '';
                } else {
                  array_push($day_array, $day);
                  $get_data['date']= $day;
                } 
                
                $get_data['time'] =  date('h:i A',strtotime($chat->send_time));
                $get_data['msgType'] = $chat->message_type;

                if($chat->message_type=='attachment'){
                  $attachment = config('base_urls.chat_attachments_base_url') . $chat->message;
                  $get_data['message'] = $attachment;
                } else {
                  $get_data['message'] = $chat->message;
                }

                if($chat->sender_type == 'Companies'){
                  $receiver_data = DB::table('users_business')->where('users_business_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $receiver_data[0];
                } else {
                  $sender_data = DB::table('users_customers')->where('users_customers_id',$req->users_customers_id)->get();
                  $get_data['users_data'] = $sender_data[0];
                }
                array_push($chat_array, $get_data);
                
                if(!empty($chat_array)){
                  $result =  DB::table('chat_messages')->where([
                    ['sender_id',$req->other_users_customers_id],
                    ['receiver_id',$req->users_customers_id]
                  ])->update(array('status'=>'Read'));

                  $result =  DB::table('chat_messages')->where([
                    ['receiver_id',$req->other_users_customers_id],
                    ['sender_id',$req->users_customers_id]
                  ])->update(array('status'=>'Read'));
                }
              }

              if($chat_array){
                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = $chat_array; 
              } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = 'Error in chat array'; 
              }
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = 'no chat history'; 
            }                       
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are needed'; 
          }
        break;

        case "updateMessages":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id)){
            $user_id = $req->users_customers_id;
            $other_user_id  = $req->other_users_customers_id;
            $chat_array =array();
  
            $all_chat =  DB::table('chat_messages')
              ->where([['sender_id', $other_user_id], ['receiver_id',$user_id],['status','Unread']])
              ->orderBy('chat_message_id', 'ASC')->get();
            
            if(sizeof($all_chat) > 0){
              foreach($all_chat as $chat){
                $get_data['chat_message_id'] = $chat->chat_message_id;
                $get_data['sender_type'] = $chat->sender_type;

                $chat->message = json_decode($chat->message);                
                $get_data['time'] =  date('h:i A',strtotime($chat->send_date));
                $get_data['msgType'] = $chat->message_type;
                if($chat->message_type =='attachment'){
                  $image = config('base_urls.chat_attachments_base_url') . $chat->message;
                  $get_data['message'] = $image;
                } else { 
                  $get_data['message'] = $chat->message;
                } 

                if($chat->sender_type == 'Companies'){
                  $receiver_data = DB::table('users_business')->where('users_business_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $receiver_data[0];
                } else {
                  $sender_data = DB::table('users_customers')->where('users_customers_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $sender_data[0];
                }
                array_push($chat_array, $get_data);
              }
               
              if(!empty($chat_array)){
                $result =  DB::table('chat_messages')->where([
                  ['sender_id',$other_user_id],
                  ['receiver_id',$user_id]
                  ])->update(array('status'=>'Read'));
              }
                         
              $chat_length   =  DB::table('chat_messages')->where([
                ['sender_id', $user_id],
                ['receiver_id',$other_user_id]
                ])->orWhere([
                    ['sender_id', $other_user_id],
                ['receiver_id',$user_id]
              ])->orderBy('chat_messages_id','ASC')->count();
            
              $finalDataset = array(
                  "chat_length" => $chat_length,
                  "unread_messages" => $chat_array,
              );

              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $finalDataset; 
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "no chat found"; 
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed"; 
          }
        break;    
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Request type not Found"; 
    }

    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  /*** CHAT MESSAGES ***/

  /*** NEW BOOKINGS ***/
  public function bookings_add(Request $req){
    if (isset($req->venues_id) && isset($req->users_customers_id) && isset($req->no_of_diners) && isset($req->bookings_date) && isset($req->bookings_time)  && isset($req->claim_discounts)) {
      $data = array(
        'venues_id'=>$req->venues_id,
        'users_customers_id'=>$req->users_customers_id,
        'no_of_diners'=>$req->no_of_diners,
        'discount_token' => ($req->claim_discounts == 'claimed') ? $req->discount_token : null,
        'bookings_date'=>$req->bookings_date,
        'bookings_time'=>$req->bookings_time,
        'date_added'=>date('Y-m-d H:i:s'),
        'status'=>'Pending'
      );
      
        
      $bookings_id  = DB::table('venues_bookings')->insertGetId($data);
      if($req->claim_discounts == 'claimed'){
        $discountUpdate  = DB::table('venues_bookings')->where('venues_bookings_id',$bookings_id)->update(["claim_discounts" => "Claimed"]);
      }
      $get_data         = DB::table('venues_bookings')->where('venues_bookings_id', $bookings_id)->first(); 
      
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $get_data;
    } else {
     $response["code"] = 404;
     $response["status"] = "error";
     $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* NEW BOOKINGS */
  
  /*** EDIT BOOKINGS ***/
  public function bookings_edit(Request $req){
    if (isset($req->venues_bookings_id) && isset($req->no_of_diners) && isset($req->bookings_date) && isset($req->bookings_time)) {
      $updateData = array(
        'no_of_diners'=>$req->no_of_diners,
        'bookings_date'=>$req->bookings_date,
        'bookings_time'=>$req->bookings_time,
        'date_added'=>date('Y-m-d H:i:s'),
        'status'=>'Pending'
      );
      
      DB::table('venues_bookings')->where('venues_bookings_id', $req->venues_bookings_id)->update($updateData);
      $data         = DB::table('venues_bookings')->where('venues_bookings_id', $req->venues_bookings_id)->first();

      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $data;
    } else {
     $response["code"] = 404;
     $response["status"] = "error";
     $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* EDIT BOOKINGS */
  
  /* CANCEL A BOOKING */
  public function bookings_cancel(Request $req){
    if (isset($req->users_customers_id) && isset($req->venues_bookings_id) && isset($req->status)){
      $data=array('status' => $req->status);
      $bookings = DB::table('venues_bookings')->where('venues_bookings_id',$req->venues_bookings_id)->where('users_customers_id', $req->users_customers_id)->update($data);
      if (!empty($bookings)){
        $bookings_data = DB::table('venues_bookings')->where('venues_bookings_id', $req->venues_bookings_id)->get();
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $bookings_data;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "booking not updated or its its already in cancelled status";
      }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Enter All Fields.";
    }
    
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* CANCEL A BOOKING */
  
  /* GET PREVIOUS BOOKINGS */
  public function bookings_previous(Request $req){
    if (isset($req->users_customers_id)){
      $users_customers_id = $req->users_customers_id;
      $bookings = DB::table('venues_bookings')->where('users_customers_id', $users_customers_id)
        ->where('bookings_date', '<', date('Y-m-d'))
        //->where(['status'=> 'Pending', 'status' => 'Accepted'])
        ->get();
        
      $final_list = [];
      foreach($bookings as $data){
        $venues_details   = DB::table('venues')->where('venues_id', $data->venues_id)->get()->first();
        $data->venues_details = $venues_details;
        
        //VENUE IMAGES
        $venues_images   =  DB::table('venues_images')->where('venues_id', $data->venues_id)->where('status', 'Active')->get();
        $data->venues_details->images = $venues_images;
        //VENUE IMAGES

        //CoVER IMAGE
        $data->venues_details->cover_images = $venues_images[0]->name;
        //CoVER IMAGE

        //MY LIKES
        $users_likes   =  DB::table('users_likes')->where('post_id', $data->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
        $data->venues_details->likes = $users_likes;
        //MY LIKES
          
        $final_list[] = $data;
      }

      if (!empty($final_list)){
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $final_list;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "booking unavailable.";
      }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Enter All Fields.";
    }
    
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET PREVIOUS BOOKINGS */
  
  /* GET UPCOMING BOOKINGS */
  public function bookings_upcoming(Request $req){
    if (isset($req->users_customers_id)){
      $users_customers_id = $req->users_customers_id;
      $bookings = DB::table('venues_bookings')->where('users_customers_id', $users_customers_id)
        ->where('bookings_date', '>=', date('Y-m-d'))
        //->where(['status'=> 'Pending', 'status' => 'Accepted'])
        ->get();
      
      $final_list = [];
      foreach($bookings as $data){
        $venues_details   = DB::table('venues')->where('venues_id', $data->venues_id)->get()->first();
        $data->venues_details = $venues_details;
        
        //VENUE IMAGES
        $venues_images   =  DB::table('venues_images')->where('venues_id', $data->venues_id)->where('status', 'Active')->get();
        $data->venues_details->images = $venues_images;
        //VENUE IMAGES

        //CoVER IMAGE
        $data->venues_details->cover_images = $venues_images[0]->name;
        //CoVER IMAGE

        //MY LIKES
        $users_likes   =  DB::table('users_likes')->where('post_id', $data->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
        $data->venues_details->likes = $users_likes;
        //MY LIKES
          
        $final_list[] = $data;
      }

      if (!empty($final_list)){
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $final_list;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "booking unavailable.";
      }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Enter All Fields.";
    }
    
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET UPCOMING BOOKINGS */
  
  /***************************************************** V2 FEATURES ******************************************************************/

  /***************************************************** V3 FEATURES ******************************************************************/

  /* GET EVENTS BY NAME */
  public function events_search(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id) && isset($req->page_number)) {
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
      $offset         = ($req->page_number - 1) * $records_limit->description;

      $events_where['status']        = 'Active';
      if(isset($req->location)){
        $events_where['location']    = $req->location;
      }

      if(isset($req->event_date)){
        $events_where['event_date']        = $req->event_date;
      }

      //DB::enableQueryLog();
      $events         = DB::table('events')->where($events_where)->skip($offset)->take($records_limit->description)->get();
      //dd(DB::getQueryLog());
      //exit;

      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          //VENUE IMAGES
          $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
          $event->images = $events_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $event->cover_images = $events_images[0]->name;
          //CoVER IMAGE

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $event->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          $event->likes = $users_likes;
          //MY LIKES

          //DISTANCE MEASURING
          $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
          //DISTANCE MEASURING

          $all_events[] = $event;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_events;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS BY NAME */

  /* CLAIM DISCOUNT */
  public function events_claim_discount(Request $req){
    if(isset($req->users_customers_id) && isset($req->events_id)) {
      $events_claimed   =  DB::table('events_claimed')->where('users_customers_id', $req->users_customers_id)->where('events_id', $req->events_id)->get()->count();
      
        DB::table('events_claimed')->insertGetId(array('users_customers_id'=>$req->users_customers_id, 'events_id'=> $req->events_id ));
        // $discount_claimed   =  DB::table('event_bookings')->where('users_customers_id', $req->users_customers_id)->where('events_id', $req->events_id)->get()->count();
        //  if($discount_claimed > 0){
          
        //  $discountUpdate  = DB::table('events_claimed')->where('users_customers_id', $req->users_customers_id)->update(["status" => "Approved"]);
        //   }
         
        $response["code"] = 200;
        $response["status"] = "success";
        $response["message"] = 'Claimed';
      
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* CLAIM DISCOUNT */

  /* GET BUSIENSS */
  public function get_business_list(Request $req){
    $users_business         =  DB::table('users_business')->where('status', 'Active')->get();

    if (!empty($users_business[0])) {
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $users_business;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "no data found.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET BUSIENSS */

  /* GET EVENTS BY BUSINESS ID */
  public function get_business_events(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id) && isset($req->users_business_id) && isset($req->page_number)) {
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
      $offset         = ($req->page_number - 1) * $records_limit->description;
      $events         = DB::table('events')->where('status', 'Active')->where('users_business_id', '=', $req->users_business_id)->skip($offset)->take($records_limit->description)->get();
      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          //VENUE IMAGES
          $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
          $event->images = $events_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $event->cover_images = $events_images[0]->name;
          //CoVER IMAGE

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $event->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          $event->likes = $users_likes;
          //MY LIKES

          //DISTANCE MEASURING
          $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
          //DISTANCE MEASURING

          $all_events[] = $event;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_events;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS BY BUSINESS ID */

  /* GET USERS TRANSACTIONS */
  public function get_transaction_list(Request $req){
    if(isset($req->users_customers_id)){
      $users_txns         =  DB::table('events_tickets')->where('users_customers_id', $req->users_customers_id)->get();

      if (!empty($users_txns[0])) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $users_txns;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else{ 
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are required.";
    }
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET USERS TRANSACTIONS */

  /* GET USERS TRANSACTIONS UPCOMING */
  public function get_upcoming_events_list(Request $req){
    if(isset($req->users_customers_id)  && isset($req->lattitude) && isset($req->longitude)){
      $fetch_data = DB::table('event_bookings')
      ->where('user_id', $req->users_customers_id)
      ->get();

    $get_data=[];
      foreach ($fetch_data as $key => $data) {
        $events=DB::table('events')->where('events_id', $data->events_id)->first();
        $data->events=$events;
        $ticket = DB::table('tickets')->where(['event_booking_id'=> $data->event_booking_id,'status'=>"Unscanned"])->get(); 
        $data->ticket=$ticket;
        $requested_tickets=DB::table('refund_requests')->where('event_booking_id', $data->event_booking_id)->get();
        $data->requested_tickets=$requested_tickets;
        
        $users_likes   =  DB::table('users_likes')->where('post_id', $data->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
        if( $data->events){
        $data->events->likes = $users_likes;}
        $data->events_images=DB::table('events_images')->where('events_id', $data->events_id)->first();
        $data->event_distance=$this->calculate_distance($req->longitude, $req->lattitude, $events->longitude, $events->lattitude);
        if($events->event_date >= date('Y-m-d')){
          $get_data[]=$data;
        }
      }


      if (count($get_data)>0) {
        $response["code"] = 200; 
        $response["status"] = "success";
        $response["data"] = $get_data;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else{ 
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are required.";
    }
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET USERS TRANSACTIONS UPCOMING */

  /* GET USERS TRANSACTIONS PREVIOUS */
  public function get_previous_events_list(Request $req){
   
      if(isset($req->users_customers_id)  && isset($req->lattitude) && isset($req->longitude)){
        $fetch_data = DB::table('event_bookings')
        ->where('user_id', $req->users_customers_id)
        ->get();
  
      $get_data=[];
        foreach ($fetch_data as $key => $data) {
          $events=DB::table('events')->where('events_id', $data->events_id)->first();
          $data->events=$events;
          $ticket = DB::table('tickets')->where('event_booking_id', $data->event_booking_id)->get(); 
          $data->ticket=$ticket;
          $users_likes   =  DB::table('users_likes')->where('post_id', $data->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          if( $data->events){
          $data->events->likes = $users_likes;}
          $data->events_images=DB::table('events_images')->where('events_id', $data->events_id)->first();
          $data->event_distance=$this->calculate_distance($req->longitude, $req->lattitude, $events->longitude, $events->lattitude);
          if($events->event_date < date('Y-m-d')){
            $get_data[]=$data;
          }
        }
  
  
        if (count($get_data)>0) {
          $response["code"] = 200; 
          $response["status"] = "success";
          $response["data"] = $get_data;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "no data found.";
        }
      } else{ 
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "All fields are required.";
      }
      return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');
    }
  /* GET USERS TRANSACTIONS PREVIOUS */

  /* GET EVENTS BY BUSINESS ID */
  public function get_events_by_id(Request $req){
    if(isset($req->longitude) && isset($req->lattitude) && isset($req->users_customers_id) && isset($req->events_id) && isset($req->page_number)) {
      $records_limit  = DB::table('system_settings')->select('description')->where('type', 'records_limit')->get()->first();
      $offset         = ($req->page_number - 1) * $records_limit->description;
      $events         = DB::table('events')->where('status', 'Active')->where('events_id', '=', $req->events_id)->skip($offset)->take($records_limit->description)->get();
      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          //EVENT IMAGE
          $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
          $event->images = $events_images;
          //VENUE IMAGES

          //CoVER IMAGE
          $event->cover_images = $events_images[0]->name;
          //CoVER IMAGE

          //MY LIKES
          $users_likes   =  DB::table('users_likes')->where('post_id', $event->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          $event->likes = $users_likes;
          //MY LIKES

          //DISTANCE MEASURING
          $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
          //DISTANCE MEASURING

          $all_events[] = $event;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_events;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* GET EVENTS BY BUSINESS ID */

    /* Add Detail of Event Bookings */
    public function event_bookings(Request $req, $length = 10)
    {
        $characters = '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $characters_length = strlen($characters);
        $random_strings = [];
    
        for ($j = 0; $j < $req->number_of_ticket; $j++) {
            $random_string = '';
    
            for ($i = 0; $i <= $length; $i++) {
                $random_string .= $characters[rand(0, $characters_length - 1)];
            }
    
            $random_strings[] = $random_string;
        }
    
        if (isset($req->events_id) && isset($req->user_id) && isset($req->user_business_id) && isset($req->number_of_ticket) && isset($req->number_of_ticket) && isset($req->package_price) && isset($req->claim_discounts) && isset($req->discounted_amount)) {
            $event = DB::table('events')->where('events_id', $req->events_id)->first();
            $available_tickets = $event->no_of_tickets - $event->booked_tickets;
    
            if ($event->no_of_tickets > $event->booked_tickets) {
                if ($available_tickets >= $req->number_of_ticket) {
                    $data = array(
                        'events_id' => $req->events_id,
                        'user_id' => $req->user_id,
                        'user_business_id' => $req->user_business_id,
                        'number_of_ticket' => $req->number_of_ticket,
                        'package_name' => $req->package_name,
                        'package_type' => $req->package_type,
                        'package_price' => $req->package_price,
                        'total_amount' => $req->total_amount,
                        'discounted_amount' => $req->discounted_amount,
                        'remaining_amount' => $req->remaining_amount,
                        'paid_amount' => $req->paid_amount,
                        'booking_percentage' => $event->booking_percentage,
                        'transiction_id'=>$req->transiction_id,
                        'transiction_status'=>$req->transiction_status,
                        'price_per_ticket' => $req->price_per_ticket,
                        'payment_type' => $req->payment_type
                    );
                    
    
                    if (json_last_error() !== JSON_ERROR_NONE) {
                        $response["code"] = 400;
                        $response["status"] = "error";
                        $response["message"] = "Error encoding random_strings array to JSON.";
                    } else {
                        $update_ticket = 0;
    
                        if ($event->booked_tickets) {
                            $update_ticket = $event->booked_tickets + $req->number_of_ticket;
                        } else {
                            $update_ticket = $req->number_of_ticket;
                        }
    
                        $event_update = DB::table('events')->where('events_id', $req->events_id)->update([
                            "booked_tickets" => $update_ticket
                        ]);
    
                        $bookings_id = DB::table('event_bookings')->insertGetId($data);
                        if($req->claim_discounts == 'claimed'){
                          $discountUpdate  = DB::table('event_bookings')->where('events_id', $req->events_id)->update(["claim_discounts" => "Claimed"]);
                        }
                        $data = DB::table('event_bookings')->where('event_booking_id', $bookings_id)->first();
                        $data->available_tickets = $available_tickets - $req->number_of_ticket;
                        foreach ($random_strings as $key => $random_string) {
                          $ticket_data=[
                            "event_booking_id"=>$bookings_id,
                            "random_string"=>$random_string,
                          ];
                          $tickets_insert = DB::table('tickets')->insertGetId($ticket_data);
                        }
                        $tickets = DB::table('tickets')->where('event_booking_id', $bookings_id)->get();
                        $data->tickets=$tickets;
                        $response["code"] = 200;
                        $response["status"] = "success";
                        $response["data"] = $data;
                    }
                } else {
                    $response["code"] = 404;
                    $response["status"] = "error";
                    $response["message"] = "$available_tickets Tickets are available.";
                }
            } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "Tickets are Sold.";
            }
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }
    
        return response()
            ->json($response)
            ->header('Content-Type', 'application/json');
    }
    
   /* Add Detail of Event Bookings */

   // Event Ticket Iist
   public  function event_ticket_list(Request $req){
    if (isset($req->email) && isset($req->password) && isset($req->status) && isset($req->one_signal_id) && isset($req->account_type) && isset($req->social_acc_type) && isset($req->verify_code) && isset($req->google_access_token)) {
      $email=DB::table('users_customers')->where('email', $req->email)->get()->count();
      if ($email==0) {
        $data=array(
          'email'=>$req->email,
          'password'=>$req->password,
          'status'=>$req->status,
          'one_signal_id'=>$req->one_signal_id,
          'account_type'=>$req->account_type,
          'social_acc_type'=>$req->social_acc_type,
          'verify_code'=>$req->verify_code,
          'google_access_token'=>$req->google_access_token
        );

        $registerId   = DB::table('users_customers')->insertGetId($data);
        $register     = DB::table('users_customers')->where('users_customers_id', $registerId)->get();
        $response["code"] = 200;   
        $response["status"] = "success";
        $response["data"] = $register;
      } else {
        $register     = DB::table('users_customers')->where('email', $req->email)->get();

        $response["code"] = 200;   
        $response["status"] = "success";
        $response["data"] = $register;
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
    
    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
   // Event Ticket Iist

   /* Add Payment Method   */
   public function get_payment_method(Request $req){
    $payment_gateway   =  DB::table('payment_gateway')->where('status', 'Active')->get();

    if (!empty($payment_gateway)) {
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $payment_gateway;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "no data found.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  public function event_bookings_type(Request $req){
    if(isset($req->payment_type) && isset($req->status) ){
      $saveData = array(
        'payment_type'=>$req->payment_type,
        'status'=>$req->status,
        'cash_payment'=>$req->cash_payment,
        'stripe_payment'=>$req->stripe_payment,
      
      );
      $gateway_id  = DB::table('payment_gateway')->insertGetId($saveData);
      $data         = DB::table('payment_gateway')->where('payment_gateway_id', $gateway_id)->first();
      if($data){
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $data;
      } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Oop, something wrong.";
      }
    } else {
     $response["code"] = 404;
     $response["status"] = "error";
     $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
   }
   public function get_business_payment_gateway(Request $req){
    $users_business_payment_list   =  DB::table('users_business_payment_gateway')->where('users_business_id', $req->users_business_id)->where('status', 'Active')->get();
    $data=[];
    foreach ($users_business_payment_list as $key => $users_business_payment) {
      $data[]   =  DB::table('payment_gateway')->where('payment_gateway_id', $users_business_payment->payment_gateway_id)->first();
    }
    if (!empty($data[0])) {
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $data;
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "no data found.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  /* Add Payment Method   */  
  /* STRIPE PAYMENT SHEET  */  
   public function payment_sheet(Request $req){
    if(isset($req->name) && isset($req->email) && isset($req->amount) && isset($req->currency)){
      require 'vendor/autoload.php';
      try{
        $stripe = new \Stripe\StripeClient('sk_test_51NLjiSCq21ty1Wx6wztBMHMRFnIYPGAG8Pm8o0vc54j2Ter1X5mVyPkeaSB4dxNQH35NQP8v9lSOzQ1tJ3wH43mU001IBaCEu5');
        
        $customer = $stripe->customers->create([
          'email' => $req->email,
          'name' => $req->name,
      ]);
      $customer_id = $customer["id"];
      $ephemeralKey = $stripe->ephemeralKeys->create([
        'customer' => $customer_id
       ], [
         'stripe_version' => '2022-08-01'
       ]);
       $paymentIntents = $stripe->paymentIntents->create([
        'customer'=> $customer_id,
        'amount' => $req->amount,
        'currency' => $req->currency,
        'payment_method_types' => ['card']
        // 'automatic_payment_methods' => [
        //   'enabled' => true,
        // ]
         
      ]);
      return response()->json(['customer'=>$customer_id,'ephemeralkey'=>$ephemeralKey,'paymentintent'=>$paymentIntents]);
      }catch (\Exception $e) {
        return response()->json(['error' => $e->getMessage()], 500);
    }
    }
   }
  /* STRIPE PAYMENT SHEET  */  
  //  Show Ticket
    public function show_ticket(Request $req){
      if(isset($req->ticket_file) && isset($req->event_booking_id)){
        $ticket_file = $req->ticket_file; 
        $prefix = time();
        $file_name = $prefix .'.pdf';
        $file_path = public_path('uploads/ticket/') . $file_name;

        file_put_contents($file_path, base64_decode($ticket_file));
        $updateData['event_ticket'] = 'uploads/ticket/'. $file_name;
      
        DB::table('event_bookings')->where('event_booking_id', $req->event_booking_id)->update($updateData);
        $updatedData = DB::table('event_bookings')->where('event_booking_id', $req->event_booking_id)->first();
   
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $updatedData;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "All fields are needed.";
      }
  
      return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');

    }
  //  Show Ticket
  // Request Refund
  public function request_refund(Request $req){
    if(isset($req->users_customers_id) && isset($req->event_booking_id)  && isset($req->events_id)  && isset($req->requested_tickets)  && isset($req->tickets_id)){
      $ticket_data = DB::table('tickets')->whereIn('tickets_id', $req->tickets_id)->get();

      $atLeastOneUnscanned = false;
      foreach ($ticket_data as $ticket) {
          if ($ticket->status === "Unscanned") {
              $atLeastOneUnscanned = true;
              break;
          }
      }
      if ($atLeastOneUnscanned) {

      $insert_array['event_booking_id'] = $req->event_booking_id;
      $insert_array['events_id'] = $req->events_id;
      $insert_array['users_customers_id'] = $req->users_customers_id;           
      $insert_array['requested_tickets'] = $req->requested_tickets;           
      $insert_data_id = DB::table('refund_requests')->insertGetId($insert_array);    
      // $refund_requests = DB::table('refund_requests')->where('refund_requests_id', $insert_data_id)->first();
      $all_refund_requests = DB::table('refund_requests')->where('event_booking_id', $req->event_booking_id)->get();
      // $event = DB::table('events')->where('events_id', $req->events_id)->first();
      $event_booking = DB::table('event_bookings')->where('event_booking_id', $req->event_booking_id)->first();
      // $remaining_tickets = $event_booking->number_of_ticket-$req->requested_tickets;
      // $event_images = DB::table('events_images')->where('events_id', $req->events_id)->first();
      // $event->distance = $this->calculate_distance($req->longitude, $req->lattitude, $event->longitude, $event->lattitude);
      $tickets_id = $req->tickets_id;            
      foreach ($tickets_id as $key => $ticket_id) {
        $ticket_update = DB::table('tickets')->where('tickets_id', $tickets_id[$key])->update(['status'=>'Refund']);
      } 

    
      $data=[
        // "refund_requests"=>$refund_requests,
        "all_refund_requests"=>$all_refund_requests,
        // "event"=>$event,
        // "event_images"=> $event_images
        // "remaining_tickets"=> $remaining_tickets
      ];
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $data;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "No tickets with status 'Unscanned' found.";
      }
    }else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }


    public function refunded_requests(Request $req){
    if(isset($req->users_customers_id) && isset($req->longitude) && isset($req->lattitude)){     
      $fetch_data    =  DB::table('refund_requests')->where('users_customers_id', $req->users_customers_id)->where('refund_status', 'Refunded')->get();
      // print_r($fetch_data);
      // exit();        

      $get_data=[];
        foreach ($fetch_data as $key => $data) {
          $events=DB::table('events')->where('events_id', $data->events_id)->first();
          $data->events=$events;
          $users_likes   =  DB::table('users_likes')->where('post_id', $data->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
          if($events){
            $data->events->likes = $users_likes;
          }
          $data->events_images=DB::table('events_images')->where('events_id', $data->events_id)->first();
          $data->events_bookings=DB::table('event_bookings')->where('event_booking_id', $data->event_booking_id)->get();

          $events_tickets=DB::table('tickets')->where('event_booking_id', $data->event_booking_id)->where('status','Refund')->get();
          $data->events_tickets=$events_tickets;

          $data->event_distance=$this->calculate_distance($req->longitude, $req->lattitude, $events->longitude, $events->lattitude);
            
          if(count($events_tickets)>0){  
            $get_data[]=$data;
          }
          
        }
    
      if (count($get_data)>0){  
        $response["code"] = 200; 
        $response["status"] = "success";
        $response["data"] = $get_data;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    }else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
  
      return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');

}
  public function pending_requests(Request $req){
    if(isset($req->users_customers_id) && isset($req->longitude) && isset($req->lattitude)){
    $fetch_data    =  DB::table('refund_requests')->where('users_customers_id', $req->users_customers_id)->where('refund_status', 'Pending')->get();
    $get_data=[];
      foreach ($fetch_data as $key => $data) {
        $events=DB::table('events')->where('events_id', $data->events_id)->first();
        $data->events=$events;
        $users_likes   =  DB::table('users_likes')->where('post_id', $data->events_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Events')->get()->count();
        if( $data->events){
        $data->events->likes = $users_likes;}
        $data->events_images=DB::table('events_images')->where('events_id', $data->events_id)->first();
        $data->events_bookings=DB::table('event_bookings')->where('event_booking_id', $data->event_booking_id)->first();
        $events_tickets=DB::table('tickets')->where('event_booking_id', $data->event_booking_id)->where('status','Refund')->get();
        $data->events_tickets = $events_tickets;
        $data->event_distance=$this->calculate_distance($req->longitude, $req->lattitude, $events->longitude, $events->lattitude);
         if(count($events_tickets)>0){
          $get_data[]=$data;
         }
               
      }
      if (count($get_data)>0) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $get_data;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');

 }
  // Request Refund
  // -------USER BUSINESS LOGIN---------
  public function users_business_login(Request $req){
    if (isset($req->email) && isset($req->password)) {
      $email = DB::table('users_business')->where('email', $req->email)->get()->count();
      if ($email>0) {
        $data=DB::table('users_business')->where('email', $req->email)->get();
        $password=$data[0]->password;
        $id = $data[0]->users_business_id;
        if ($req->password == $password) {
          $userDetail=DB::table('users_business')->where('users_business_id', $id)->first();
          $package_details=DB::table('packages')->where('packages_id', $data[0]->packages_id)->first();
          if (isset($userDetail) && $userDetail != null && isset($package_details) && $package_details != null && $package_details->package_type=="Events") {
            if($userDetail->status == 'Active'){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $userDetail;
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "User Account is inactive.";
            } 
          } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "User do not exist.";
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Password do not match.";
        }
      }else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Email does not exits.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
       
   
  // -------USER BUSINESS LOGIN---------
  // -------SCANNED TICKET---------
  public function scanned_tickets(Request $req){
    if(isset($req->tickets_id)){
      $tickets    =  DB::table('tickets')->where('tickets_id', $req->tickets_id)->update(['status'=>'Scanned']);
      // $get_data=[];
        // foreach ($fetch_data as $key => $data) {
        //   $events=DB::table('events')->where('events_id', $data->events_id)->first();
        //   $data->events=$events;
        //   $data->events_images=DB::table('events_images')->where('events_id', $data->events_id)->first();
        //     $get_data[]=$data;      
          
        // }
    
      if ($tickets){  
        $response["code"] = 200; 
        $response["status"] = "success";
        $response["data"] = $tickets;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    }
      return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');
        

}
public function business_scanned(Request $req){
  if(isset($req->users_business_id)){
    $fetch_data = DB::table('users_business')
    ->join('events', 'users_business.users_business_id', '=', 'events.users_business_id')
    ->join('event_bookings', 'events.events_id', '=', 'event_bookings.events_id')
    ->join('tickets', 'event_bookings.event_booking_id', '=', 'tickets.event_booking_id')
    ->where('users_business.users_business_id', '=', $req->users_business_id) 
    ->where('tickets.status','=' ,'Scanned') 
    ->select('events.*', 'event_bookings.*', 'tickets.*')
    ->get();
    if ($fetch_data){   
      $response["code"] = 200; 
      $response["status"] = "success";
      $response["data"] = $fetch_data; 
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "no data found.";
    }
  }
    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
      

}


  // -------SCANNED TICKET---------
  // ----------EVENTS CHAT----------
  public function get_All_Chat(Request $req){  
    if (isset($req->users_customers_id) && isset($req->events_id)){
      $final_chat_array = array();
      $chat_list = DB::table('chat_list')->where('sender_id', $req->users_customers_id)->where('events_id', $req->venues_id)->get();

      foreach($chat_list as $key => $chat){
        $chat_array = array();
        $chat_array['sender_id'] = $chat->sender_id;
        $chat_array['receiver_id'] = $chat->receiver_id;

        $receiver_data = DB::table('users_business')->where('users_business_id',$chat->receiver_id)->get();
        $chat_array['company_name'] = $receiver_data[0]->first_name;
        $chat_array['company_logo'] = $receiver_data[0]->user_image;
          
        $chat_message = DB::table('chat_messages')->where('sender_id', $req->users_customers_id)->where('sender_id', $req->users_customers_id)->get();
        if (!empty($chat_message[0])) {
          $date_request = Helper::get_day_difference($chat_message[0]->send_date);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = $chat_message[0]->message;
        } else {
          $date_request = Helper::get_day_difference($chat->date_request);
          $chat_array['date'] = $date_request;
          $chat_array['last_message'] = 'No Message sent or recieved.';
        }

        $final_chat_array[] = $chat_array;
      }

      if (!empty($final_chat_array)) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $final_chat_array;
      } else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "chat unavailable.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Enter All Fields.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
  public function users_chat(Request $req){
    if (isset($req->requestType)) {
      $request_type = $req->requestType;
      switch ($request_type) {
        case "startChat":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->events_id)){
            $check_request = DB::table('chat_list')->where([ ['sender_id', $req->users_customers_id], ['receiver_id', $req->other_users_customers_id], ['events_id', $req->events_id]])->orWhere([ ['sender_id', $req->other_users_customers_id], ['receiver_id', $req->users_customers_id], ['events_id', $req->events_id]])->count();
            if($check_request > 0){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["message"] = 'chat already started';    
            } else { 
              $data_save = array(
                  'sender_id'=> $req->users_customers_id,
                  'receiver_id'=> $req->other_users_customers_id,
                  'events_id'=> $req->events_id,
                  'date_request'=> date('Y-m-d'),
                  'created_at' => Carbon::now()
              );
              $requestSend = DB::table('chat_list')->insert($data_save);
              
              if($requestSend){
                  $response["code"] = 200;
                  $response["status"] = "success";
                  $response["message"] = 'chat started';
                } else {
                  $response["code"] = 404;
                  $response["status"] = "error";
                  $response["message"] = 'Error in starting chat';
                }
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are required';      
          }
        break;   
        
        case "sendMessage":
          if(isset($req->events_id) && isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->content) && isset($req->messageType)){
            $message_details = array(
              'events_id'=> $req->events_id,
              'sender_id'=> $req->users_customers_id,
              'receiver_id'=> $req->other_users_customers_id,
              'sender_type'=> $req->sender_type,
              'message'=>  json_encode($req->content) ,
              'message_type'=> $req->messageType,
              'send_date'=> date('Y-m-d'),
              'send_time'=> date('H:i:s'),
              'created_at'=> date('Y-m-d H:i:s'),
              'status'=> 'Unread'
            );

            $insertedId = DB::table('chat_messages')->insertGetId($message_details);
            if($insertedId){
              //NEW MESSAGE Notifications
              $dataInsert=array(
                'events_id'=>$req->events_id,
                'senders_id'=>$req->users_customers_id,
                'receivers_id'=>$req->other_users_customers_id,
                'message'=> 'A new message has been recieved.',
                'date_added'=>date('Y-m-d H:i:s'),
                'date_modified'=>date('Y-m-d H:i:s')
              );
              $this->send_notification($dataInsert);
              //NEW MESSAGE Notifications

              $messageDetails =  DB::table('chat_messages')->where('chat_message_id', $insertedId)->first();
              $messageDetails->message = json_decode($messageDetails->message);
              if($messageDetails->message_type == 'attachment'){
                $messageDetails->message = config('base_urls.chat_attachments_base_url').$messageDetails->message;
              }

              $response["code"] = 200;
              $response["status"] = "success"; 
              $response["message"] = 'Message Sent Successfully';  
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = 'Oops! Something went wrong.';  
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are required';  
          }
        break;
                                       
        case "getMessages":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id) && isset($req->events_id)){
            $chat_array =array();
            $day_array =array();
            $result = DB::table('chat_messages')->where([['sender_id',$req->other_users_customers_id], ['receiver_id', $req->users_customers_id], ['events_id', $req->events_id]])->update(array('status' => 'Read'));  
            
            $all_chat = DB::table('chat_messages')->where([['sender_id',$req->users_customers_id],['receiver_id',$req->other_users_customers_id], ['events_id', $req->events_id]])->orWhere([['sender_id',$req->other_users_customers_id], ['receiver_id',$req->users_customers_id], ['events_id', $req->events_id]])->orderBy('chat_message_id','ASC')->get();

            if(sizeof($all_chat) > 0){
              foreach($all_chat as $key => $chat){
                $get_data['sender_type'] = $chat->sender_type;

                $chat->message = json_decode($chat->message);
                $day = Helper::get_day_difference($chat->send_date);

                if (in_array($day, $day_array, TRUE)){
                  $get_data['date']= '';
                } else {
                  array_push($day_array, $day);
                  $get_data['date']= $day;
                } 
                
                $get_data['time'] =  date('h:i A',strtotime($chat->send_time));
                $get_data['msgType'] = $chat->message_type;

                if($chat->message_type=='attachment'){
                  $attachment = config('base_urls.chat_attachments_base_url') . $chat->message;
                  $get_data['message'] = $attachment;
                } else {
                  $get_data['message'] = $chat->message;
                }

                if($chat->sender_type == 'Companies'){
                  $receiver_data = DB::table('users_business')->where('users_business_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $receiver_data[0];
                } else {
                  $sender_data = DB::table('users_customers')->where('users_customers_id',$req->users_customers_id)->get();
                  $get_data['users_data'] = $sender_data[0];
                }
                array_push($chat_array, $get_data);
                
                if(!empty($chat_array)){
                  $result =  DB::table('chat_messages')->where([
                    ['sender_id',$req->other_users_customers_id],
                    ['receiver_id',$req->users_customers_id]
                  ])->update(array('status'=>'Read'));

                  $result =  DB::table('chat_messages')->where([
                    ['receiver_id',$req->other_users_customers_id],
                    ['sender_id',$req->users_customers_id]
                  ])->update(array('status'=>'Read'));
                }
              }

              if($chat_array){
                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = $chat_array; 
              } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = 'Error in chat array'; 
              }
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = 'no chat history'; 
            }                       
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are needed'; 
          }
        break;

        case "updateMessages":
          if(isset($req->users_customers_id) && isset($req->other_users_customers_id)){
            $user_id = $req->users_customers_id;
            $other_user_id  = $req->other_users_customers_id;
            $chat_array =array();
  
            $all_chat =  DB::table('chat_messages')
              ->where([['sender_id', $other_user_id], ['receiver_id',$user_id],['status','Unread']])
              ->orderBy('chat_message_id', 'ASC')->get();
            
            if(sizeof($all_chat) > 0){
              foreach($all_chat as $chat){
                $get_data['chat_message_id'] = $chat->chat_message_id;
                $get_data['sender_type'] = $chat->sender_type;

                $chat->message = json_decode($chat->message);                
                $get_data['time'] =  date('h:i A',strtotime($chat->send_date));
                $get_data['msgType'] = $chat->message_type;
                if($chat->message_type =='attachment'){
                  $image = config('base_urls.chat_attachments_base_url') . $chat->message;
                  $get_data['message'] = $image;
                } else { 
                  $get_data['message'] = $chat->message;
                } 

                if($chat->sender_type == 'Companies'){
                  $receiver_data = DB::table('users_business')->where('users_business_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $receiver_data[0];
                } else {
                  $sender_data = DB::table('users_customers')->where('users_customers_id',$req->other_users_customers_id)->get();
                  $get_data['users_data'] = $sender_data[0];
                }
                array_push($chat_array, $get_data);
              }
               
              if(!empty($chat_array)){
                $result =  DB::table('chat_messages')->where([
                  ['sender_id',$other_user_id],
                  ['receiver_id',$user_id]
                  ])->update(array('status'=>'Read'));
              }
                         
              $chat_length   =  DB::table('chat_messages')->where([
                ['sender_id', $user_id],
                ['receiver_id',$other_user_id]
                ])->orWhere([
                    ['sender_id', $other_user_id],
                ['receiver_id',$user_id]
              ])->orderBy('chat_messages_id','ASC')->count();
            
              $finalDataset = array(
                  "chat_length" => $chat_length,
                  "unread_messages" => $chat_array,
              );

              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $finalDataset; 
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "no chat found"; 
            }
          } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed"; 
          }
        break;    
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Request type not Found"; 
    }

    return response()
     ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
     ->header('Content-Type', 'application/json');
  }
  
  // ----------EVENTS CHAT----------

  // ------------GET EVENTS FOR APP-------------
  public function get_events_for_app(Request $req){
    if(isset($req->users_business_id) ) {
      $events         = DB::table('events')->where('status', 'Active')->where('users_business_id', '=', $req->users_business_id)->get();
      if (!empty($events[0])) {
        $all_events = array();
        foreach($events as $event){
          //EVENT IMAGE
          $events_images   =  DB::table('events_images')->where('events_id', $event->events_id)->where('status', 'Active')->get();
          $event->images = $events_images;
          //EVENT IMAGE

          $all_events[] = $event;
        }

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $all_events;
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  // Get Special Offers
  public function special_offers(Request $req){
    if(isset($req->users_customers_id) && isset($req->longitude) && isset($req->lattitude)){
      $venues =  DB::table('venues')
      ->where('status', 'Active')
      ->where('special_offers', 'Yes')
      ->where('discount_percentage', '>', 0) 
      ->get();                
      if (!empty($venues[0])) {
        $all_venues = array();
        foreach($venues as $venue){
          $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();

            //MY LIKES
            $venue->likes = $users_likes;    
            //MY LIKES

            //VENUE IMAGES
            $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
            $venue->images = $venues_images;
            //VENUE IMAGES

            // Venue timing
            $venues_hours = DB::table('venues_hours')
            ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
            ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
            ->where('venues_hours.status', 'Active')
            ->where('venues_hours.venues_id', $venue->venues_id)     
            ->get();
            $venue->venue_timing = $venues_hours;
            // Venue timing

            //CoVER IMAGE
            $venue->cover_images = $venues_images[0]->name;
            //CoVER IMAGE

            //DISTANCE MEASURING
            $venue->distance = $this->calculate_distance($req->longitude, $req->lattitude, $venue->longitude, $venue->lattitude);
            //DISTANCE MEASURING

            $all_venues[] = $venue;
          
        }

        if(!empty($all_venues)){
          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $all_venues;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "no data found.";
        }
      } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }
      return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');
        

}
  // Get Special Offers
  // Get Venues Timing
  public function get_venues_timing(Request $req)
  {
      if (isset($req->users_customers_id) && isset($req->venues_id)) {
          $venues_hours = DB::table('venues_hours')
              ->join('venues_days', 'venues_hours.venues_hours_days', '=', 'venues_days.venues_days_id')
              ->select('venues_days.days_name', 'venues_hours.start_hours', 'venues_hours.close_hours')
              ->where('venues_hours.status', 'Active')
              ->where('venues_hours.venues_id', $req->venues_id)
              ->get();
  
          if ($venues_hours !== null && count($venues_hours) > 0) {
              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $venues_hours;
          } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "No timing found for the provided venues ID";
          }
      } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Invalid Authentication Key";
      }
  
      return response()
          ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
  }
  // Get Venues Timing
  // Add Review Api
  public function add_reviews(Request $req){
    if(isset($req->users_customers_id) && isset($req->venues_id) && isset($req->review_rating)){
        // Check if the user has already reviewed the venue
        $existing_review = DB::table('venues_reviews')
                            ->where('venues_id', $req->venues_id)
                            ->where('users_customer_id', $req->users_customers_id)
                            ->first();

        if($existing_review) {
            $response["code"] = 400;
            $response["status"] = "error";
            $response["message"] = "You have already reviewed this venue";
            return response()->json($response)->header('Content-Type', 'application/json');
        }

        // If the user hasn't reviewed the venue yet, proceed with saving the review
        $data_save = array(
            'venues_id'=> $req->venues_id,
            'users_customer_id'=> $req->users_customers_id,
            'review'=> $req->review,
            'review_ratings'=> (float)$req->review_rating 
        );

        $save_review = DB::table('venues_reviews')->insertGetId($data_save);

        // Check if review is successfully saved
        if($save_review){
            $review = DB::table('venues_reviews')->where('venues_reviews_id', $save_review)->first();     
            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $review;
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "Failed to save review";
        }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "All fields are needed";
    }

    return response()->json($response)->header('Content-Type', 'application/json');
}


  // Add Review Api
  // Get Reviews
  public function get_reviews(Request $req){
    if(isset($req->venues_id)){

        // Retrieve reviews for the specified venue
        $reviews = DB::table('venues_reviews')
                    ->where('venues_id', $req->venues_id)
                    ->get();

        if($reviews->isNotEmpty()){
            $response["code"] = 200;
            $response["status"] = "success";

            // Retrieve user data for each review
            foreach ($reviews as $review) {
                $user = DB::table('users_customers')
                            ->where('users_customers_id', $review->users_customer_id)
                            ->first();

                $review->user_profile = $user;
            }

            $response["data"] = $reviews;
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["data"] = [
                "message" => "No reviews found for the specified venue"
            ];
        }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["data"] = [
            "message" => "Venue ID is required"
        ];
    }

    return response()
        ->json($response)
        ->header('Content-Type', 'application/json');
}



  // Get Reviews
  //  update user location 
  public function updateLocation(Request $request)
{
    if (isset($request->customer_id) && isset($request->current_latitude) && isset($request->current_longitude)) {
 

    $userCustomer = DB::table('users_customers')->where('users_customers_id',$request->customer_id)->first();

    if (!$userCustomer) {
        $response = [
            'code' => 404,
            'status' => 'error',
            'message' => 'User customer not found'
        ];
    } else {
        DB::table('users_customers')         
            ->where('users_customers_id',$request->customer_id)
            ->update([
                'current_lattitude' => $request->current_latitude,
                'current_longitude' => $request->current_longitude    
            ]);

        $response = [
            'code' => 200,
            'status' => 'success',
            'message' => 'User location updated successfully'
        ];
    }
  }else  {
    $response["code"] = 404;
    $response["status"] = "error";
    $response["message"] = "All fields are needed";
  }
  return response()
  ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
  ->header('Content-Type', 'application/json');

}
  //  update user location 
  // cron job function for venue availabitity 
  public function updateVenueAvailability()
  {
      $venues = DB::table('venues')->get();
  
      foreach ($venues as $venue) {
          $usersWithin30 = DB::table('users_customers')    
              ->whereRaw("6371 * acos(cos(radians($venue->lattitude)) * cos(radians(current_lattitude)) * cos(radians(current_longitude) - radians($venue->longitude)) + sin(radians($venue->lattitude)) * sin(radians(current_lattitude))) * 1000 < 50")    
              ->count();
              $capacity = $venue->capacity;
              $percentage = ($usersWithin30 / $capacity) * 100;
  
          $availability = 'Quiet';
              if ($percentage >= 70) {
                  $availability = 'Very Busy';
              } elseif ($percentage >= 50 && $percentage < 70) {
                  $availability = 'Busy';
              }
          DB::table('venues')
              ->where('venues_id', $venue->venues_id)           
              ->update(['availability' => $availability,
                        'availability_count' => $usersWithin30
                      ]);      
      }
  
      return response()->json(['message' => 'Venue availability updated successfully']);          
  } 
  // cron job function for venue availabitity 
  // ----------Third Part API's-----------------
  // Get Authentication Key
  public function get_authentication_key(Request $req){
    if (isset($req->email) && isset($req->password)) {
      $email = DB::table('users_business')->where('email', $req->email)->get()->count();  
      if ($email>0) {
        $data=DB::table('users_business')->where('email', $req->email)->get();
        $password=$data[0]->password;
        $id = $data[0]->users_business_id;
        if ($req->password == $password) {
          $userDetail=DB::table('users_business')->where('users_business_id', $id)->get()->first();
          $authentication_key = $userDetail->authentication_key;    
          if (isset($userDetail) && $userDetail != null) {
            if($userDetail->status == 'Active'){
              $response["code"] = 200;
              $response["status"] = "success";
              $response["data"] = $authentication_key;
            } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "User Account is inactive.";
            } 
          } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "User do not exist.";
          }
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "Password do not match.";
        }
      }else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "Email does not exits.";
      }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "All fields are needed.";
    }

    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
  // get Venues List
  public function get_venues(Request $req){
    if(isset($req->authentication_key)) {
      $User_business   =  DB::table('users_business')->where('status', 'Active')->where('authentication_key', $req->authentication_key)->first();
      if($User_business){
        $ID = $User_business->users_business_id;   

      $venues         =  DB::table('venues')->where('status', 'Active')->where('users_business_id', $ID)->get();         
      

        if (!empty($venues[0])) {
          $all_venues = array();    
          foreach($venues as $venue){
            //VENUE IMAGES 
            $venues_images   =  DB::table('venues_images')->where('venues_id', $venue->venues_id)->where('status', 'Active')->get();
            $venue->images = $venues_images;
            //VENUE IMAGES

            //CoVER IMAGE
            $venue->cover_images = $venues_images[0]->name;
            //CoVER IMAGE

            //MY LIKES
            // $users_likes   =  DB::table('users_likes')->where('post_id', $venue->venues_id)->where('users_customers_id', $req->users_customers_id)->where('type', 'Venues')->get()->count();
            // $venue->likes = $users_likes;
            // //MY LIKES
            
            // //DISTANCE MEASURING
            // $venue->distance = $this->calculate_distance($req->lattitude, $req->longitude, $venue->lattitude, $venue->longitude);
            // //DISTANCE MEASURING

            $all_venues[] = $venue;
          }

          $response["code"] = 200;
          $response["status"] = "success";
          $response["data"] = $all_venues;
        } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "no data found.";
        }
    } else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Invalid Authentication Key";
    }
  }else{
    $response["code"] = 404;
    $response["status"] = "error";
    $response["message"] = "All fields are needed.";

  }

    return response()
      ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
      ->header('Content-Type', 'application/json');
  }
  public function get_your_customer(Request $req)
  {
      if (isset($req->authentication_key) && isset($req->email)) {
          $User_business = DB::table('users_business')->where('status', 'Active')->where('authentication_key', $req->authentication_key)->first();
          if ($User_business) {
              $users_Customer = DB::table('users_customers')->where('status', 'Active')->where('email', $req->email)->get();
              if ($users_Customer !== null && count($users_Customer) > 0) {
                  $response["code"] = 200;
                  $response["status"] = "success";
                  $response["data"] = $users_Customer;
              } else {
                  $response["code"] = 404;
                  $response["status"] = "error";
                  $response["message"] = "No Customer Found. Create Your Customer";
              }
          } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "Invalid Authentication Key";
          }
      } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "All fields are needed.";
      }
  
      return response()
          ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
  }

  public function create_your_customer(Request $req){
    if(isset($req->authentication_key) && isset($req->email)&& isset($req->password)){
        $User_business = DB::table('users_business')->where('status', 'Active')->where('authentication_key', $req->authentication_key)->first();  
        if($User_business){
              $email=DB::table('users_customers')->where('email', $req->email)->get()->count();
              if ($email==0) {
                $data=array(   
                  'email'=>$req->email,
                  'password'=> md5($req->password)
                );
        
                $registerId   = DB::table('users_customers')->insertGetId($data);
                $Customer     = DB::table('users_customers')->where('users_customers_id', $registerId)->get();
                $response["code"] = 200;   
                $response["status"] = "success";
                $response["data"] = $Customer;
                }else{
                  $response["code"] = 404;
                  $response["status"] = "error";
                  $response["message"] = "Email Already Exists";

                }     
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "Invalid Authentication Key";
        }
    } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "All fields are needed.";
    }

    return response()
        ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');
  }

 
 


  public function schedule_visit(Request $req)    
  {  
      if (isset($req->venues_id) && isset($req->users_customers_id) && isset($req->no_of_diners) 
          && isset($req->bookings_date) && isset($req->bookings_time) && isset($req->claim_discounts) 
        && isset($req->authentication_key)) {
          
          $user_business = DB::table('users_business')->where('authentication_key', $req->authentication_key)->first();
  
          if ($user_business) {
              $currentDate = now()->toDateString();
  
              if ($req->bookings_date >= $currentDate) {
                  $data = array(
                      'venues_id' => $req->venues_id,
                      'users_customers_id' => $req->users_customers_id,
                      'no_of_diners' => $req->no_of_diners,
                      'bookings_date' => $req->bookings_date,
                      'bookings_time' => $req->bookings_time,
                      'date_added' => now(),
                      'status' => 'Pending'
                  );
  
                  $bookings_id  = DB::table('venues_bookings')->insertGetId($data);
  
                  if ($req->claim_discounts == 'claimed') {
                      $discountUpdate = DB::table('venues_bookings')->where('venues_bookings_id', $bookings_id)->update(["claim_discounts" => "Claimed"]);
                  }
  
                  $get_data = DB::table('venues_bookings')->where('venues_bookings_id', $bookings_id)->first();
  
                  $response["code"] = 200;
                  $response["status"] = "success";
                  $response["data"] = $get_data;
              } else {
                  $response["code"] = 404;
                  $response["status"] = "error";    
                  $response["message"] = "Invalid booking date.";
              }
          } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "Invalid Authentication Key";
          }
      } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "All fields are needed.";
      }
  
      return response()
          ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
  }
  public function schedule_visit_test(Request $req)      
  {  
      if (isset($req->venues_id) && isset($req->users_customers_id) && isset($req->no_of_diners) 
          && isset($req->bookings_date) && isset($req->bookings_time) && isset($req->claim_discounts) 
          && isset($req->users_business_id) && isset($req->authentication_key)) {
          
          $user_business = DB::table('users_business')->where('users_business_id', $req->users_business_id)->first();
          $Auth = $user_business->authentication_key;
  
          if ($Auth == $req->authentication_key) {
              $currentDate = now()->toDateString();
  
              if ($req->bookings_date >= $currentDate) {
                  $data = array(
                      'venues_id' => $req->venues_id,
                      'users_customers_id' => $req->users_customers_id,
                      'no_of_diners' => $req->no_of_diners,
                      'bookings_date' => $req->bookings_date,
                      'bookings_time' => $req->bookings_time,
                      'date_added' => now(),
                      'status' => 'Pending'
                  );
  
                  $bookings_id  = DB::table('schedule_visit')->insertGetId($data);
  
                  if ($req->claim_discounts == 'claimed') {
                      $discountUpdate = DB::table('schedule_visit')->where('venues_bookings_id', $bookings_id)->update(["claim_discounts" => "Claimed"]);
                  }
  
                  $get_data = DB::table('schedule_visit')->where('venues_bookings_id', $bookings_id)->first();  
  
                  $response["code"] = 200;
                  $response["status"] = "success";
                  $response["data"] = $get_data;
              } else {
                  $response["code"] = 404;
                  $response["status"] = "error";    
                  $response["message"] = "Invalid booking date.";
              }
          } else {
              $response["code"] = 404;
              $response["status"] = "error";
              $response["message"] = "Invalid Authentication Key";
          }
      } else {
          $response["code"] = 404;
          $response["status"] = "error";
          $response["message"] = "All fields are needed.";
      }
  
      return response()
          ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
  }
  // get stripe keys
  public function get_stripe_keys(){
    $stripe_key  =  DB::table('system_settings')->where('type','stripe_keys')->first();
    $description = $stripe_key->description;
  
    if($stripe_key){
    $stripe_keys   =  DB::table('stripe_keys')->where('stripe_keys_type',$description)->get();
  
    $response["code"] = 200;
    $response["status"] = "success";
    $response["data"] = $stripe_keys; 
    }else{
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "Something went wrong";
    }
  
    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
  }
  
  // get stripe keys
  // get venues Keywords
  public function venues_keywords(Request $request) {
    if(isset($request->customer_id)) {
        $all_venues = array();

        // Retrieve venue types
        $venues_types = DB::table('venues_type')->where('status', 'Active')->get();      

        // Retrieve venue music
        $venues_music = DB::table('venues_music')->where('status', 'Active')->get();

        // Retrieve venue budget
        $venues_budget = DB::table('venues_budget')->where('status', 'Active')->get();

        // Retrieve venue cuisine
        $venues_cuisine = DB::table('venues_cusine')->where('status', 'Active')->get();

        // Retrieve venue food
        $venues_food = DB::table('venues_food')->where('status', 'Active')->get();

        // Create a new venue object and assign data     
        $venue = [
            'Types' => $venues_types,
            'Music' => $venues_music,
            'Budget' => $venues_budget,
            'Cuisine' => $venues_cuisine,
            'Food' => $venues_food
        ];

        // Add the venue object to the array of all venues
        $all_venues[] = $venue;

        $response = [
            "code" => 200,
            "status" => "success",
            "data" => $all_venues
        ];
    } else {
        $response = [
            "code" => 404,
            "status" => "error",
            "message" => "No data found."
        ];
    }

    return response()->json($response);
}
public function event_keywords(Request $request) {
  if(isset($request->customer_id)) {
      $all_events = array();

      // Retrieve venue types
      $event_exp = DB::table('event_type')->where('status', 'Active')->get();      

      // Retrieve venue music
      $event_music = DB::table('event_music')->where('status', 'Active')->get();

      // Create a new venue object and assign data     
      $event = [
          'Event_Exp' => $event_exp,
          'Event_Music' => $event_music
      ];

      // Add the venue object to the array of all venues
      $all_events[] = $event;

      $response = [
          "code" => 200,
          "status" => "success",
          "data" => $all_events
      ];
  } else {
      $response = [
          "code" => 404,
          "status" => "error",
          "message" => "No data found."
      ];
  }

  return response()->json($response);
}
public function findVenuesMatchingKeywords(Request $request)     
{
    // Get the user's request
    $userRequest = $request->input('user_request');

    // Split the user request into individual words
    $words = explode(' ', $userRequest);    
    // Initialize an empty array to store the number of matches for each venue
    $venueMatches = [];

    // Iterate over each word and check if it exists in the venues_keyword table
    foreach ($words as $word) {
        // Query to find venue_ids for the given keyword
        $venues = DB::table('venues_keywords')
                    ->where('keyword_value', $word)
                    ->pluck('venues_id')
                    ->toArray();
        print_r($venues);
        exit();    
        
        // Increment the match count for each venue
        foreach ($venues as $venueId) {
            if (!isset($venueMatches[$venueId])) {
                $venueMatches[$venueId] = 1;
            } else {
                $venueMatches[$venueId]++;
            }
        }
    }

    // Filter venues that have multiple matches
    $matchingVenues = array_keys(array_filter($venueMatches, function ($count) {
        return $count >= 2;
    }));

    // Return the array of matching venues
    return response()->json(['matching_venues' => $matchingVenues]);
}
public function findEventMatchingKeywords(Request $request)     
{
    // Get the user's request
    $userRequest = $request->input('user_request');

    // Split the user request into individual words
    $words = explode(' ', $userRequest);    
    // Initialize an empty array to store the number of matches for each venue
    $venueMatches = [];

    // Iterate over each word and check if it exists in the venues_keyword table
    foreach ($words as $word) {
        // Query to find venue_ids for the given keyword
        $venues = DB::table('venues_keywords')
                    ->where('keyword_value', $word)
                    ->pluck('venues_id')
                    ->toArray();
        print_r($venues);
        exit();    
        
        // Increment the match count for each venue
        foreach ($venues as $venueId) {
            if (!isset($venueMatches[$venueId])) {
                $venueMatches[$venueId] = 1;
            } else {
                $venueMatches[$venueId]++;
            }
        }
    }

    // Filter venues that have multiple matches
    $matchingVenues = array_keys(array_filter($venueMatches, function ($count) {
        return $count >= 2;
    }));

    // Return the array of matching venues
    return response()->json(['matching_venues' => $matchingVenues]);
}



  // ------------GET EVENTS FOR APP-------------
  /***************************************************** V3 FEATURES ******************************************************************/
} 
