<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Mail;

use App\Models\Event_post;
use App\Models\Tag;
use App\Models\Event_tag;
use App\Mail\{SendMail,RefundMail};

use App\Http\Controllers\Controller;
use App\User;
use Carbon\Carbon;
use DB;
use URL;

use Artisan;
use Session;

class BusinessController extends Controller{
    public $successStatus = 200;   
    public $errorStatus = 401;

    // -------------- NOTIFICATIONS PAGE ------------- //
    public function send_notification($id, $availability, $message = ''){
        $users_customers = DB::table('users_customers')->where('status', '=', 'Active')->get();
        foreach($users_customers as $users){
            if($message == ''){
                $data = array(
                    'venues_id'=>$id,
                    'senders_id'=>session('id'),
                    'receivers_id'=>$users->users_customers_id,
                    'message'=> 'Venue availability status updated to '. $availability, 
                    'date_added'=>date('Y-m-d H:i:s'),
                    'date_modified'=>date('Y-m-d H:i:s')
                );
            } else {
                $data = array(
                    'venues_id'=>$id,
                    'senders_id'=>session('id'),
                    'receivers_id'=>$users->users_customers_id,
                    'message'=> $message, 
                    'date_added'=>date('Y-m-d H:i:s'),
                    'date_modified'=>date('Y-m-d H:i:s')
                );
            }
            DB::table('notifications')->insert($data);
        }
    }
    // -------------- NOTIFICATIONS PAGE ------------- //

    // -------------- LANDING PAGE ------------- //
    public function landing(Request $request){
        if ($request->session()->has('id')) {
            return redirect('business/dashboard');
        } else{
            return view('business.landing');
        }
    }
    // -------------- LANDING PAGE ------------- //

    // -------------- LOGIN PAGE ------------- //
    public function index(Request $request){
        if ($request->session()->has('id')) {
            return redirect('business/dashboard');
        } else{
            return view('business.login');
        }
    }
    // -------------- LOGIN PAGE ------------- //

    // -------------- LOGIN AUTHENTICATION ------------- //
    public function login(Request $request){
        $validateData = $request->validate([
            'email' => 'required|email',
            'password' => 'required'
        ]);
        
        $postData = $request->all();
        $ifExists = DB::table('users_business')->where('email', $postData['email'])->where('password', $postData['password'])->first();
        if (!empty($ifExists)) {
            if($ifExists->status == 'Active'){
                $request->session()->put([
                    'id' => $ifExists->users_business_id,
                    'user_image' => $ifExists->user_image,
                    'fname' => $ifExists->first_name,
                    'email' => $ifExists->email,
                ]);
                Session::flash('success', ' Logged in successfully.'); 
                return redirect('business/dashboard');
            } else {
                Session::flash('error', 'Your account is '. $ifExists->status .'. Please contact admin for further details.'); 
                return redirect()->back(); 
            }
        } else {
            Session::flash('error', 'Invalid Email/Password'); 
            return redirect()->back();
        }
    }
    // -------------- LOGIN AUTHENTICATION ------------- //

    // -------------- FORGOT PASSWORD ------------- //
    public function forget_password(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else{
            return view('business.forget_password');
        }
    }
    // -------------- FORGOT PASSWORD ------------- //

    // -------------- FORGOT PASSWORD SEND OTP ------------- //
    public function forget_password_otp(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $email      =   DB::table('users_business')->where('email', $request->email)->get()->count();
            if ($email > 0) {
                $emaildata          =   DB::table('users_business')->where('email', $request->email)->get();
                $id                 =   $emaildata[0]->users_business_id; 
                $onlyEmail          =   $request->email;
                $forgotPasswordOtp  =   rand(1000,9999);

                $details = [
                  "title"=>"Email Verification Code",
                  "body"=> $forgotPasswordOtp
                ];            
                $otpSended      = Mail::to($onlyEmail)->send(new SendMail($details));
                
                $otpData        = array('forgotPasswordOtp' => $forgotPasswordOtp);
                $UserotpUpdate  = DB::table('users_business')->where('email', $onlyEmail)->update($otpData);

                Session::flash('success', ' Password reset OTP is sent on your email. Please check and proceed with OTP.'); 
                return redirect('business/forget_password_otp_reset/'.$id);
            } else {
                Session::flash('error', ' Invalid Email.'); 
                return redirect('business/forget_password');
            }
        }
    }
    // -------------- FORGOT PASSWORD SEND OTP ------------- //

    // -------------- FORGOT PASSWORD RESET ------------- //
    public function forget_password_otp_reset($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            return view('business.forget_password_otp_reset', ['users_business_id'=>$id]);
        }
    }
    // -------------- FORGOT PASSWORD RESET ------------- //

    // -------------- FORGOT PASSWORD RESET VERIFICATION ------------- //
    public function forget_password_otp_reset_verification(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $id         = $request->id;
            $UserOtp    = DB::table('users_business')->select('forgotPasswordOtp')->where('users_business_id', $id)->get();
            $userOtpGet = $UserOtp[0]->forgotPasswordOtp;
            
            $otp1       = $request->otp1;
            $otp2       = $request->otp2;
            $otp3       = $request->otp3;
            $otp4       = $request->otp4;
            $otp        = $otp1.''.$otp2.''.$otp3.''.$otp4;
            
            if ($userOtpGet==$otp) {
                Session::flash('success', ' OTP Verified.'); 
                return redirect()->route('forget_password_change_password', $id);
            } else {
                Session::flash('error', ' Invalid Otp. Please enter correct otp.'); 
                return redirect()->back()->withMessage('Invalid Otp. Please enter correct otp');
            }
        }
    }
    // -------------- FORGOT PASSWORD RESET VERIFICATION ------------- //

    // -------------- FORGOT CHANGE PASSWORD ------------- //
    public function forget_password_change_password($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $data   = DB::table('users_business')->where('users_business_id', $id)->get();
            $id     = $data[0]->users_business_id;
            return view('business.forget_password_change_password', ['id'=>$id]);
        }
    }
    // -------------- FORGOT CHANGE PASSWORD ------------- //

    // -------------- FORGOT CHANGE PASSWORD PROCESS ------------- //
    public function forget_password_change_password_process(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            if ($request->password == $request->cpassword) {
                $id     = $request->id;
                $data   = array(
                  'password'=>$request->password
                );
                DB::table('users_business')->where('users_business_id', $id)->update($data);
                Session::flash('success', ' Password change Successfully.'); 
                return redirect('/')->withMessage('Password change Successfully.');
            } else {
                Session::flash('error', ' Password Does Not Match.'); 
                return redirect()->back()->withMessage('Password Does Not Match.');
            }
        }
    }
    // -------------- FORGOT CHANGE PASSWORD PROCESS ------------- //

    // -------------- SIGNUP PAGE ------------- //
    public function signup(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else{
            return view('business.signup');
        }
    }
    // -------------- SIGNUP PAGE ------------- //

     // -------------- SIGNUP PROCESS ------------- //
    public function signup_process(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $email      =   DB::table('users_business')->where('email', $request->email)->get()->count();
            if ($email == 0) {
                if ($request->password == $request->confirm_password) {
                    $randomString = Str::random(12);    
                    $md5Token = md5($randomString);
                    $auth_key = 'authentication_key_' .$md5Token;
                    $data = array(
                        'first_name'=>$request->first_name,
                        'email'=>$request->email,
                        'mobile'=>$request->mobile,
                        'authentication_key'=>$auth_key,
                        'password'=>$request->password,
                        'status'=>'Pending'
                    );
                    $users_business_id = DB::table('users_business')->insertGetId($data);

                    $payable_amount  = DB::table('packages')->where('packages_id', $request->packages_id)->get()->first();
                    $discount_amount = $payable_amount->price / 100 * $payable_amount->discount_percentage;
                    $paid_amount     = $payable_amount->price - $discount_amount;

                    $data_txns = array(
                        'users_business_id'     => $users_business_id,
                        'packages_id'           => $request->packages_id,
                        'payment_gateways'      => $request->payment_gateways,
                        'discount_percentage'  => $payable_amount->discount_percentage,
                        'discount_amount'       => $discount_amount,
                        'paid_amount'           => $paid_amount,
                        'transactions_status'   => 'Pending'
                    );
                    $txn_id = DB::table('users_business_txns')->insertGetId($data_txns);
                    
                    //FREE TRIAL CODE echo "free trial"; exit;
                    if($request->packages_id == 3 || $request->packages_id == 6){
                        $update_business['packages_id']                = $request->packages_id;
                        $update_business['status']                     = 'Active';
                        $update_business['subscription_start_date']    = date("Y-m-d H:i:s");
                        $update_business['subscription_end_date']       = date("Y-m-d H:i:s", strtotime($update_business['subscription_start_date']. ' + 6 months'));
                        $update_data = DB::table('users_business')->where('users_business_id', '=', $users_business_id)->update($update_business);

                        $update_business_txns['transactions_status']        = 'Completed';
                        $update_business_txns['gateway_status']             = 'Success';
                        $update_business_txns['subscription_start_date']    = date("Y-m-d H:i:s");
                        $update_business_txns['subscription_end_date']      = date("Y-m-d H:i:s", strtotime($update_business_txns['subscription_start_date']. ' + 6 months'));
                        $update_data = DB::table('users_business_txns')->where('users_business_txns_id', '=', $txn_id)->update($update_business_txns);

                        Session::flash('success', ' Your payment is recieved. Please login to your account.'); 
                        return redirect('business');
                    } else {
                        Session::flash('success', ' Signup successfully. Your are being redirected to payment gateways.'); 
                        return redirect('business/payments/'.$txn_id);
                    }
                    //FREE TRIAL CODE echo "free trial"; exit;
                } else {
                    Session::flash('error', ' password and confirm password donot Match.'); 
                    return redirect('business/signup');
                }
            } else {
                Session::flash('error', ' Email Already Exists. Please try with another email address.'); 
                return redirect('business/signup');
            }
        }
    }
    // -------------- SIGNUP PROCESS ------------- //

    // -------------- SIGNUP PAYMENT INIT ------------- //
    public function payment_init(){
        // Include the Stripe PHP library 
        require_once (realpath($_SERVER["DOCUMENT_ROOT"]).'/public/vendor/stripe-php/init.php');

        // Set API key 
        $STRIPE_API_KEY             =   DB::table('system_settings')->where('type', 'STRIPE_API_KEY')->get()->first()->description;
        $STRIPE_PUBLISHABLE_KEY     =   DB::table('system_settings')->where('type', 'STRIPE_PUBLISHABLE_KEY')->get()->first()->description;

        \Stripe\Stripe::setApiKey($STRIPE_API_KEY); 

        // Retrieve JSON from POST body 
        $jsonStr = file_get_contents('php://input'); 
        $jsonObj = json_decode($jsonStr); 
         
        if($jsonObj->request_type == 'create_payment_intent'){ 
             
            // Define item price and convert to cents 
            $itemPriceCents = round($jsonObj->itemPrice * 100); 
             
            // Set content type to JSON 
            header('Content-Type: application/json'); 
             
            try { 
                // Create PaymentIntent with amount and currency 
                $paymentIntent = \Stripe\PaymentIntent::create([ 
                    'amount' => $itemPriceCents, 
                    'currency' => $jsonObj->currency, 
                    'description' => $jsonObj->itemName, 
                    'payment_method_types' => [ 
                        'card' 
                    ] 
                ]); 
             
                $output = [ 
                    'id' => $paymentIntent->id, 
                    'clientSecret' => $paymentIntent->client_secret 
                ]; 
             
                echo json_encode($output); 
            } catch (Error $e) { 
                http_response_code(500); 
                echo json_encode(['error' => $e->getMessage()]); 
            } 
        }elseif($jsonObj->request_type == 'create_customer'){ 
            $payment_intent_id = !empty($jsonObj->payment_intent_id)?$jsonObj->payment_intent_id:''; 
            $name = !empty($jsonObj->name)?$jsonObj->name:''; 
            $email = !empty($jsonObj->email)?$jsonObj->email:''; 
             
            // Add customer to stripe 
            try {   
                $customer = \Stripe\Customer::create(array(  
                    'name' => $name,  
                    'email' => $email 
                ));  
            }catch(Exception $e) {   
                $api_error = $e->getMessage();   
            } 
             
            if(empty($api_error) && $customer){ 
                try { 
                    // Update PaymentIntent with the customer ID 
                    $paymentIntent = \Stripe\PaymentIntent::update($payment_intent_id, [ 
                        'customer' => $customer->id 
                    ]); 
                } catch (Exception $e) {  
                    // log or do what you want 
                } 
                 
                $output = [ 
                    'id' => $payment_intent_id, 
                    'customer_id' => $customer->id 
                ]; 
                echo json_encode($output); 
            }else{ 
                http_response_code(500); 
                echo json_encode(['error' => $api_error]); 
            } 
        }elseif($jsonObj->request_type == 'payment_insert'){ 
            $payment_intent = !empty($jsonObj->payment_intent)?$jsonObj->payment_intent:''; 
            $customer_id = !empty($jsonObj->customer_id)?$jsonObj->customer_id:''; 
             
            // Retrieve customer info 
            try {   
                $customer = \Stripe\Customer::retrieve($customer_id);  
            }catch(Exception $e) {   
                $api_error = $e->getMessage();   
            } 
             
            // Check whether the charge was successful 
            if(!empty($payment_intent) && $payment_intent->status == 'succeeded'){ 
                // Transaction details  
                $gateway_transaction_id = $payment_intent->id; 
                $paid_amount = $payment_intent->amount; 
                $paid_amount = ($paid_amount/100); 
                $paid_currency = $payment_intent->currency; 
                $payment_status = $payment_intent->status; 
                 
                $customer_name = $customer_email = ''; 
                if(!empty($customer)){ 
                    $customer_name = !empty($customer->name)?$customer->name:''; 
                    $customer_email = !empty($customer->email)?$customer->email:''; 
                } 
                 
                // Check if any transaction data is exists already with the same TXN ID 
                $txn_data                                           = DB::table('users_business_txns')->where('users_business_txns_id', $jsonObj->id)->get()->first();
                $users_business                                     = DB::table('users_business')->where('users_business_id', $txn_data->users_business_id)->get()->first();
                $packages                                           = DB::table('packages')->where('packages_id', $txn_data->packages_id)->get()->first();

                $update_business['gateway_transaction_id']          = $gateway_transaction_id;
                $update_business['packages_id']                     = $txn_data->packages_id;
                $update_business['status']                          = 'Active';
                $update_business['subscription_start_date']         = date("Y-m-d H:i:s");
                $update_business['subscription_end_date']           = date("Y-m-d H:i:s", strtotime($update_business['subscription_start_date']. ' + 1 months'));
                $update_data = DB::table('users_business')->where('users_business_id', '=', $users_business->users_business_id)->update($update_business);

                $update_business_txns['transactions_status']        = 'Completed';
                $update_business_txns['gateway_status']             = 'Success';
                $update_business_txns['subscription_start_date']    = date("Y-m-d H:i:s");
                $update_business_txns['subscription_end_date']      = date("Y-m-d H:i:s", strtotime($update_business_txns['subscription_start_date']. ' + 1 months'));
                $update_data = DB::table('users_business_txns')->where('users_business_txns_id', '=', $jsonObj->id)->update($update_business_txns);
                 
                $output = ['payment_txn_id' => $jsonObj->id]; 
                echo json_encode($output); 
            }else{ 
                http_response_code(500); 
                echo json_encode(['error' => 'Transaction has been failed!']); 
            } 
        } 
    }
    // -------------- SIGNUP PAYMENT INIT ------------- //

    // -------------- SIGNUP PAYMENT PROCESSOR ------------- //
    public function payments($id){
        if(!session()->has('id')){
            $system_currency        = DB::table('system_settings')->where('type', 'system_currency')->get()->first()->description;
            $paypal_mode            = DB::table('system_settings')->where('type', 'paypal_mode')->get()->first()->description;
            $paypal_email           = DB::table('system_settings')->where('type', 'paypal_email')->get()->first()->description;
            $site_title             = DB::table('system_settings')->where('type', 'system_name')->get()->first()->description;
            
            $site_url               = URL::to('/');

            $txn_data               = DB::table('users_business_txns')->where('users_business_txns_id', $id)->get()->first();
            $users_business         = DB::table('users_business')->where('users_business_id', $txn_data->users_business_id)->get()->first();
            $packages               = DB::table('packages')->where('packages_id', $txn_data->packages_id)->get()->first();

            $subscription_period    = 1;
            
            $user_id = $txn_data->users_business_id;
            $payment = $txn_data->paid_amount;        

            if($paypal_mode == 'live'){
                $paypal_url = "https://www.paypal.com/cgi-bin/webscr";
            } else { 
                $paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
            }

            if($txn_data->payment_gateways == 'Paypal'){
                echo '
                    <div class="row">
                        <div class="col margin-top col-md-12">
                            <div class="row min-bottom-margin">
                                <div class="col col-xs-12">
                                    <form action="'.$paypal_url.'" method="post" class="paypal-form" target="_top" id="paypal_form_recurring">
                                        <input type="hidden" name="cmd" value="_xclick-subscriptions">
                                        <input type="hidden" name="business" value="'.$paypal_email.'">
                                        <input type="hidden" name="lc" value="US">
                                        <input type="hidden" name="item_name" value="'.$site_title.' :: '.$packages->name.' Subscription">
                                        <input type="hidden" name="currency_code" value="USD">
                                        <input type="hidden" name="no_note" value="1">
                                        <input type="hidden" name="no_shipping" value="1">
                                        <input type="hidden" name="custom" value="">
                                        <input type="hidden" name="src" value="1">
                                        
                                        <input type="hidden" name="a3" value="'.$payment.'"> 

                                        <!-- amount gets set dynamically -->
                                        <input type="hidden" name="p3" value="'.$subscription_period.'">
                                        <input type="hidden" name="t3" value="M">
                                        <input type="hidden" name="return" data-type="success" value="'. $site_url .'/business/payments_callback/success/'.$id.'">
                                        <input type="hidden" name="cancel_return" data-type="cancel" value="'. $site_url .'/business/payments_callback/cancel/'.$id.'">
                                        <input type="hidden" name="notify_url" value="'. $site_url .'/business/payments_callback/ipn_notify/'.$id.'">
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <script type="text/javascript"> document.getElementById("paypal_form_recurring").submit(); </script>
                ';
            } else if($txn_data->payment_gateways == 'Stripe'){
                $data['STRIPE_API_KEY']             =   DB::table('system_settings')->where('type', 'STRIPE_API_KEY')->get()->first()->description;
                $data['STRIPE_PUBLISHABLE_KEY']     =   DB::table('system_settings')->where('type', 'STRIPE_PUBLISHABLE_KEY')->get()->first()->description;
                $data['system_currency']            =   $system_currency;  
                
                $data['itemName']                   =   $site_title.' :: '.$packages->name.' Subscription'; 
                $data['users_business']             =   $users_business; 
                $data['itemPrice']                  =   $payment;  
                $data['id']                         =   $id;
                return view('business.payments.stripe', $data); exit;
            } else { 
                Session::flash('error', ' Invalid Payment Processor. Please contact admin.'); 
                return redirect('business/signup');
            }
        } else {
            return redirect('business/dashboard');
        }
    }
    // -------------- SIGNUP PAYMENT PROCESSOR ------------- //

    // -------------- SIGNUP PAYMENT PROCESSOR CALLBACK------------- //
    public function payments_callback($type, $id){
        if(!session()->has('id')){
            $txn_data = DB::table('users_business_txns')->where('users_business_txns_id', $id)->get()->first();
            $users_business = DB::table('users_business')->where('users_business_id', $txn_data->users_business_id)->get()->first();
            $packages = DB::table('packages')->where('packages_id', $txn_data->packages_id)->get()->first();

            if($txn_data->payment_gateways == 'Paypal'){
                if($type == 'success'){
                    $update_business['packages_id']                = $txn_data->packages_id;
                    $update_business['status']                     = 'Active';
                    $update_business['subscription_start_date']    = date("Y-m-d H:i:s");
                    $update_business['subscription_end_date']       = date("Y-m-d H:i:s", strtotime($update_business['subscription_start_date']. ' + 1 months'));
                    $update_data = DB::table('users_business')->where('users_business_id', '=', $users_business->users_business_id)->update($update_business);

                    $update_business_txns['transactions_status']        = 'Completed';
                    $update_business_txns['gateway_status']             = 'Success';
                    $update_business_txns['subscription_start_date']    = date("Y-m-d H:i:s");
                    $update_business_txns['subscription_end_date']      = date("Y-m-d H:i:s", strtotime($update_business_txns['subscription_start_date']. ' + 1 months'));
                    $update_data = DB::table('users_business_txns')->where('users_business_txns_id', '=', $id)->update($update_business_txns);

                    Session::flash('success', ' Your payment is recieved. Please login to your account.'); 
                    return redirect('business');
                } else if($type == 'ipn_notify'){
                    $update_business['packages_id']                = $txn_data->packages_id;
                    $update_business['status']                     = 'Active';
                    $update_business['subscription_start_date']    = date("Y-m-d H:i:s");
                    $update_business['subscription_end_date'] = date("Y-m-d H:i:s", strtotime($update_business['subscription_start_date']. ' + 1 months'));
                    $update_data = DB::table('users_business')->where('users_business_id', '=', $users_business->users_business_id)->update($update_business);

                    $update_business_txns['transactions_status']        = 'Completed';
                    $update_business_txns['gateway_status']             = 'Success';
                    $update_business_txns['subscription_start_date']    = date("Y-m-d H:i:s");
                    $update_business_txns['subscription_end_date']      = date("Y-m-d H:i:s", strtotime($update_business_txns['subscription_start_date']. ' + 1 months'));
                    $update_data = DB::table('users_business_txns')->where('users_business_txns_id', '=', $id)->update($update_business_txns);

                    Session::flash('success', ' Your payment is recieved. IPN Callback.'); 
                    return redirect('business');
                } else if($type == 'cancel'){
                    Session::flash('error', ' User cancelled payment.'); 
                    return redirect('business');
                } else {
                    Session::flash('error', ' Oops! Something went wrong.'); 
                    return redirect('business');
                }
            } else if($txn_data->payment_gateways == 'Stripe'){
                if($type == 'success'){
                    Session::flash('success', ' Your payment is recieved. Please login to your account.'); 
                    return redirect('business');
                } else {
                    Session::flash('error', ' Oops! Something went wrong.'); 
                    return redirect('business');
                }
            } else { 
                Session::flash('error', ' Invalid Payment Processor. Please contact admin.'); 
                return redirect('business/signup');
            }
        } else {
            return redirect('business/dashboard');
        }
    }
    // -------------- SIGNUP PAYMENT PROCESSOR CALLBACK------------- //

    // -------------- LOGOUT ------------- //
    public function logout(Request $request){
        $request->session()->flush();
        return redirect('/');
    }
    // -------------- LOGOUT ------------- //

    // ------------- DASHBOARD -------------- //
    public function dashboard(){
        if(session()->has('id')){
            $users_business_data            = DB::table('users_business')->where('users_business_id', session('id'))->get()->first();
            $packages_data                  = DB::table('packages')->where('packages_id', $users_business_data->packages_id)->get()->first();
            
            $my_venues                      = number_format(DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->count());
            $my_venues_ids                  = DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->get();
            $my_venues_ids_array            = json_decode(json_encode($my_venues_ids), true);

            $total_venues_claimed           = number_format(DB::table('venues_claimed')->whereIn('venues_id', $my_venues_ids_array)->count());
            $total_venues                   = DB::table('venues')->where('users_business_id', session('id'))->count();
            $total_active_users_customers   = DB::table('users_customers')->where('status', 'Active')->count();
            $total_venues_visits            = number_format(DB::table('venues_visits')->whereIn('venues_id', $my_venues_ids_array)->count());
            
            $recent_venues_visits           = DB::table('venues_visits')->whereIn('venues_id', $my_venues_ids_array)->orderBy("venues_visits_id", "DESC")->take(5)->get();

            $total_claims_1                 = DB::table('venues_claimed')->whereMonth('claimed_date', 1)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_2                 = DB::table('venues_claimed')->whereMonth('claimed_date', 2)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_3                 = DB::table('venues_claimed')->whereMonth('claimed_date', 3)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_4                 = DB::table('venues_claimed')->whereMonth('claimed_date', 4)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_5                 = DB::table('venues_claimed')->whereMonth('claimed_date', 5)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_6                 = DB::table('venues_claimed')->whereMonth('claimed_date', 6)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_7                 = DB::table('venues_claimed')->whereMonth('claimed_date', 7)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_8                 = DB::table('venues_claimed')->whereMonth('claimed_date', 8)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_9                 = DB::table('venues_claimed')->whereMonth('claimed_date', 9)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_10                = DB::table('venues_claimed')->whereMonth('claimed_date', 10)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_11                = DB::table('venues_claimed')->whereMonth('claimed_date', 11)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_claims_12                = DB::table('venues_claimed')->whereMonth('claimed_date', 12)->whereIn('venues_id', $my_venues_ids_array)->count();

            $total_visits_1                 = DB::table('venues_visits')->whereMonth('date_added', 1)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_2                 = DB::table('venues_visits')->whereMonth('date_added', 2)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_3                 = DB::table('venues_visits')->whereMonth('date_added', 3)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_4                 = DB::table('venues_visits')->whereMonth('date_added', 4)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_5                 = DB::table('venues_visits')->whereMonth('date_added', 5)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_6                 = DB::table('venues_visits')->whereMonth('date_added', 6)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_7                 = DB::table('venues_visits')->whereMonth('date_added', 7)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_8                 = DB::table('venues_visits')->whereMonth('date_added', 8)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_9                 = DB::table('venues_visits')->whereMonth('date_added', 9)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_10                = DB::table('venues_visits')->whereMonth('date_added', 10)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_11                = DB::table('venues_visits')->whereMonth('date_added', 11)->whereIn('venues_id', $my_venues_ids_array)->count();
            $total_visits_12                = DB::table('venues_visits')->whereMonth('date_added', 12)->whereIn('venues_id', $my_venues_ids_array)->count();
                
            $total_events                   = DB::table('events')->where('users_business_id', session('id'))->count();
            $my_events_ids                  = DB::table('events')->select('events_id')->where('users_business_id', session('id'))->get();
            $my_events_ids_array            = json_decode(json_encode($my_events_ids), true);
            $total_events_visits            = number_format(DB::table('events_visits')->whereIn('events_id', $my_events_ids_array)->count());
            
            $recent_events_visits           = DB::table('events_visits')->whereIn('events_id', $my_events_ids_array)->orderBy("events_visits_id", "DESC")->take(5)->get();

            $total_events_visits_1                 = DB::table('events_visits')->whereMonth('date_added', 1)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_2                 = DB::table('events_visits')->whereMonth('date_added', 2)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_3                 = DB::table('events_visits')->whereMonth('date_added', 3)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_4                 = DB::table('events_visits')->whereMonth('date_added', 4)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_5                 = DB::table('events_visits')->whereMonth('date_added', 5)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_6                 = DB::table('events_visits')->whereMonth('date_added', 6)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_7                 = DB::table('events_visits')->whereMonth('date_added', 7)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_8                 = DB::table('events_visits')->whereMonth('date_added', 8)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_9                 = DB::table('events_visits')->whereMonth('date_added', 9)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_10                = DB::table('events_visits')->whereMonth('date_added', 10)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_11                = DB::table('events_visits')->whereMonth('date_added', 11)->whereIn('events_id', $my_events_ids_array)->count();
            $total_events_visits_12                = DB::table('events_visits')->whereMonth('date_added', 12)->whereIn('events_id', $my_events_ids_array)->count();

            return view('business.dashboard', compact('users_business_data', 'packages_data', 'total_venues_claimed','total_venues', 'total_active_users_customers', 'total_venues_visits', 'recent_venues_visits', 'total_events', 'total_events_visits', 'recent_events_visits',
                'total_claims_1',
                'total_claims_2',
                'total_claims_3',
                'total_claims_4',
                'total_claims_5',
                'total_claims_6',
                'total_claims_7',
                'total_claims_8',
                'total_claims_9',
                'total_claims_10',
                'total_claims_11',
                'total_claims_12',

                'total_visits_1',
                'total_visits_2',
                'total_visits_3',
                'total_visits_4',
                'total_visits_5',
                'total_visits_6',
                'total_visits_7',
                'total_visits_8',
                'total_visits_9',
                'total_visits_10',
                'total_visits_11',
                'total_visits_12',

                'total_events_visits_1',
                'total_events_visits_2',
                'total_events_visits_3',
                'total_events_visits_4',
                'total_events_visits_5',
                'total_events_visits_6',
                'total_events_visits_7',
                'total_events_visits_8',
                'total_events_visits_9',
                'total_events_visits_10',
                'total_events_visits_11',
                'total_events_visits_12'
            ));
        } else {
            return redirect('/');
        }
    }
    // ------------- DASHBOARD -------------- //


    // ------------- MANAGE VENUE BOOKINGS -------------- //
    public function venue_bookings(){
        if (session()->has('id')) {
            $my_venues                      = number_format(DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->count());
            $my_venues_ids                  = DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->get();
            $my_venues_ids_array            = json_decode(json_encode($my_venues_ids), true);

            $total_venues_bookings          = number_format(DB::table('venues_bookings')->whereIn('venues_id', $my_venues_ids_array)->count());
            $fetch_data                     = DB::table('venues_bookings')->orderBy('venues_bookings_id','DESC')->whereIn('venues_id', $my_venues_ids_array)->get();
            
            return view('business.venue_bookings', compact('fetch_data', 'total_venues_bookings'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUE BOOKINGS -------------- //

    // ------------- MANAGE VENUE BOOKINGS STATUS -------------- //
    // public function venue_bookings_status($id, $status){
    //     if (session()->has('id')) {
    //         if($status == 'Deleted'){
    //             DB::table('venues_bookings')->where('venues_bookings_id', $id)->delete();
    //             Session::flash('error', ' Data deleted successfully!'); 
    //         } else {
    //             $update_array['status'] = $status;
    //             $update_data = DB::table('venues_bookings')->where('venues_bookings_id', '=', $id)->update($update_array);
    //             Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
    //         }

    //         return redirect('business/venue_bookings');
    //     } else {
    //         return redirect('/');
    //     }
    // }
    public function venue_bookings_status($id, $status) {
        if (session()->has('id')) {
            $booking = DB::table('venues_bookings')->where('venues_bookings_id', $id)->first();
    
            if (!$booking) {
                Session::flash('error', 'Booking not found.'); 
                return redirect('business/venue_bookings');
            }
    
            // Keep track of the previous status for email condition
            $previousStatus = $booking->status;
    
            // Update booking status
            $update_array['status'] = $status;
            $update_data = DB::table('venues_bookings')->where('venues_bookings_id', $id)->update($update_array);
    
            if ($status == 'Accepted' && $previousStatus != 'Accepted') {
                // Retrieve venue information
                $venue = DB::table('venues')->where('venues_id', $booking->venues_id)->first();  
    
                if (!$venue) {
                    Session::flash('error', 'Venue not found.'); 
                    return redirect('business/venue_bookings');
                }
    
                // Send email to the user only if the status changed to 'Accepted'
                $user = DB::table('users_customers')->where('users_customers_id', $booking->users_customers_id)->first();
    
                if ($user) {
                    $details = [
                        'user_name' => $user->username,
                        'venue_name' => $venue->name,
                    ];
    
                    // Assuming you have an email template in the database for booking acceptance
                    $template = DB::table('email_templates')->where('type', 'venue_booking')->first();
    
                    if (!$template) {
                        Session::flash('error', 'Email template not found.'); 
                        return redirect('business/venue_bookings');
                    }
    
                    $templateBody = str_replace('{user_name}', $details['user_name'], $template->body);
                    $templateBody = str_replace('{venue_name}', $details['venue_name'], $templateBody);
    
                    // Replace tags in the template with actual data
                    $templateBody = str_replace('{user_name}', $user->username, $templateBody);
                    $templateBody = str_replace('{venue_name}', $venue->name, $templateBody);
    
                    $details = [
                        "title" => $template->subject,
                        "body" => $templateBody
                    ];
    
                    // Send email with the modified template
                    $otpSended = Mail::to($user->email)->send(new SendMail($details));
    
                    Session::flash('success', 'Booking status updated to ' . $update_array['status'] . '. Email sent.'); 
                } else {
                    Session::flash('error', 'User not found.'); 
                }
            } elseif ($status == 'Deleted') {
                // Delete the booking
                DB::table('venues_bookings')->where('venues_bookings_id', $id)->delete();
                Session::flash('error', 'Data deleted successfully!'); 
            } else {
                // Update booking status for other cases
                Session::flash('success', 'Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }
    
            return redirect('business/venue_bookings');
        } else {
            return redirect('/');
        }
    }
    
    
    
    

    // ------------- MANAGE VENUE BOOKINGS STATUS -------------- //
        // Special Venue Discounts Requests
        public function discount_requests(){
            if (session()->has('id')) {
                $fetch_data = DB::table('venues_claimed')
                                ->where('status', '!=', 'Expired')
                                ->orderBy('venues_claimed_id', 'DESC')
                                ->get();
                
                return view('business.special_offers', compact('fetch_data'));
            } else {
                return redirect('/');   
            }
        }
            public function discount_request_status($id, $status){
        if (session()->has('id')) {
            if($status == 'Deleted'){
                DB::table('venues_claimed')->where('venues_claimed_id', $id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } else {
                $update_array['status'] = $status;
                $update_data = DB::table('venues_claimed')->where('venues_claimed_id', '=', $id)->update($update_array);
                Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }

            return redirect('business/discount_requests');
        } else {
            return redirect('/');
        }
    }    
    public function expire_claims()     
    {
        $currentTime = Carbon::now();

        $pendingRows = DB::table('venues_claimed')
            ->where('status', 'Pending')
            ->get();

        foreach ($pendingRows as $row) {
            $claimedDate = Carbon::parse($row->claimed_date);

            // Calculate the time difference
            $timeDifference = $currentTime->diffInHours($claimedDate);

            // If the time difference is more than 24 hours, update status to "Expired"
            if ($timeDifference > 24) {
                DB::table('venues_claimed')
                    ->where('venues_claimed_id', $row->venues_claimed_id)
                    ->update(['status' => 'Expired']);
            }
        }

        return response()->json(['message' => 'Status updated successfully']);
    }
        
        // Special Venue Discounts Requests
    // ---------------Delete Venue Images---------------------
    public function delete($id)
    {
        // Find the image by ID
        $image = DB::table('venues_images')->where('venues_images_id', $id)->first();
    
        if ($image) {
            // Remove image file
            if (file_exists(public_path($image->name))) {
                unlink(public_path($image->name));
            }
    
            // Delete image from the database
            DB::table('venues_images')->where('venues_images_id', $id)->delete();
    
            return response()->json(['success' => 'Image deleted successfully.'],200);
        }
    
        return response()->json(['error' => 'Image not found.'], 404);
    }
    // ---------------Delete Venue Images---------------------
        // ------------- MANAGE EVENT BOOKINGS STATUS -------------- //
    public function event_bookings_status($id, $status){
        if (session()->has('id')) {
            if($status == 'Deleted'){
                DB::table('event_bookings')->where('event_booking_id', $id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } else {
                $update_array['status'] = $status;
                $update_data = DB::table('event_bookings')->where('event_booking_id', '=', $id)->update($update_array);
                Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }

            return redirect('business/event_booking');
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENT BOOKINGS STATUS -------------- //

    // ------------- MANAGE VENUE CHAT -------------- //
    public function venues_chat($id){
        if (session()->has('id')) {
            return view('business.venues_chat', compact('id'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUE CHAT -------------- //
    
    
    // ------------- MANAGE EVENT CHAT -------------- //
       public function events_chat($id){
        if (session()->has('id')) {
            return view('business.events_chat', compact('id'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENT CHAT -------------- //

    // ------------- MANAGE VENUES -------------- //
    public function manage_venues(){
        if (session()->has('id')) {
            $fetch_data = db::table('venues')->where('users_business_id', session('id'))->where('status', '!=','Deleted')->orderBy('venues_id', 'DESC')->get();
            return view('business.manage_venues', compact('fetch_data'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUES -------------- //

    // ------------- MANAGE VENUES ADD -------------- //
    public function manage_venues_add(){
        if (session()->has('id')) {
            $users_business = db::table('users_business')->where('users_business_id', session('id'))->where('status', '!=','Deleted')->orderBy('users_business_id', 'DESC')->get();
            return view('business.manage_venues_add', compact('users_business'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUES ADD -------------- //

    // ------------- MANAGE VENUES SAVE -------------- //
    public function manage_venues_save(Request $request){
        if(session()->has('id')){
            // dd($request->all());
            // exit();
            if(isset($request->special_offers)){
            $insert_array['special_offers'] = $request->special_offers;          
            }
            $insert_array['users_business_id'] = $request->users_business_id;
            $insert_array['name'] = $request->name;
            $insert_array['capacity'] = $request->capacity;
            $insert_array['location'] = $request->location;
            $insert_array['longitude'] = $request->longitude;
            $insert_array['lattitude'] = $request->lattitude;
            $insert_array['google_place_id'] = $request->google_place_id;
            $insert_array['discount_percentage'] = $request->discount_percentage;
            $insert_array['website'] = $request->website;
            $insert_array['menu_link'] = $request->menu_link;
            $insert_array['phone_number'] = $request->phone_number;
            $insert_array['description'] = $request->description;
            $insert_array['important_info'] = $request->important_info;
            $insert_array['restaurant_note'] = $request->restaurant_note;
            $insert_array['status'] = $request->status;
            $insert_data_id = DB::table('venues')->insertGetId($insert_array);
            $id = $insert_data_id;
            if(isset($_REQUEST['venue_type'])) {
                $venueTypes = $_REQUEST['venue_type'];

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_type"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_music'])) {
                $venueTypes = $_REQUEST['venues_music'];   

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_music"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_budget'])) {
                $venueBudget = $_REQUEST['venues_budget'];
            
                foreach($venueBudget as $venue_budget) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venue_budget,
                        'keyword_type' => "venues_budget"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_cusine'])) {
                $venueTypes = $_REQUEST['venues_cusine'];

                foreach($venueTypes as $venueType) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueType,
                        'keyword_type' => "venues_cusine"
                    ]);
                }
            }
            if(isset($_REQUEST['venues_food'])) {
                $venueFoodArray = $_REQUEST['venues_food'];
                foreach($venueFoodArray as $venueFood) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $venueFood,
                        'keyword_type' => "venues_food"
                    ]);
                }
            }
            if(isset($_REQUEST['payment_method'])) {
                $payment_method = $_REQUEST['payment_method'];
                foreach($payment_method as $method) {
                    DB::table('venues_keywords')->insert([
                        'venues_id' => $id,
                        'keyword_value' => $method,
                        'keyword_type' => "payment_method"
                    ]);
                }
            }         
            if ($request->has('hours')) {
                $hours = $request->hours;

                DB::beginTransaction();

                $transactionSuccess = true;

                foreach ($hours as $day => $dayHours) {
                    $startHour = $dayHours['start'];
                    $closeHour = $dayHours['close'];

                    $insertResult = DB::table('venues_hours')->insert([
                        'venues_hours_days' => $day,
                        'venues_id' => $id,
                        'start_hours' => $startHour,
                        'close_hours' => $closeHour
                    ]);

                    if (!$insertResult) {
                        $transactionSuccess = false;
                        break; 
                    }
                }
            
                if ($transactionSuccess) {
                    DB::commit();
                } else {
                    DB::rollback();

                }
            }

            if ($request->hasfile('images')) {
                foreach($request->file('images') as $file){
                    if ($file->isValid()) {
                        $path = public_path('uploads/venues/');
                        //$image_name = $insert_data_id . '-' .time() . rand() . '-' . $file->getClientOriginalName();
                        $image_name = $insert_data_id . '-' .time() . rand() . '.jpeg';
                        if ($file->move($path, $image_name)) {
                            $images_array['venues_id'] = $id;
                            $images_array['name'] = 'uploads/venues/' . $image_name;
                            $images_array['status'] = 'Active';
                            $insert_data_id = DB::table('venues_images')->insert($images_array);
                        }
                    }
                }
            }

            if($insert_data_id){
                Session::flash('success', ' Data Added successfully'); 
                return redirect('business/manage_venues');
            } else {
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('business/manage_venues');
            }
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUES SAVE -------------- //

    // ------------- MANAGE VENUES VIEW -------------- //
    public function manage_venues_views($id){
        if (session()->has('id')) {
            $fetch_data = db::table('venues')->where('users_business_id', session('id'))->where('venues_id', '=', $id)->orderBy('venues_id', 'DESC')->get();
            return view('business.manage_venues_views', compact('fetch_data'));
        } else {
            return view('business.login');
        }
    }
    // ------------- MANAGE VENUES VIEW -------------- //

    // ------------- UPDATE VENUES -------------- //
    public function manage_venues_update($id, Request $request){
        if(session()->has('id')){
            if(!empty($id)){
                $update_array['name'] = $request->name;
                $update_array['capacity'] = $request->capacity;
                $update_array['location'] = $request->location;
                $update_array['longitude'] = $request->longitude;
                $update_array['lattitude'] = $request->lattitude;
                $update_array['google_place_id'] = $request->google_place_id;
                $update_array['open_hours'] = $request->open_hours;
                $update_array['close_hours'] = $request->close_hours;
                $update_array['discount_percentage'] = $request->discount_percentage;
                $update_array['website'] = $request->website;
                $update_array['menu_link'] = $request->menu_link;
                $update_array['phone_number'] = $request->phone_number;
                $update_array['description'] = $request->description;
                $update_array['important_info'] = $request->important_info;
                $update_array['restaurant_note'] = $request->restaurant_note;

                if(isset($_REQUEST['venue_type'])) {
                    $venueTypesArray = $_REQUEST['venue_type'];
                    $venueId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_type')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_type')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'venues_type'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venues_music'])) {
                    $venueMusicArray = $_REQUEST['venues_music'];   
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue music types from the database
                    $existingVenueMusic = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_music')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue music types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueMusic, $venueMusicArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_music')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue music types
                    foreach($venueMusicArray as $venueMusic) {
                        // Check if the venue music type already exists in the database
                        if (!in_array($venueMusic, $existingVenueMusic)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueMusic,
                                'keyword_type' => 'venues_music'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venues_budget'])) {
                    $venueBudgetArray = $_REQUEST['venues_budget'];   
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue budget types from the database
                    $existingVenueBudget = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_budget')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue budget types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueBudget, $venueBudgetArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_budget')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue budget types
                    foreach($venueBudgetArray as $venueBudget) {
                        // Check if the venue budget type already exists in the database
                        if (!in_array($venueBudget, $existingVenueBudget)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueBudget,
                                'keyword_type' => 'venues_budget'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venue_cuisine'])) {
                    $venueCuisineArray = $_REQUEST['venue_cuisine'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue cuisine types from the database
                    $existingVenueCuisine = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_cusine')
                        ->pluck('keyword_value')     
                        ->toArray();     
                
                    // Compare submitted venue cuisine types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueCuisine, $venueCuisineArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_cusine')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue cuisine types
                    foreach($venueCuisineArray as $venueCuisine) {
                        // Check if the venue cuisine type already exists in the database
                        if (!in_array($venueCuisine, $existingVenueCuisine)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueCuisine,
                                'keyword_type' => 'venues_cusine'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['venue_food'])) {
                    $venueFoodArray = $_REQUEST['venue_food'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing venue food types from the database
                    $existingVenueFood = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'venues_food')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue food types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueFood, $venueFoodArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'venues_food')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue food types
                    foreach($venueFoodArray as $venueFood) {
                        // Check if the venue food type already exists in the database
                        if (!in_array($venueFood, $existingVenueFood)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $venueFood,
                                'keyword_type' => 'venues_food'
                            ]);
                        }
                    }
                }
                
                if(isset($_REQUEST['payment_method'])) {
                    $paymentMethodArray = $_REQUEST['payment_method'];
                    $venueId = $id; // Assuming $id contains the venue ID
                
                    // Retrieve existing payment methods from the database
                    $existingPaymentMethods = DB::table('venues_keywords')
                        ->where('venues_id', $venueId)
                        ->where('keyword_type', 'payment_method')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted payment methods with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingPaymentMethods, $paymentMethodArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('venues_keywords')
                            ->where('venues_id', $venueId)
                            ->where('keyword_type', 'payment_method')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted payment methods
                    foreach($paymentMethodArray as $paymentMethod) {
                        // Check if the payment method already exists in the database
                        if (!in_array($paymentMethod, $existingPaymentMethods)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('venues_keywords')->insert([
                                'venues_id' => $venueId,
                                'keyword_value' => $paymentMethod,
                                'keyword_type' => 'payment_method'
                            ]);
                        }
                    }
                }
    
                if ($request->has('hours')) {
                    // Retrieve the existing hours data for the specified venue ID
                    $existingHours = DB::table('venues_hours')
                        ->select('venues_hours_id', 'venues_hours_days', 'start_hours', 'close_hours')
                        ->where('venues_id', $id)
                        ->where('status', 'Active')
                        ->get();
                
                    if (count($request->hours) !== count($existingHours)) {
                        // Handle mismatch error here, such as returning a response or throwing an exception
                    }
                    $success = true;
                    // Begin a transaction
                    DB::beginTransaction();
                
                    // Update the existing hours data
                    foreach ($existingHours as $index => $hour) {   
                        // Initialize startHour and closeHour with existing values as defaults
                        $startHour = $hour->start_hours;
                        $closeHour = $hour->close_hours;           
                    
                        // Check if the corresponding data exists in the request
                        if (isset($request->hours[$index + 1])) {
                            // Override with request data if available
                            $startHour = $request->hours[$index + 1]['start'] ?? $startHour;
                            $closeHour = $request->hours[$index + 1]['close'] ?? $closeHour;
                        }
                    
                        // Perform the update query
                        $updateResult = DB::table('venues_hours')
                            ->where('venues_hours_id', $hour->venues_hours_id)
                            ->update([
                                'start_hours' => $startHour,
                                'close_hours' => $closeHour,         
                            ]);
                    
                        // Update $success variable if update is successful
                        $success = $success && $updateResult;   
                    }
                
                    // Commit the transaction
                    DB::commit();
                }
                
    
                if(isset($_POST['Delete'])){
                    $update_array['status'] = 'Deleted';
                } else { 
                    $update_array['status'] = $request->status;
                }
    
                $update_data = DB::table('venues')->where('venues_id', '=', $id)->update($update_array);
                
                // Introduce a variable to track the success of either update operation
                $success = $update_data; // Set it to the result of venue data update
    
                if ($request->hasFile('images')) {
                    foreach ($request->file('images') as $file) {  
                        if ($file->isValid()) {
                            // Generate a unique image name
                            $image_name = $id . '-' . uniqid() . '.' . $file->getClientOriginalExtension();
                            
                            // Move the image to the desired path
                            $path = public_path('uploads/venues/');
                            if ($file->move($path, $image_name)) {
                                // Save the new image information to the database
                                $images_array = [
                                    'venues_id' => $id,
                                    'name' => 'uploads/venues/' . $image_name,
                                    'status' => 'Active'
                                ];
                                
                                $update_images = DB::table('venues_images')->insert($images_array);
                                
                                // Update $success variable if image insertion is successful
                                $success = $success || $update_images;
                            }
                        }
                    }
                }         
    
                // Redirect back to the edit page after the update
    
                if($success){
                    Session::flash('success', 'Data Updated successfully'); 
                } else {
                    Session::flash('error', 'Oops! Something went wrong'); 
                }
                return redirect('business/manage_venues');
            } else {
                Session::flash('error', 'No Data Found'); 
                return redirect('business/manage_venues');
            }
        } else {
            return redirect('business');
        }
    }
    // ------------- UPDATE VENUES -------------- //

    // ------------- MANAGE DEALS -------------- //
    public function manage_deals(){
        if (session()->has('id')) {
            $my_venues                      = number_format(DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->count());
            $my_venues_ids                  = DB::table('venues')->select('venues_id')->where('users_business_id', session('id'))->get();
            $my_venues_ids_array            = json_decode(json_encode($my_venues_ids), true);

            $total_venues_claimed           = number_format(DB::table('venues_claimed')->whereIn('venues_id', $my_venues_ids_array)->count());
            $fetch_data                     = DB::table('venues_claimed')->whereIn('venues_id', $my_venues_ids_array)->get();
            
            return view('business.manage_deals', compact('fetch_data', 'total_venues_claimed'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE DEALS -------------- //

    // ------------- MANAGE DEALS STATUS -------------- //
    public function manage_deals_status(Request $request){
        if (session()->has('id')) {
            if($request->status == 'Deleted'){
                DB::table('venues_claimed')->where('venues_claimed_id', $request->id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } else {
                $update_array['status'] = $request->status;
                $update_data = DB::table('venues_claimed')->where('venues_claimed_id', '=', $request->id)->update($update_array);
                Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }

            return redirect('business/manage_deals');
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE DEALS STATUS -------------- //     

    // ------------- MANAGE EVENTS -------------- //
    public function manage_events($param1 = '', $param2 = ''){
        if (session()->has('id')) {
            if($param1 == 'views'){
                $fetch_data = db::table('venues')->where('users_business_id', session('id'))->where('venues_id', '=', $param2)->orderBy('venues_id', 'DESC')->get();
                return view('business.manage_events_views', compact('fetch_data'));
            } else {
                $fetch_data = db::table('events')->where('users_business_id', session('id'))->where('status', '!=','Deleted')->orderBy('events_id', 'DESC')->get();
                return view('business.manage_events', compact('fetch_data'));
            }
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENTS -------------- //

    // ------------- MANAGE EVENTS ADD -------------- //
    public function manage_events_add(){
        if (session()->has('id')) {
            $users_business = db::table('users_business')->where('users_business_id', session('id'))->where('status', '!=','Deleted')->orderBy('users_business_id', 'DESC')->get();
            return view('business.manage_events_add', compact('users_business'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENTS ADD -------------- //

    // ------------- MANAGE VENUES SAVE -------------- //
    public function manage_events_save(Request $request){
        if(session()->has('id')){
            $insert_array['users_business_id'] = $request->users_business_id;
            $insert_array['name'] = $request->name;
            $insert_array['venue_name'] = $request->venue_name;
            $insert_array['location'] = $request->location;
            $insert_array['longitude'] = $request->longitude;
            $insert_array['lattitude'] = $request->lattitude;
            $insert_array['event_date'] = $request->event_date;
            $insert_array['event_start_time'] = $request->event_start_time;
            $insert_array['event_end_time'] = $request->event_end_time;
            $insert_array['discount_percentage'] = $request->discount_percentage;
            $insert_array['booking_percentage'] = $request->booking_percentage;
            $insert_array['no_of_tickets'] = $request->no_of_tickets;
            $insert_array['price_per_ticket'] = $request->price_per_ticket;
            $insert_array['drinking_pakage1p4'] = $request->drinking_pakage1p4;
            $insert_array['drinking_pakage2p4'] = $request->drinking_pakage2p4;
            $insert_array['drinking_pakage1p6'] = $request->drinking_pakage1p6;
            $insert_array['drinking_pakage2p6'] = $request->drinking_pakage2p6;
            $insert_array['website'] = $request->website;
            $insert_array['phone_number'] = $request->phone_number;
            $insert_array['description'] = $request->description;
            $insert_array['refund_policy'] = $request->refund_policy;
            $insert_array['date_added'] = date('Y-m-d H:i:s');
            $insert_array['status'] = $request->status;
            $insert_data_id = DB::table('events')->insertGetId($insert_array);
            $event_id = $insert_data_id;

            if(isset($_REQUEST['event_type'])) {
                $EventTypes = $_REQUEST['event_type'];

                foreach($EventTypes as $Type) {
                    DB::table('events_keywords')->insert([
                        'events_id' => $event_id,
                        'keyword_value' => $Type,
                        'keyword_type' => "event_exp"
                    ]);
                }
            }
            if(isset($_REQUEST['event_music'])) {
                $EventTypes = $_REQUEST['event_music'];

                foreach($EventTypes as $Type) {
                    DB::table('events_keywords')->insert([
                        'events_id' => $event_id,
                        'keyword_value' => $Type,
                        'keyword_type' => "event_music"
                    ]);
                }
            }

            if ($request->hasfile('images')) {
                foreach($request->file('images') as $file){
                    if ($file->isValid()) {
                        $path = public_path('uploads/events/');
                        $image_name = $event_id . '-' .time() . rand() . '-' . $file->getClientOriginalName();
                        if ($file->move($path, $image_name)) {
                            $images_array['events_id'] = $event_id;
                            $images_array['name'] = 'uploads/events/' . $image_name;
                            $images_array['status'] = 'Active';
                            $events_id = DB::table('events_images')->insert($images_array);
                        }
                    }
                }
            }

            if($insert_data_id){
                Session::flash('success', ' Data Added successfully'); 
                return redirect('business/manage_events');
            } else {
                Session::flash('error', ' Oops! something went wrong'); 
                return redirect('business/manage_events');
            }
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE VENUES SAVE -------------- //

    // ------------- MANAGE EVENTS VIEW -------------- //
    public function manage_events_views($id){
        if (session()->has('id')) {
            $fetch_data = db::table('events')->where('events_id', '=', $id)->orderBy('events_id', 'DESC')->get();
            return view('business.manage_events_views', compact('fetch_data'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENTS VIEW -------------- //

    // ------------- UPDATE VENUES -------------- //
    public function manage_events_update(Request $request ,$id){
        if(session()->has('id')){
            if(!empty($id)){
                $update_array['name'] = $request->name;
                $update_array['venue_name'] = $request->venue_name;
                $update_array['location'] = $request->location;
                $update_array['longitude'] = $request->longitude;
                $update_array['lattitude'] = $request->lattitude;
                $update_array['event_date'] = $request->event_date;
                $update_array['event_start_time'] = $request->event_start_time;
                $update_array['event_end_time'] = $request->event_end_time;
                $update_array['discount_percentage'] = $request->discount_percentage;
                $update_array['no_of_tickets'] = $request->no_of_tickets;
                $update_array['price_per_ticket'] = $request->price_per_ticket;
                $update_array['booking_percentage'] = $request->booking_percentage; 
                $update_array['drinking_pakage1p4'] = $request->drinking_pakage1p4;
                $update_array['drinking_pakage2p4'] = $request->drinking_pakage2p4;
                $update_array['drinking_pakage1p6'] = $request->drinking_pakage1p6;
                $update_array['drinking_pakage2p6'] = $request->drinking_pakage2p6;
                
                $update_array['website'] = $request->website;
                $update_array['phone_number'] = $request->phone_number;
                $update_array['description'] = $request->description;
                $update_array['refund_policy'] = $request->refund_policy;
                
                if(isset($_REQUEST['event_type'])) {
                    $venueTypesArray = $_REQUEST['event_type'];
                    $EventId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('events_keywords')
                        ->where('events_id', $EventId)
                        ->where('keyword_type', 'event_exp')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('events_keywords')
                            ->where('events_id', $EventId)
                            ->where('keyword_type', 'event_exp')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('events_keywords')->insert([
                                'events_id' => $EventId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'event_exp'
                            ]);
                        }
                    }
                }
                if(isset($_REQUEST['event_music'])) {
                    $venueTypesArray = $_REQUEST['event_music'];
                    $EventId = $id; // Assuming $items contains the venue ID
                
                    // Retrieve existing venue types from the database
                    $existingVenueTypes = DB::table('events_keywords')
                        ->where('events_id', $EventId)
                        ->where('keyword_type', 'event_music')
                        ->pluck('keyword_value')
                        ->toArray();
                
                    // Compare submitted venue types with existing ones
                    // Remove any values that are no longer selected
                    $valuesToRemove = array_diff($existingVenueTypes, $venueTypesArray);
                
                    // Remove deselected values from the database
                    if (!empty($valuesToRemove)) {
                        DB::table('events_keywords')
                            ->where('events_id', $EventId)
                            ->where('keyword_type', 'event_music')
                            ->whereIn('keyword_value', $valuesToRemove)
                            ->delete();
                    }
                
                    // Loop through the submitted venue types
                    foreach($venueTypesArray as $venueType) {
                        // Check if the venue type already exists in the database
                        if (!in_array($venueType, $existingVenueTypes)) {
                            // If it doesn't exist, insert it into the database
                            DB::table('events_keywords')->insert([
                                'events_id' => $EventId,
                                'keyword_value' => $venueType,
                                'keyword_type' => 'event_music'
                            ]);
                        }
                    }
                }
                
                if(isset($_POST['Delete'])){
                    $update_array['status'] = 'Deleted';
                } else { 
                    $update_array['status'] = $request->status;
                }
                $update_data = DB::table('events')->where('events_id', '=', $id)->update($update_array);

                if ($request->hasfile('images')) {
                    //DELETE OLD 
                    DB::table('events_images')->where('events_id', $id)->delete();
                    //DELETE OLD

                    //ADD NEW
                    foreach($request->file('images') as $file){
                        if ($file->isValid()) {
                            $path = public_path('uploads/events/');
                            $image_name = $id . '-' .time() . rand() . '-' . $file->getClientOriginalName();
                            if ($file->move($path, $image_name)) {
                                $images_array['events_id'] = $id;
                                $images_array['name'] = 'uploads/events/' . $image_name;
                                $images_array['status'] = 'Active';
                                $update_data = DB::table('events_images')->insert($images_array);
                            }
                        }
                    }
                    //ADD NEW
                }

                if($update_data){
                    Session::flash('success', ' Data Updated successfully'); 
                    return redirect('business/manage_events');
                } else {
                    Session::flash('error', ' Oops! something went wrong'); 
                    return redirect('business/manage_events');
                }
            } else {
                Session::flash('error', ' No Data Found'); 
                return redirect('business/manage_events');
            }
        } else {
            return redirect('/');
        }
    }
    // ------------- UPDATE VENUES -------------- //

    // ------------- MANAGE EVENTS BOOKINGS -------------- //
    public function events_tickets(){
        if (session()->has('id')) {
            $my_events                      = number_format(DB::table('events')->select('events_id')->where('users_business_id', session('id'))->count());
            $my_events_ids                  = DB::table('events')->select('events_id')->where('users_business_id', session('id'))->get();
            $my_events_ids_array            = json_decode(json_encode($my_events_ids), true);

            $total_events_bookings          = number_format(DB::table('event_bookings')->whereIn('events_id', $my_events_ids_array)->count());
            $fetch_data                     = DB::table('event_bookings')->orderBy('event_booking_id','DESC')->whereIn('events_id', $my_events_ids_array)->get();
            
            return view('business.events_tickets', compact('fetch_data', 'total_events_bookings'));
        } else {
            return redirect('/');
        }
    }
    public function event_bookings(){
        if (session()->has('id')) {
            $my_events                      = number_format(DB::table('events')->select('events_id')->where('users_business_id', session('id'))->count());
            $my_events_ids                  = DB::table('events')->select('events_id')->where('users_business_id', session('id'))->get();
            $my_events_ids_array            = json_decode(json_encode($my_events_ids), true);
            
            $total_events_bookings          = number_format(DB::table('event_bookings')->whereIn('events_id', $my_events_ids_array)->count());
            $fetch_data                     = DB::table('event_bookings')->orderBy('event_booking_id','DESC')->whereIn('events_id', $my_events_ids_array)->get();
            
            return view('business.event_booking', compact('fetch_data', 'total_events_bookings'));
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENTS BOOKINGS -------------- //

    // ------------- MANAGE EVENTS BOOKINGS STATUS -------------- //
    public function events_tickets_status($id, $status){
        if (session()->has('id')) {
            if($status == 'Deleted'){
                DB::table('events_tickets')->where('events_tickets_id', $id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } else {
                $update_array['status'] = $status;
                $update_data = DB::table('events_tickets')->where('events_tickets_id', '=', $id)->update($update_array);
                Session::flash('success', ' Data updated to status ' . $update_array['status'] . ' successfully!'); 
            }

            return redirect('business/events_tickets');
        } else {
            return redirect('/');
        }
    }
    // ------------- MANAGE EVENTS BOOKINGS STATUS -------------- //

    // ------------- ACCOUNT SETTINGS -------------- //
    public function account_settings(){
        if(session()->has('id')){
            $fetch_data = DB::table('users_business')->where('users_business_id',session('id'))->get();
            return view('business.account_settings',compact('fetch_data'));
        } else {
            return redirect('/');
        }
    }
    // ------------- ACCOUNT SETTINGS -------------- //
    
   

    // ------------- UPDATE ACCOUNT SETTINGS -------------- //
    public function account_settings_update(Request $req,$id){
        $insert=array();
        $insert['first_name'] = $req->first_name;
        $insert['email'] = $req->email;
        $insert['password'] = $req->password;
        
        if ($req->hasfile('image')) {
            $file = $req->file('image');
            if ($file->isValid()) {
                $ext = $file->extension();
                $path = public_path('uploads/users_business/');
                $prefix = 'user-' . md5(time());
                $img_name = $prefix . '.' . $ext;
                if ($file->move($path, $img_name)) {
                    $insert['user_image'] = 'uploads/users_business/' . $img_name;
                }
            }
        }

        if($req->password == $req->confirm_password){
            $a = DB::table('users_business')->where('users_business_id','=',$id)->update($insert);
            if ($a) {
                Session::flash('success', ' Profile Updated successfully'); 
                return redirect('business/account_settings');
            } else {
                Session::flash('error', ' oops! something went wrong'); 
                return redirect('business/account_settings');
            }
        } else {
            Session::flash('error', ' Password donot Match.'); 
            return redirect('business/account_settings');
        }
        
    }
    // ------------- UPDATE ACCOUNT SETTINGS -------------- //    
   
   
    // ------------- PAYMENT SETTINGS -------------- //
     public function payment_settings(){
        if(session()->has('id')){
            // $fetch_data = DB::table('payment_gateway')->where('users_business_id',session('id'))->get();
            $fetch_data = DB::table('payment_gateway')->get();
            return view('business.payment_settings',compact('fetch_data'));
        } else {
            return redirect('/');
        }
    }
    public function payment_settings_status($id, $status){
        if (session()->has('id')) {
            if($status == 'Inactive'){
                DB::table('payment_gateway')->where('payment_gateway_id', $id)->delete();
                Session::flash('error', ' Data deleted successfully!'); 
            } 
        } else {
            return redirect('/');
        }
    }
    public function payment_settings_fetch(Request $req){
        if (session()->has('id')) {
            if(!$req->filter){
                $users_business_payment_gateway = DB::table('users_business_payment_gateway')->where("users_business_id",session("id"))->orderBy('users_business_payment_gateway_id', 'DESC')->get();
                $filter='';
            } else {
                $users_business_payment_gateway = DB::table('users_business_payment_gateway')->where("users_business_id",session("id"))->where('status', $req->filter)->orderBy('users_business_payment_gateway_id', 'DESC')->get();
                $filter = $req->filter;
            }
            $fetch_data=[];
            foreach ($users_business_payment_gateway as $key => $single) {
                $single->payment_gateway=DB::table('payment_gateway')->where("payment_gateway_id",$single->payment_gateway_id)->first();
                $fetch_data[]=$single;
            }
            return response()->json(['fetch_data'=>$fetch_data,'filter'=>$filter,]);
        } else {return redirect('/');}
    }
    public function payment_settings_delete(Request $req){
        if($req->payment_gateway_id){
            $checkdata = DB::table('users_business_payment_gateway')->where('users_business_payment_gateway_id', $req->payment_gateway_id)->where('status', '!=','Deleted')->first();

            if($checkdata){
                $del=DB::table('users_business_payment_gateway')->where('users_business_payment_gateway_id', '=', $req->payment_gateway_id)->update(array( 'status' => 'Deleted'));
                if($del){
                    $response=["code"=>200,"status"=> "success","message"=> "Data Deleted successfully"];
                } else{
                    $response=["code"=>404,"status"=>"error","message"=>"Oops! Something went wrong."];
                }
            } else{
                $response=["code"=>404,"status"=>"error","message"=>"This record is already deleted in status."];
            }
        } else{
            $response=["code"=>404,"status"=>"error","message"=>"No Data Found."];
        }
        return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');

    }
    public function payment_settings_update(Request $req){
        $update_array['status'] = $req->status; 
        $updated = DB::table('users_business_payment_gateway')->where('users_business_payment_gateway_id', $req->payment_gateway_id)->update($update_array);
            if ($updated) {
                $response=["code"=>200,"status"=> "success","message"=> "Data Updated successfully"];
           } else{
                $response=["code"=>404,"status"=>"error","message"=>"Oops! Something went wrong."];
            }
      
          return response()
          ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
    }

    public function payment_gateway(){
        $fetch_data   =  DB::table('payment_gateway')->get();
        if (count($fetch_data)>0) {
        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $fetch_data;
        } else {
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "no data found.";
        }
        return response()
        ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
        ->header('Content-Type', 'application/json');
    }

    public function add_payment_gateway_data(Request $req){
        if (isset($req->users_business_id) && isset($req->payment_gateway_id)) {
            $save_data['users_business_id']     = $req->users_business_id;
            $save_data['payment_gateway_id']     = $req->payment_gateway_id;
            $Payment_gateway = DB::table('users_business_payment_gateway')->insertGetId($save_data);
            if ($Payment_gateway) {
                $response["code"] = 200;
                $response["status"] = "success";
                $response["message"] = "Payment Gateway Added";
           } else{
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "Oops! Something went wrong.";
            }
        } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = 'All fields are required';
        }
      
          return response()
          ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
          ->header('Content-Type', 'application/json');
    }
    // ------------- PAYMENT SETTINGS -------------- //

   // DOWNLOAD TICKET
   public function download_file($id)
   {
       $data = DB::table('event_bookings')->where('event_booking_id', $id)->first();
   
     
       $url = config('app.url'); 
      
       $filename = $data->event_ticket;
   
       $fileUrl = $url . 'public/' . $filename; 
   
       $fileContent = file_get_contents($fileUrl);
   
       return response($fileContent)
           ->header('Content-Type', 'application/pdf')
           ->header('Content-Disposition', 'attachment; filename="' . $filename . '"');
   }
   
   // DOWNLOAD TICKET

//    ---------------REFUND REQUEST-------------
public function refund_request(){
    if (session()->has('id')) {
      
        $get_data  = DB::table('refund_requests')->orderBy('refund_requests_id','DESC')->get();
        $fetch_data = [];
        foreach ($get_data as $key => $value) {
            $value->user_customer =  DB::table('users_customers')->where('users_customers_id',$value->users_customers_id)->first();
            $value->events =  DB::table('events')->where('events_id',$value->events_id)->first();
            $event_bookings =  DB::table('event_bookings')->where('event_booking_id',$value->event_booking_id)->first();
            if($event_bookings->user_business_id == session('id')){
                $value->event_bookings=$event_bookings;
            }
            $fetch_data[]=$value;
        }
        return view('business.refund_request', compact('fetch_data'));
    } else {
        return redirect('/');
    }
}
public function single_refund_request($id){
    if (session()->has('id')) {
      
        $data  = DB::table('refund_requests')->where('refund_requests_id',$id)->first();
            $fetch_data['user_customer'] =  DB::table('users_customers')->where('users_customers_id',$data->users_customers_id)->first();
            $fetch_data['event'] =  DB::table('events')->where('events_id',$data->events_id)->first();
            $event_bookings =  DB::table('event_bookings')->where('event_booking_id',$data->event_booking_id)->first();
            if($event_bookings->user_business_id == session('id')){
                $fetch_data['event_bookings']=$event_bookings;
            }
    if($data)
      $response["code"] = 200;
      $response["status"] = "success";
      $response["data"] = $data;

    }else {
      $response["code"] = 404;
      $response["status"] = "error";
      $response["message"] = "No data found";
    }
    return response()
    ->json(array( 'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
 
}
public function manage_refund_requests(Request $req){
    if (session()->has('id')){
        $upd_array['refunded_email'] = $req->refunded_email;
        $upd_array['refunded_date'] = $req->refunded_date;
        $upd_array['refunded_amount'] =$req->refunded_amount;
        $upd_array['bank_title'] = $req->bank_title;
        $upd_array['account_number'] = $req->account_number;
        $upd_array['refund_status'] = "Refunded";

        $update_data = DB::table('refund_requests')->where('refund_requests_id', $req->refund_requests_id)->update($upd_array);
        Session::flash('success', ' Amount Refunded successfully!'); 

        return redirect(route('refund_request'));
    } else {
        return redirect('/');       
    }
     
}

public function rejected_refund_request(Request $request,$id){
    if ($request->session()->has('id')) {
        $request_data      =  DB::table('refund_requests')->where('refund_requests_id', $id)->first();
        if ($request_data) {
            $event          =   DB::table('events')->where('events_id', $request_data->events_id)->first();
            $users_customer          =   DB::table('users_customers')->where('users_customers_id', $request_data->users_customers_id)->first();
            $onlyEmail          =   $users_customer->email;
            $refund_policy      =   $event->refund_policy;

            $details = [
              "title"=>"Refund Request",
              "body"=> $refund_policy,
              "note"=> "Dear Customer We regret to inform you that your request for a refund does not align with our established Refund Policy",
            ];            
            $mailSend      = Mail::to($onlyEmail)->send(new RefundMail($details));
            
            $UpdateRequest  = DB::table('refund_requests')->where('refund_requests_id', $id)->update(['refund_status' => 'Rejected']);
            Session::flash('success', 'Email sended successfully!'); 

            return redirect(route('refund_request'));
        } else {
            Session::flash('error', ' Invalid Email.'); 
            return redirect('business/forget_password');
        }  
    } else {
       
    }
}
//  Delete Events Images
public function delete_event_images($id)
{
    // Find the image by ID
    $image = DB::table('events_images')->where('events_images_id', $id)->first();  

    if ($image) {
        // Remove image file
        if (file_exists(public_path($image->name))) {
            unlink(public_path($image->name));
        }

        // Delete image from the database
        DB::table('events_images')->where('events_images_id', $id)->delete();

        return response()->json(['success' => 'Image deleted successfully.'],200);
    }

    return response()->json(['error' => 'Image not found.'], 404);
}
//    ---------------REFUND REQUEST-------------


      

    
}