<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Hash;


class CaptchaValidationController extends Controller
{
    public function index()
    {
        return view('form-with-captcha');
    }

    public function capthcaFormValidate(Request $request)
    {
        
        $code = $request->code;
        $hash = $request->hash;

        $tt =  Hash::check($code, $hash);
        if ($tt){
            return response()->json(['status'=> "Matched"]);
        }else{
            return response()->json(['status'=> "Incorrect"]);
        }

    }

    public function reloadCaptcha()
    {
        return response()->json(['captcha'=> captcha_src()]);
    }

    public function get_captcha()
    {
        $response = Http::get('https://eigix.net/morlaApp/captcha/api/');

        return response()->json([$response->object()]);
    }

}
