<?php
namespace App\Http\Controllers;
use Illuminate\Support\Facades\Mail;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Models\Student;
use App\Mail\SendMail;
use DB;
use Session;
Use \Carbon\Carbon;

class CompaniesController extends Controller{
    /* SEND NOTIFICATIONS */
    public function send_notification($data){
        DB::table('notifications')->insert($data);
    }
    /* SEND NOTIFICATIONS */

    // -------------- LOGIN PAGE ------------- //
    public function index(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else{
            return view('company.login');
        }
    }
    // -------------- LOGIN PAGE ------------- //
    
    // -------------- LOGIN AUTHENTICATION ------------- //
    public function login(Request $request){
        $validateData = $request->validate([
            'email' => 'required|email',
            'password' => 'required'
        ]);
        
        $postData = $request->all();
        $ifExists = DB::table('users_companies')->where('email', $postData['email'])->where('password', $postData['password'])->first();
        if(!empty($ifExists)){
            if ($ifExists->status != 'Pending') {
                $request->session()->put([
                    'id' => $ifExists->users_companies_id,
                    'user_image' => $ifExists->company_logo,
                    'company_name' => $ifExists->company_name,
                    'email' => $ifExists->email,
                ]);
                Session::flash('success', ' Logged in successfully.'); 
                return redirect('dashboard');
            } else {
                Session::flash('warning', 'Account is in pending state. Please contact admin to activate your account.'); 
            return redirect()->back();
            }
        } else {
            Session::flash('error', 'Invalid Email/Password'); 
            return redirect()->back();
        }
    }
    // -------------- LOGIN AUTHENTICATION ------------- //
    
    // -------------- FORGOT PASSWORD ------------- //
    public function forget_password(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else{
            return view('company.forget_password');
        }
    }
    // -------------- FORGOT PASSWORD ------------- //

    // -------------- FORGOT PASSWORD SEND OTP ------------- //
    public function forget_password_otp(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $email      =   DB::table('users_companies')->where('email', $request->email)->get()->count();
            if ($email > 0) {
                $emaildata          =   DB::table('users_companies')->where('email', $request->email)->get();
                $id                 =   $emaildata[0]->users_companies_id; 
                $onlyEmail          =   $request->email;
                $forgotPasswordOtp  =   rand(1000,9999);

                $details = [
                  "title"=>"Email Verification Code",
                  "body"=> $forgotPasswordOtp
                ];            
                $otpSended      = Mail::to($onlyEmail)->send(new SendMail($details));
                
                $otpData        = array('forgotPasswordOtp' => $forgotPasswordOtp);
                $UserotpUpdate  = DB::table('users_companies')->where('email', $onlyEmail)->update($otpData);

                Session::flash('success', ' Password reset OTP is sent on your email. Please check and proceed with OTP.'); 
                return redirect()->route('forget_password_otp_reset', [$id]);
            } else {
                Session::flash('error', ' Invalid Email.'); 
                return redirect('/forget_password');
            }
        }
    }
    // -------------- FORGOT PASSWORD SEND OTP ------------- //

    // -------------- FORGOT PASSWORD RESET ------------- //
    public function forget_password_otp_reset($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            return view('company.forget_password_otp_reset', ['users_companies_id'=>$id]);
        }
    }
    // -------------- FORGOT PASSWORD RESET ------------- //

    // -------------- FORGOT PASSWORD RESET VERIFICATION ------------- //
    public function forget_password_otp_reset_verification(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $id         = $request->id;
            $UserOtp    = DB::table('users_companies')->select('forgotPasswordOtp')->where('users_companies_id', $id)->get();
            $userOtpGet = $UserOtp[0]->forgotPasswordOtp;
            
            $otp1       = $request->otp1;
            $otp2       = $request->otp2;
            $otp3       = $request->otp3;
            $otp4       = $request->otp4;
            $otp        = $otp1.''.$otp2.''.$otp3.''.$otp4;
            
            if ($userOtpGet==$otp) {
                Session::flash('success', ' OTP Verified.'); 
                return redirect()->route('forget_password_change_password', $id);
            } else {
                Session::flash('error', ' Invalid Otp. Please enter correct otp.'); 
                return redirect()->back()->withMessage('Invalid Otp. Please enter correct otp');
            }
        }
    }
    // -------------- FORGOT PASSWORD RESET VERIFICATION ------------- //

    // -------------- FORGOT CHANGE PASSWORD ------------- //
    public function forget_password_change_password($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $data   = DB::table('users_companies')->where('users_companies_id', $id)->get();
            $id     = $data[0]->users_companies_id;
            return view('company.forget_password_change_password', ['id'=>$id]);
        }
    }
    // -------------- FORGOT CHANGE PASSWORD ------------- //

    // -------------- FORGOT CHANGE PASSWORD PROCESS ------------- //
    public function forget_password_change_password_process(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            if ($request->password == $request->cpassword) {
                $id     = $request->id;
                $data   = array(
                  'password'=>$request->password
                );
                DB::table('users_companies')->where('users_companies_id', $id)->update($data);
                Session::flash('success', ' Password change Successfully.'); 
                return redirect('/')->withMessage('Password change Successfully.');
            } else {
                Session::flash('error', ' Password Does Not Match.'); 
                return redirect()->back()->withMessage('Password Does Not Match.');
            }
        }
    }
    // -------------- FORGOT CHANGE PASSWORD PROCESS ------------- //

    // -------------- LOGOUT ------------- //
    public function logout(Request $request){
        Session::flash('success', ' Logged Out.'); 
        $request->session()->flush();
        return redirect('/');
    }
    // -------------- LOGOUT ------------- //

    // -------------- SIGNUP PAGE ------------- //
    public function signup(Request $request){
        if ($request->session()->has('id')) {
            return redirect('signup');
        } else{
            return view('company.signup');
        }
    }
    // -------------- SIGNUP PAGE ------------- //

     // -------------- SIGNUP SEND OTP ------------- //
    public function signup_process(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $email      =   DB::table('users_companies')->where('email', $request->email)->get()->count();
            if ($email == 0) {
                if ($request->password == $request->confirm_password) {
                    $verify_email_otp  =   rand(1000,9999);

                    $details = [
                        "title"=>"Email Verification Code",
                        "body"=> $verify_email_otp
                    ];            
                    $otpSended      = Mail::to($request->email)->send(new SendMail($details));
                    
                    $data=array(
                        'email'=>$request->email,
                        'phone'=>$request->phone_number,
                        'password'=>$request->password,
                        'verify_email_otp'=>$verify_email_otp,
                        'status'=>'Pending'
                    );
                    $id = DB::table('users_companies')->insertGetId($data);

                    Session::flash('success', ' Password reset OTP is sent on your email. Please check and proceed with OTP.'); 
                    return redirect()->route('signup_otp_email', [$id]);
                } else {
                    Session::flash('error', ' password and confirm password donot Match.'); 
                    return redirect('/signup');
                }
            } else {
                Session::flash('error', ' Email Already Exists. Please try with another email address.'); 
                return redirect('/signup');
            }
        }
    }
     // -------------- SIGNUP SEND OTP ------------- //

    // -------------- SIGNUP OTP EMAIL ------------- //
    public function signup_otp_email($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            return view('company.signup_otp_email', ['users_companies_id'=>$id]);
        }
    }
    // -------------- SIGNUP OTP EMAIL ------------- //

    // -------------- SIGNUP OTP EMAIL VERIFICATION ------------- //
    public function signup_otp_email_verification(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $id         = $request->id;
            $UserOtp    = DB::table('users_companies')->select('verify_email_otp')->where('users_companies_id', $id)->get();
            $userOtpGet = $UserOtp[0]->verify_email_otp;
            
            $otp1       = $request->otp1;
            $otp2       = $request->otp2;
            $otp3       = $request->otp3;
            $otp4       = $request->otp4;
            $otp        = $otp1.''.$otp2.''.$otp3.''.$otp4;
            
            if ($userOtpGet==$otp) {
                Session::flash('success', ' OTP Verified.'); 
                return redirect()->route('signup_company_profile', $id);
            } else {
                Session::flash('error', ' Invalid Otp. Please enter correct otp.'); 
                return redirect()->back()->withMessage('Invalid Otp. Please enter correct otp');
            }
        }
    }
    // -------------- SIGNUP OTP EMAIL VERIFICATION ------------- //

    // -------------- SIGNUP OTP EMAIL ------------- //
    public function signup_company_profile($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            return view('company.signup_company_profile', ['users_companies_id'=>$id]);
        }
    }
    // -------------- SIGNUP OTP EMAIL ------------- //

    // ------------- SIGNUP Update Company Details -------------- //
   public function signup_company_profile_process($id, Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            $data['company_name'] = $request->company_name;
            $data['company_registration_number'] = $request->company_registration_number;
            $data['company_location'] = $request->company_location;
            
            if ($request->hasFile('company_logo')) {
                $todayDate  = Carbon::now();
                $file       = $request->file('company_logo');
                $file_name  = $file->getClientOriginalName();
                $destinationPath = public_path( 'uploads/users_companies/');
                $file->move($destinationPath, $file_name);
                $data['company_logo'] = 'uploads/users_companies/' . $file_name;
            }
              
            $updateProfile=DB::table('users_companies')->where('users_companies_id', $id)->update($data);
            if (isset($updateProfile)) {
                Session::flash('success', ' Profile created successfully.'); 
                return redirect('signup_complete');
            } else {
                Session::flash('error', ' Oops! Something went wrong.'); 
                return redirect()->back();
            }
        }
    }
    // ------------- SIGNUP Update Company Details -------------- //

    // -------------- SIGNUP OTP EMAIL ------------- //
    public function signup_complete(Request $request){
        if ($request->session()->has('id')) {
            return redirect('dashboard');
        } else {
            return view('company.signup_complete');
        }
    }
    // -------------- SIGNUP OTP EMAIL ------------- //

    // ------------- DASHBOARD -------------- //
    public function dashboard(){
        if(session()->has('id')){
            $my_cars            = number_format(DB::table('cars')->select('cars_id')->where('users_companies_id', session('id'))->count());
            $my_cars_ids        = DB::table('cars')->select('cars_id')->where('users_companies_id', session('id'))->get();
            $my_cars_array      = json_decode(json_encode($my_cars_ids), true);
            //print_r($my_cars_array); exit();

            $totalpending       = number_format(DB::table('bookings')->where('status', 'Pending')->whereIn('cars_id', $my_cars_array)->count());
            $totalaccepted      = number_format(DB::table('bookings')->where('status', 'Accepted')->whereIn('cars_id', $my_cars_array)->count());
            $totalrejected      = number_format(DB::table('bookings')->where('status', 'Rejected')->whereIn('cars_id', $my_cars_array)->count());
            $totalCancelled     = number_format(DB::table('bookings')->where('status', 'Cancelled')->whereIn('cars_id', $my_cars_array)->count());
            
            $system_currency    = DB::table('system_settings')->select('description')->where('type', 'system_currency')->get()->first();
            $totalEarning       = $system_currency->description . number_format(DB::table('bookings')->where('status', 'Accepted')->whereIn('cars_id', $my_cars_array)->sum('total_cost'), 2);
            
            return view('company.dashboard', compact('totalpending','totalaccepted', 'totalrejected', 'totalCancelled', 'totalEarning'));
        } else {
            return redirect('/');
        }
    }
    // ------------- DASHBOARD -------------- //

    // ------------- CARS ADD -------------- //
    public function cars_add(){
        if(session()->has('id')){
            $data['cars_type'] = DB::table('cars_type')->get();
            $data['cars_makes'] = DB::table('cars_makes')->get();
            $data['cars_models'] = DB::table('cars_models')->get();
            $data['cars_colors'] = DB::table('cars_colors')->get();
            return view('company.cars_add', ['data'=>$data]);
        } else {
            return redirect('/');
        }
    }
    // ------------- CARS ADD -------------- //

    // ------------- CARS ADD DATA -------------- //
    public function cars_add_data(Request $req){
        if (isset($req->image1) && isset($req->image2) && isset($req->image3) && isset($req->image4) && isset($req->image5)) {
            $image1 = $req->file('image1');
            $image1_name = $image1->getClientOriginalName();
            $destinationPath = public_path().'/uploads/cars' ;
            $image1_n=  "uploads/cars/".$image1_name;
            $image1->move($destinationPath, $image1_name);

            $image2 = $req->file('image2');
            $image2_name = $image2->getClientOriginalName();
            $image2_n=  "uploads/cars/".$image2_name;
            $image2->move($destinationPath, $image2_name);

            $image3 = $req->file('image3');
            $image3_name = $image3->getClientOriginalName();
            $image3_n=  "uploads/cars/".$image3_name;
            $image3->move($destinationPath, $image3_name);

            $image4 = $req->file('image4');
            $image4_name = $image4->getClientOriginalName();
            $image4_n=  "uploads/cars/".$image4_name;
            $image4->move($destinationPath, $image4_name);

            $image5 = $req->file('image5');
            $image5_name = $image5->getClientOriginalName();
            $image5_n=  "uploads/cars/".$image5_name;
            $image5->move($destinationPath, $image5_name);

            $car_data['users_companies_id'] = session('id');
            $car_data['vehical_name'] = $req->vehical_name;
            $car_data['license_plate'] = $req->license_plate;
            $car_data['discount_percentage'] = $req->discount_percentage;
            $car_data['cars_usage_type'] = $req->cars_usage_type;
            $car_data['cars_type_id'] = $req->cars_type_id;
            $car_data['cars_makes_id'] = $req->cars_makes_id;
            $car_data['cars_models_id'] = $req->cars_models_id;
            $car_data['year'] = $req->year;
            $car_data['cars_colors_id'] = $req->cars_colors_id;
            $car_data['description'] = $req->description;

             if(isset($req->features_suv)){
                $car_data['features_suv'] = $req->features_suv;
            }

            if(isset($req->features_seats)){
                $car_data['features_seats'] = $req->features_seats;
            }

            if(isset($req->features_speed)){
                $car_data['features_speed'] = $req->features_speed;
            }

            if(isset($req->features_automatic)){
                $car_data['features_automatic'] = $req->features_automatic;
            }

            if(isset($req->features_drives)){
                $car_data['features_drives'] = $req->features_drives;
            }

            if(isset($req->features_doors)){
                $car_data['features_doors'] = $req->features_doors;
            }

            if(isset($req->features_electric)){
                $car_data['features_electric'] = $req->features_electric;
            }

            if(isset($req->features_engine_capacity)){
                $car_data['features_engine_capacity'] = $req->features_engine_capacity;
            }

            if(isset($req->features_fuel_capacity)){
                $car_data['features_fuel_capacity'] = $req->features_fuel_capacity;
            }

            if(isset($req->features_meter_reading)){
                $car_data['features_meter_reading'] = $req->features_meter_reading;
            }

            if(isset($req->features_new_cars)){
                $car_data['features_new_cars'] = $req->features_new_cars;
            }
            
            $car_data['image1'] = $image1_n;
            $car_data['image2'] = $image2_n;
            $car_data['image3'] = $image3_n;
            $car_data['image4'] = $image4_n;
            $car_data['image5'] = $image5_n;

            $cars_id = DB::table('cars')->insertGetId($car_data);

            if($req->cars_usage_type == 'Driving Experience'){
                foreach($req->plan_date as $key => $plan_date){
                    $data_sub_table['cars_id']          = $cars_id;
                    $data_sub_table['plan_date']        = $req->plan_date[$key];
                    $data_sub_table['start_time']       = $req->start_time[$key];
                    $data_sub_table['end_time']         = $req->end_time[$key];
                    $data_sub_table['price_per_slot']   = $req->price_per_slot[$key];
                    DB::table('cars_plans_de')->insert($data_sub_table);
                }
            } else if($req->cars_usage_type == 'EV Subscriptions'){
                foreach($req->months as $key => $months){
                    $data_sub_table['cars_id']          = $cars_id;
                    $data_sub_table['months']           = $req->months[$key];
                    $data_sub_table['price_per_month']  = $req->price_per_month[$key];
                    DB::table('cars_plans_ev')->insert($data_sub_table);
                }
            } else if($req->cars_usage_type == 'Photography'){
                foreach($req->plan_date as $key => $plan_date){
                    $data_sub_table['cars_id']          = $cars_id;
                    $data_sub_table['plan_date']        = $req->plan_date[$key];
                    $data_sub_table['price_per_hour']   = $req->price_per_hour[$key];
                    DB::table('cars_plans_pg')->insert($data_sub_table);
                }
            }

            session()->flash('success', 'Car added successfully!');
            return redirect('cars_manage');
        } else {
            session()->flash('error', 'Please Upload all images first!');
            return redirect()->back()->withMessage('Please Upload all images first');
        }
    }
    // ------------- CARS ADD DATA -------------- //

    // ------------- CARS ADD DATA -------------- //
    public function cars_manage(){
        $data=DB::table('cars')
            ->join('cars_type', 'cars_type.cars_type_id','=','cars.cars_type_id')
            ->join('cars_colors', 'cars_colors.cars_colors_id','=','cars.cars_colors_id')
            ->select('cars.*','cars_type.name as cars_type_name','cars_colors.name as cars_colors')
            ->where('users_companies_id', session('id'))
            ->orderBy('cars_id', 'DESC')->get();
        return view('company.cars_manage', ['data'=>$data]);
    }
    // ------------- CARS ADD DATA -------------- //

    // ------------- CARS DETAILS-------------- //
    public function cars_details($id){
        $data           = DB::table('cars')
                            ->join('cars_type', 'cars_type.cars_type_id','=','cars.cars_type_id')
                            ->join('cars_makes', 'cars_makes.cars_makes_id','=','cars.cars_makes_id')
                            ->join('cars_models', 'cars_models.cars_models_id','=','cars.cars_models_id')
                            ->join('cars_colors', 'cars_colors.cars_colors_id','=','cars.cars_colors_id')
                            ->select('cars.*', 'cars_type.name as cars_type_name', 'cars_makes.name as cars_makes_name', 'cars_models.name as cars_models_name', 'cars_colors.name as cars_colors_name')
                            ->where('cars_id', $id)->get()->first();

        $bookingCount   = DB::table('bookings')->where('cars_id', $id)->count();

        $bookings       = DB::table('bookings')
            ->join('users_customers', 'users_customers.users_customers_id','=','bookings.users_customers_id')
            ->join('cars','cars.cars_id','=','bookings.cars_id')
            ->select('bookings.*','users_customers.*','cars.*', 'bookings.status as booking_status')
            ->where('cars.cars_id', $id)->get();

        if($data->cars_usage_type == 'Driving Experience'){
            $cars_plans = DB::table('cars_plans_de')->where('cars_id', $data->cars_id)->get();
        }

        if($data->cars_usage_type == 'EV Subscriptions'){
            $cars_plans = DB::table('cars_plans_ev')->where('cars_id', $data->cars_id)->get();
        }

        if($data->cars_usage_type == 'Photography'){
            $cars_plans = DB::table('cars_plans_pg')->where('cars_id', $data->cars_id)->get();
        }   

        return view('company.cars_details', ['data'=>$data, 'bookingCount'=>$bookingCount, 'bookings'=>$bookings, 'cars_plans'=>$cars_plans]);
    }
    // ------------- CARS DETAILS-------------- //

    // ------------- CARS EDIT-------------- //
    public function cars_edit($id){
        $data = DB::table('cars')->where('cars_id', $id)->get()->first();
        return view('company.cars_edit', ['data'=>$data]);
    }
    // ------------- CARS EDIT-------------- //

    // ------------- CARS EDIT DATA -------------- //
    public function cars_edit_data(Request $req, $id){
        $data['vehical_name'] = $req->vehical_name;
        $data['cars_type_id'] = $req->cars_type_id;
        $data['license_plate'] = $req->license_plate;
        $data['description'] = $req->description;

        if($req->file('image1')){
          $image1 = $req->file('image1');
          $image1_name = $image1->getClientOriginalName();
          $destinationPath = public_path().'/uploads/companyCars' ;
          $image1_n=  "uploads/companyCars/".$image1_name;
          $image1->move($destinationPath, $image1_name);
          $data['image1'] = $image1_n;
        }
    
        if($req->file('image2')){
          $image2 = $req->file('image2');
          $image2_name = $image2->getClientOriginalName();
          $image2_n=  "uploads/companyCars/".$image2_name;
          $image2->move($destinationPath, $image2_name);
          $data['image2'] = $image1_n;
        }
        
        if($req->file('image3')){
          $image3 = $req->file('image3');
          $image3_name = $image3->getClientOriginalName();
          $image3_n=  "uploads/companyCars/".$image3_name;
          $image3->move($destinationPath, $image3_name);
          $data['image3'] = $image1_n;
        }
        
        if($req->file('image4')){
          $image4 = $req->file('image4');
          $image4_name = $image4->getClientOriginalName();
          $image4_n=  "uploads/companyCars/".$image4_name;
          $image4->move($destinationPath, $image4_name);
          $data['image4'] = $image1_n;
        }
        
        if($req->file('image5')){
          $image5 = $req->file('image5');
          $image5_name = $image5->getClientOriginalName();
          $image5_n=  "uploads/companyCars/".$image5_name;
          $image5->move($destinationPath, $image5_name);
          $data['image5'] = $image1_n;
        }
        
        session()->flash('success', 'Car updated successfully!');
        DB::table('cars')->where('cars_id',$id)->update($data);
        return redirect('/cars_manage');
    }
    // ------------- CARS EDIT DATA -------------- //

    // ------------- CARS DISABLE -------------- //
    public function cars_disable(Request $req){
        $id=$req->id;
        $cars=DB::table('cars')->where('cars_id', $id)->get();
        $status=$cars[0]->status;
        
        if ($status=='Active') {
            $data=array(
                'status'=>'Inactive'
            );
            $data2=DB::table('cars')->where('cars_id', $id)->update($data);
            $status2=DB::table('cars')->where('cars_id', $id)->get();
            $status3=$status2[0]->status;
            return $status3; 
        } elseif ($status=='Inactive') {
            $data=array(
                'status'=>'Active'
            );
            $data3=DB::table('cars')->where('cars_id', $id)->update($data);
            $status2=DB::table('cars')->where('cars_id', $id)->get();
            $status3=$status2[0]->status;
            return $status3;
        }
    }
    // ------------- CARS DISABLE -------------- //

    // ------------- Bookings LIST -------------- //
    public function bookings($booking_status = 'accepted', Request $request){
        if(!session()->has('id')){
            return redirect('/');
        } else {
            $my_cars_ids        = DB::table('cars')->select('cars_id')->where('users_companies_id', session('id'))->get();
            $my_cars_array      = json_decode(json_encode($my_cars_ids), true);

            if (empty($request->filter)) {
                $data=DB::table('bookings')
                    ->join('cars', 'cars.cars_id','=','bookings.cars_id')
                    ->join('users_customers', 'users_customers.users_customers_id','=', 'bookings.users_customers_id')
                    ->select(  
                        'bookings.*', 'cars.vehical_name as vehical_name',
                        'users_customers.first_name', 'users_customers.email'
                    )
                    ->whereIn('bookings.cars_id', $my_cars_array)
                    ->orderBy('bookings.bookings_id','DESC')
                    ->get();
            } else if ($request->filter == 'Pending') {
                $data=DB::table('bookings')
                    ->join('cars', 'cars.cars_id','=','bookings.cars_id')
                    ->join('users_customers', 'users_customers.users_customers_id','=', 'bookings.users_customers_id')
                    ->select(  
                        'bookings.*', 'cars.vehical_name as vehical_name',
                        'users_customers.first_name', 'users_customers.email'
                    )
                    ->whereIn('bookings.cars_id', $my_cars_array)
                    ->where('bookings.status', $request->filter)
                    ->orderBy('bookings.bookings_id','DESC')
                    ->get();        
            }else if ($request->filter == 'Accepted') {
                $data=DB::table('bookings')
                    ->join('cars', 'cars.cars_id','=','bookings.cars_id')
                    ->join('users_customers', 'users_customers.users_customers_id','=', 'bookings.users_customers_id')
                    ->select(  
                        'bookings.*', 'cars.vehical_name as vehical_name',
                        'users_customers.first_name', 'users_customers.email'
                    )
                    ->whereIn('bookings.cars_id', $my_cars_array)
                    ->where('bookings.status', $request->filter)
                    ->orderBy('bookings.bookings_id','DESC')
                    ->get();
            }else if ($request->filter =='Rejected') {
                $data=DB::table('bookings')
                    ->join('cars', 'cars.cars_id','=','bookings.cars_id')
                    ->join('users_customers', 'users_customers.users_customers_id','=', 'bookings.users_customers_id')
                    ->select(  
                        'bookings.*', 'cars.vehical_name as vehical_name',
                        'users_customers.first_name', 'users_customers.email'
                    )
                    ->whereIn('bookings.cars_id', $my_cars_array)
                    ->where('bookings.status', $request->filter)
                    ->orderBy('bookings.bookings_id','DESC')
                    ->get();
            }else if ($request->filter == 'Cancelled') {
                $data=DB::table('bookings')
                    ->join('cars', 'cars.cars_id','=','bookings.cars_id')
                    ->join('users_customers', 'users_customers.users_customers_id','=', 'bookings.users_customers_id')
                    ->select(  
                        'bookings.*', 'cars.vehical_name as vehical_name',
                        'users_customers.first_name', 'users_customers.email'
                    )
                    ->whereIn('bookings.cars_id', $my_cars_array)
                    ->where('bookings.status', $request->filter)
                    ->orderBy('bookings.bookings_id','DESC')
                    ->get();
            }
            return view('company.bookings', ['data'=>$data]);
        }    
    }    
    // ------------- Bookings LIST -------------- //

    // ------------- Bookings Details -------------- //
    public function bookings_details($id){
        $data=DB::table('bookings')
            ->join('users_customers', 'users_customers.users_customers_id','=','bookings.users_customers_id')
            ->join('cars','cars.cars_id','=','bookings.cars_id')
            ->join('cars_type','cars.cars_type_id','=','cars_type.cars_type_id')
            ->select('bookings.*','users_customers.*','cars.*','cars_type.name as cars_type_name', 'bookings.status as bookings_status')
            ->where('bookings_id', $id)->get()->first();

        $datacars           = DB::table('cars')->where('cars_id', $data->cars_id)->get()->first();
        
        if($datacars->cars_usage_type == 'Driving Experience'){
            $cars_plans = DB::table('bookings_plans_de')->where('bookings_id', $id)->where('cars_id', $datacars->cars_id)->get();
        }

        if($datacars->cars_usage_type == 'EV Subscriptions'){
            $cars_plans = DB::table('bookings_plans_ev')->where('bookings_id', $id)->where('cars_id', $datacars->cars_id)->get();
        }

        if($datacars->cars_usage_type == 'Photography'){
            $cars_plans = DB::table('bookings_plans_pg')->where('bookings_id', $id)->where('cars_id', $datacars->cars_id)->get();
        }   

        return view('company.bookings_details', ['data'=>$data, 'cars_usage_type'=> $datacars->cars_usage_type, 'cars_plans'=>$cars_plans]);
    }
    // ------------- Bookings Details -------------- //

    // ------------- Bookings Accepted -------------- //
    public function bookings_accept($id){
      $data = array(
            'status'=>'Accepted'
      );

      $data = DB::table('bookings')->where('bookings_id', $id)->update($data);
      $booking_data = DB::table('bookings')->where('bookings_id', $id)->get()->first();

      //NEW MESSAGE Notifications
      $dataInsert=array(
        'bookings_id'=>$id,
        'senders_id'=>session('id'),
        'receivers_id'=>$booking_data->users_customers_id,
        'message'=> 'Your booking has been accepted successfully.',
        'date_added'=>date('Y-m-d H:i:s'),
        'date_modified'=>date('Y-m-d H:i:s')
      );
      $this->send_notification($dataInsert);
      //NEW MESSAGE Notifications
      Session::flash('success', ' Bookings Accepted'); 
      return redirect()->back();
    }                   
    // ------------- Bookings Accepted -------------- //

    // ------------- Bookings Cancelled -------------- //
    public function bookings_cancel($id){
      $data = array(
            'status'=>'Cancelled'
      );

      $data=DB::table('bookings')->where('bookings_id', $id)->update($data);

      //NEW MESSAGE Notifications
      $dataInsert=array(
        'bookings_id'=>$id,
        'senders_id'=>session('id'),
        'receivers_id'=>$booking_data->users_customers_id,
        'message'=> 'Your booking has been cancelled by company.',
        'date_added'=>date('Y-m-d H:i:s'),
        'date_modified'=>date('Y-m-d H:i:s')
      );
      $this->send_notification($dataInsert);
      //NEW MESSAGE Notifications

      Session::flash('warning', ' Bookings Cancelled'); 
      return redirect()->back();
    }                   
    // ------------- Bookings Cancelled -------------- //

    // ------------- Bookings Reject -------------- //
    public function bookings_reject($id){
      $data = array(
            'status'=>'Rejected'
      );

      $data=DB::table('bookings')->where('bookings_id', $id)->update($data);

      //NEW MESSAGE Notifications
      $dataInsert=array(
        'bookings_id'=>$id,
        'senders_id'=>session('id'),
        'receivers_id'=>$booking_data->users_customers_id,
        'message'=> 'Your booking has been rejected by company.',
        'date_added'=>date('Y-m-d H:i:s'),
        'date_modified'=>date('Y-m-d H:i:s')
      );
      $this->send_notification($dataInsert);
      //NEW MESSAGE Notifications

      Session::flash('warning', ' Bookings Rejected'); 
      return redirect()->back();
    }                   
    // ------------- Bookings Reject -------------- //
    
    // ------------- TRANSACTIONS -------------- //
    public function transactions(){
        return view('company.transactions');
    }
    // ------------- TRANSACTIONS -------------- //   

    // ------------- SUPPORT -------------- //
    public function support(){
        return view('company.support');
    }
    // ------------- SUPPORT -------------- //    

    // ------------- Account Settings -------------- //
    public function account_settings(){
        if(session()->has('id')){
            $data=DB::table('users_companies')->where('users_companies_id', session('id'))->get()->first();
            return view('company.account_settings', ['data'=>$data]);
        } else {
            return redirect('/');
        }    
    }
    // ------------- Account Settings -------------- //

    // ------------- Update Account Settings -------------- //
    public function account_settings_update(Request $request, $id){
        if(session()->has('id')){
            $oldPassword=DB::table('users_companies')->where('users_companies_id', $id)->select('password')->get();
            $oldP = $oldPassword[0]->password;
            if ($request->old_password==$oldP) {
                if ($request->password==$request->cpassword) {
                    $todayDate = Carbon::now();
                    $data = array(
                        'password'=>$request->password,
                        'bank_name'=>$request->bank_name,
                        'bank_account_number'=>$request->bank_account_number,
                        'paypal_email'=>$request->paypal_email,
                        'about'=>$request->about,
                        'date_modified'=>$todayDate
                    );

                    $updateProfile=DB::table('users_companies')->where('users_companies_id', $id)->update($data);
                    if (isset($updateProfile)) {
                        Session::flash('success', ' Account Updated.'); 
                        return redirect()->back();
                    } 
                } else { 
                    Session::flash('error', ' Password do Not Match.'); 
                    return redirect()->back();
                }
            } else {
                Session::flash('error', ' Old Password is wrong.'); 
                return redirect()->back();
            }
        } else {
            return redirect('/');
        }         
    }
    // ------------- Update Account Settings -------------- //

    // ------------- Company Profile -------------- //
    public function company_profile(){
        if(session()->has('id')){
            $data=DB::table('users_companies')->where('users_companies_id', session('id'))->get();
            return view('company.company_profile', ['data'=>$data]);
        } else {
            return redirect('/');
        }    
    }
    // ------------- Company Profile -------------- //

    // ------------- Update Company Details -------------- //
    public function company_profile_update($id, Request $request){
        $detail     = DB::table('users_companies')->where('users_companies_id', session('id'))->first();
        $profile    = $detail->company_logo;
        if ($request->hasFile('company_logo')) {
            $todayDate  = Carbon::now();
            $file       = $request->file('company_logo');
            $file_name  = $file->getClientOriginalName();
            $destinationPath = public_path( 'uploads/users_company/');
            $file->move($destinationPath, $file_name);
            
            $data=array(
              'company_name'=>$request->company_name,
              'about'=>$request->about,
              'company_registration_number'=>$request->company_registration_number,
              'company_location'=>$request->company_location,
              'company_logo'=>'uploads/users_company/' . $file_name,
              'email'=>$request->email,
              'phone'=>$request->phone,
              'date_modified'=>$todayDate
            );
            $updateProfile=DB::table('users_companies')->where('users_companies_id', $id)->update($data);
            if (isset($updateProfile)) {
                return redirect()->back();
            }
        } else {
            $todayDate = Carbon::now();
            $file = $request->file('company_logo');
            $file_name = $profile;
            $data=array(
                'company_name'=>$request->company_name,
                'about'=>$request->about,
                'company_registration_number'=>$request->company_registration_number,
                'company_location'=>$request->company_location,
                'company_logo'=>$file_name,
                'email'=>$request->email,
                'phone'=>$request->phone,
                'date_modified'=>$todayDate
            );
            $updateProfile=DB::table('users_companies')->where('users_companies_id', $id)->update($data);
            if (isset($updateProfile)) {
                return redirect()->back();
            }
        }
    }
    // ------------- Update Company Details -------------- //

}