<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use \stdClass;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;
use App\Http\Controllers\Controller;
use App\Helpers\Helper;
use Mail;
use Carbon\Carbon;
use Illuminate\Support\Facades\Hash;
use File;
use DB;
use Stripe\Stripe;
use Stripe\Charge;
use Stripe\Customer;
use Stripe\StripeClient;
use DateTime;
use Illuminate\Support\Arr;
use App\Models\User;
use App\Models\Tribe;
use App\Models\GroupCategory;
use App\Models\Feature;
use App\Models\Group;
use App\Models\ImportantRule;
use App\Models\GroupImportantRule;
use App\Models\GroupTribe;
use App\Models\GroupFeature;
use App\Models\GroupMember;
use App\Models\UserGroupInterest;
use App\Models\GroupReport;
use App\Models\GroupMessage;
use App\Models\FavouriteUser;
use App\Models\ReliabilityMember;
use App\Models\Notification;








class GroupController extends Controller{
    public $successStatus = 200;
    public $errorStatus = 401;

    public  function get_predefined_group_details(Request $req){
        $response = array();
        $mainDataset = array();

        $groupCategories = GroupCategory::where('status','Active' )->get();
        foreach($groupCategories as $k){
            $k->category_image = config('base_urls.group_category_image_base_url').$k->category_image;
        }

        $tribes = Tribe::where('status', 'Active')->get();
        $features = Feature::where('status', 'Active')->get();
        $importantRules = ImportantRule::where('status', 'Active')->get();


        $mainDataset['group_categories'] = $groupCategories;
        $mainDataset['tribes'] = $tribes;
        $mainDataset['features'] = $features;
        $mainDataset['important_rules'] = $importantRules;

        $response["code"] = 200;
        $response["status"] = "success";
        $response["data"] = $mainDataset;


        return response()
            ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }



    public  function create_group(Request $req){
        $response = array();


//        below line changed by nabeel
        if (isset($req->usersId) &&  isset($req->groupCategoryId) && isset($req->title) && isset($req->coverPhoto) && isset($req->startingTime) && isset($req->startingDate) && isset($req->endingDate) && isset($req->address) && isset($req->additionalInstructions) && isset($req->cover) && isset($req->tribes) && isset($req->features)  && isset($req->groupLong) && isset($req->groupLat)) {
            $groupData = [
                'users_id'=> $req->usersId,
                'group_category_id'=> $req->groupCategoryId,
                'cover_photo'=> $req->coverPhoto,
                'starting_time'=> date('H:i:s', strtotime($req->startingTime)),
                'starting_date'=> date('Y-m-d', strtotime($req->startingDate)),
                'ending_time'=> date('H:i:s', strtotime($req->endingTime)),
                'ending_date'=> date('Y-m-d', strtotime($req->endingDate)),
                'address'=> $req->address,
                'additional_instructions'=> $req->additionalInstructions,
                'cover'=> $req->cover,
                'cost'=> (isset($req->cost) ? $req->cost : null),
                'top_to_bottom_ratio'=> (isset($req->topToBottomRatio) ? $req->topToBottomRatio : null),
                'max_group_size'=> (isset($req->maxGroupSize) ? $req->maxGroupSize : null),
                'invite_other_guests'=> (isset($req->inviteOtherGuests) ? $req->inviteOtherGuests : null),
                'group_long'=> $req->groupLong,
                'group_lat'=> $req->groupLat,
                'created_at'=> date('Y-m-d H:i:s'),
                'status'=> 'Active'
            ];
            $lastInsertedId = Group::insertGetId($groupData);
            if($lastInsertedId){

                //adding owner as a default participant as group member
                GroupMember::insert([
                                'group_id' => $lastInsertedId,
                                'users_id' => $req->usersId,
                                'joining_type' => 'Invited',
                                'created_at' => date('Y-m-d H:i:s'),
                                'status' => 'Accepted'
                            ]);

                // if guests are not set then do not insert in participants
                if (isset($req->guests)) {
                    //inserting invited participants
                    foreach ($req->guests as $k) {
                        $guestsData = array(
                            'group_id' => $lastInsertedId,
                            'users_id' => $k,
                            'joining_type' => 'Invited',
                            'created_at' => date('Y-m-d H:i:s'),
                            'status' => 'Requested'
                        );
                        GroupMember::insert($guestsData);

                        $groupDetails = Group::with('category')->where('group_id', $lastInsertedId)->first();
                        $senderDetails = User::where('users_id', $groupDetails->users_id)->first();
                        $receiverDetails = User::where('users_id', $k)->first();

                        if ($senderDetails->users_id != $receiverDetails->users_id) {
                            if ($receiverDetails->notification_status == 'True') {
                                $notificationResponse = Helper::sendpushnotification($receiverDetails->one_signal_id, ' You are invited by ' . $senderDetails->user_name . ' to join ' . $groupDetails->category->category . ' Group', 'groupInviteRequest');
                                if ($notificationResponse) {
                                    $notificationData = array(
                                        'sender_users_id' => $senderDetails->users_id,
                                        'receiver_users_id' => $receiverDetails->users_id,
                                        'notification_type' => 'GroupInviteRequest',
                                        'message' => ' You are invited by ' . $senderDetails->user_name . ' to join ' . $groupDetails->category->category . ' Group',
                                        'group_id' => $groupDetails->group_id,
                                        'datetime' => date('Y-m-d H:i:s'),
                                        'status' => 'Unread'
                                    );
                                    $notificationInsertQuery = Notification::insert($notificationData);
                                }
                            }
                        }

                    }
                }

                foreach($req->tribes as $k){
                    GroupTribe::insert(['group_id' => $lastInsertedId, 'tribe_id' => $k]);
                }
                foreach($req->features as $k){
                    GroupFeature::insert(['group_id' => $lastInsertedId, 'feature_id' => $k]);
                }


//                if important Rules are not set then do not insert in grpImportantRule
                if (isset($req->importantRules)){
                    foreach($req->importantRules as $key=>$k){
                        $groupRulesData = [
                            'group_id' => $lastInsertedId,
                            'important_rule_id' => $k['importantRuleId'],
                            'answer' => $k['answer']
                        ];
                        GroupImportantRule::insert($groupRulesData);
                    }
                }

                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = 'Group created successfully';
            }


        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }


    public  function prefilled_edit_group_details(Request $req){

        if (isset($req->groupId)) {
            $groupDetails = Group::where('group_id', $req->groupId)->first();

            if($groupDetails->cover_photo != null && $groupDetails->cover_photo != "")
                $groupDetails->cover_photo = config('base_urls.group_cover_photo_base_url').$groupDetails->cover_photo;
            else
                $groupDetails->cover_photo = "";

            $groupTribes = GroupTribe::where('group_id', $req->groupId)->orderBy('tribe_id')->pluck('tribe_id');
            $groupDetails->tribes = $groupTribes;

            $groupGuests = GroupMember::where('group_id', $req->groupId)->orderBy('users_id')->pluck('users_id');
            $userGuestsDetails = array();
            foreach($groupGuests  as $k){
                    $userGuest = User::where('users_id', $k)->first();
                    if($userGuest->profile_picture != null && $userGuest->profile_picture != "")
                        $userGuest->profile_picture = config('base_urls.profile_images_base_url').$userGuest->profile_picture;
                    else
                        $userGuest->profile_picture = "";

                array_push($userGuestsDetails, $userGuest);
            }
            $groupDetails->user_guests = $userGuestsDetails;

            $groupImportantRules = GroupImportantRule::select('important_rule_id', 'answer')->where('group_id', $req->groupId)->orderBy('important_rule_id')->get();
            $groupDetails->important_rules = $groupImportantRules;

            $groupFeatures = GroupFeature::where('group_id', $req->groupId)->orderBy('feature_id')->pluck('feature_id');
            $groupDetails->features = $groupFeatures;

            $response = Helper::success(200, 'success', $groupDetails);

        } else
            $response = Helper::failed(404, 'error', 'All Fields are required');


        return Helper::custom_response($response);
    }

    public  function edit_group(Request $req){


        if (isset($req->groupId) && isset($req->usersId) &&  isset($req->groupCategoryId) && isset($req->title) && isset($req->startingTime) && isset($req->startingDate) && isset($req->endingDate) && isset($req->address) && isset($req->additionalInstructions) && isset($req->cover) && isset($req->tribes) && isset($req->features)  && isset($req->groupLong) && isset($req->groupLat)) {
            $groupData = [
                'users_id'=> $req->usersId,
                'group_category_id'=> $req->groupCategoryId,
                'starting_time'=> date('H:i:s', strtotime($req->startingTime)),
                'starting_date'=> date('Y-m-d', strtotime($req->startingDate)),
                'ending_time'=> date('H:i:s', strtotime($req->endingTime)),
                'ending_date'=> date('Y-m-d', strtotime($req->endingDate)),
                'address'=> $req->address,
                'additional_instructions'=> $req->additionalInstructions,
                'cover'=> $req->cover,
                'cost'=> (isset($req->cost) ? $req->cost : null),
                'top_to_bottom_ratio'=> (isset($req->topToBottomRatio) ? $req->topToBottomRatio : null),
                'max_group_size'=> (isset($req->maxGroupSize) ? $req->maxGroupSize : null),
                'invite_other_guests'=> (isset($req->inviteOtherGuests) ? $req->inviteOtherGuests : null),
                'group_long'=> $req->groupLong,
                'group_lat'=> $req->groupLat,
                'status'=> 'Active'
            ];

            $updateGroup = Group::where('group_id', $req->groupId)->update($groupData);
               if(isset($req->coverPhoto))
                     Group::where('group_id', $req->groupId)->update(['cover_photo'=> $req->coverPhoto]);

                GroupMember::where('group_id', $req->groupId)->delete();

            if (isset($req->guests)) {

                foreach ($req->guests as $k) {
                    $guestsData = array(
                        'group_id' => $req->groupId,
                        'users_id' => $k,
                        'joining_type' => 'Invited',
                        'created_at' => date('Y-m-d H:i:s'),
                        'status' => 'Requested'
                    );
                    GroupMember::insert($guestsData);
                }
            }

                GroupTribe::where('group_id', $req->groupId)->delete();
                foreach($req->tribes as $k){
                    GroupTribe::insert(['group_id' => $req->groupId, 'tribe_id' => $k]);
                }

                GroupFeature::where('group_id', $req->groupId)->delete();
                foreach($req->features as $k){
                    GroupFeature::insert(['group_id' => $req->groupId, 'feature_id' => $k]);
                }

                GroupImportantRule::where('group_id', $req->groupId)->delete();

            if (isset($req->importantRules)) {

                foreach ($req->importantRules as $key => $k) {
                    $groupRulesData = [
                        'group_id' => $req->groupId,
                        'important_rule_id' => $k['importantRuleId'],
                        'answer' => $k['answer']
                    ];
                    GroupImportantRule::insert($groupRulesData);
                }
            }

                $response = Helper::success(200, 'success', 'Group Updated successfully');

        } else
            $response = Helper::failed(404, 'error', 'All Fields are required');


        return Helper::custom_response($response);
    }



    public function edit_participants(Request $req) {

        if (!isset($req->groupId) && !isset($req->usersId) && !isset($req->guests)) {

            $response = Helper::failed(404, "Error", "groupId(int), usersId(int), guests(array():int) must not be empty!");
            return Helper::custom_response($response);

        }


        // Filter already Requested members, because we will never send invitaion to those who was already Accepted
        $filteredAcceptedGroupMembers = array();
        $filteredRequestedGroupMembers = array();
        $filteredOtherGroupMembers = array();

        // Filter Accepted Group Members
        foreach($req->guests as $users_id) {

            $groupMember = GroupMember::where([
                ['group_id', $req->groupId],
                ['users_id', $users_id],
                ['status', 'Accepted']
            ])->first('users_id');

            if ($groupMember) {
                $filteredAcceptedGroupMembers[] = $groupMember->users_id;
            }

        }


        // Filter Requested Group Members
        foreach($req->guests as $users_id) {

            $groupMember = GroupMember::where([
                ['group_id', $req->groupId],
                ['users_id', $users_id],
                ['status', 'Requested']
            ])->first('users_id');

            if ($groupMember) {
                $filteredRequestedGroupMembers[] = $groupMember->users_id;
            }

        }


        // Filter Other Group Members
        $filteredOtherGroupMembers = array_diff($req->guests, $filteredAcceptedGroupMembers, $filteredRequestedGroupMembers);



        // Delete all previous data
        GroupMember::where('group_id', $req->groupId)->delete();

        // Add logged in user in GroupMembers table by default because group Host is mendatory person in group
        GroupMember::insert([
                'group_id' => $req->groupId,
                'users_id' => $req->usersId,
                'joining_type' => 'Invited',
                'created_at' => date('Y-m-d H:i:s'),
                'status' => 'Accepted'
        ]);



        // Insert Accepted Members
        foreach($filteredAcceptedGroupMembers as $users_id) {

            try {

                GroupMember::insert([
                    'group_id' => $req->groupId,
                    'users_id' => $users_id,
                    'joining_type' => 'Invited',
                    'created_at' => date('Y-m-d H:i:s'),
                    'status' => 'Accepted'
                ]);

            } catch (Exception $e) {

                $response = Helper::failed(404, "Error", "Something is Wrong! Participant Not Added.");
                return Helper::custom_response($response);

            }

        }


        // Insert Requested Members
        foreach($filteredRequestedGroupMembers as $users_id) {

            try {

                GroupMember::insert([
                    'group_id' => $req->groupId,
                    'users_id' => $users_id,
                    'joining_type' => 'Invited',
                    'created_at' => date('Y-m-d H:i:s'),
                    'status' => 'Requested'
                ]);

            } catch (Exception $e) {

                $response = Helper::failed(404, "Error", "Something is Wrong! Participant Not Added.");
                return Helper::custom_response($response);

            }

        }


        // Insert Others/Remaining Members
        foreach($filteredOtherGroupMembers as $users_id) {

            try {

                GroupMember::insert([
                    'group_id' => $req->groupId,
                    'users_id' => $users_id,
                    'joining_type' => 'Invited',
                    'created_at' => date('Y-m-d H:i:s'),
                    'status' => 'Requested'
                ]);

            } catch (Exception $e) {

                $response = Helper::failed(404, "Error", "Something is Wrong! Participant Not Added.");
                return Helper::custom_response($response);

            }

        }

        $response = Helper::success(200, "Success", "Participants Edited Successfully!");
        return Helper::custom_response($response);

    }



    /*
     * Cancellation Of a Group Created By User
     */
    public function cancel_group(Request $req){

         Group::where('group_id', $req->groupId)->update(['status' => 'Deleted']);
         $members_found = false;

                //Send Notification to all members about Group Cancellation
            $groupMembers = GroupMember::where('group_id', $req->groupId)->get();
            if (sizeof($groupMembers) > 0) {
                foreach($groupMembers as $k){
                    $groupDetails = Group::with('category')->where('group_id', $req->groupId)->first();
                    $senderDetails = User::where('users_id', $groupDetails->users_id)->first();
                    $receiverDetails = User::where('users_id', $k->users_id)->first();

                    if($senderDetails->users_id != $receiverDetails->users_id){
                        if($receiverDetails->notification_status == 'True'){
                            $notificationResponse =  Helper::sendpushnotification($receiverDetails->one_signal_id, ' Group '.$groupDetails->category->category.' has been canceled just now ', 'groupCanceled');
                            if($notificationResponse){
                                $notificationData = array(
                                    'sender_users_id' => $senderDetails-> users_id,
                                    'receiver_users_id' => $receiverDetails-> users_id,
                                    'notification_type' => 'GroupCanceled',
                                    'message' => ' Group '.$groupDetails->category->category.' has been canceled just now ',
                                    'group_id' => $req->groupId,
                                    'datetime' => date('Y-m-d H:i:s'),
                                    'status' => 'Unread'
                                );
                                $notificationInsertQuery = Notification::insert($notificationData);
                                 $members_found = true;

                            }
                        }
                    }
                }
            }

                //Send Notification to all users who ticked the group as interested
                $groupInterestedUsers = UserGroupInterest::where('group_id', $req->groupId)->get();
               if (sizeof($groupInterestedUsers) > 0) {
                   foreach($groupInterestedUsers as $k){
                       $groupDetails = Group::with('category')->where('group_id', $k->groupId)->first();
                       $senderDetails = User::where('users_id', $groupDetails->users_id)->first();
                       $receiverDetails = User::where('users_id', $k->users_id)->first();

                       if($senderDetails->users_id != $receiverDetails->users_id){
                           if($receiverDetails->notification_status == 'True'){
                               $alreadyNotified = Notification::where([ ['sender_users_id', $senderDetails->users_id],
                                                                         ['receiver_users_id', $receiverDetails->users_id],
                                                                         ['notification_type', 'GroupCanceled'] ])->count();
                                if($alreadyNotified == 0){
                                    $notificationResponse =  Helper::sendpushnotification($receiverDetails->one_signal_id, ' Group '.$groupDetails->category->category.' has been canceled just now ', 'groupCanceled');
                                    if($notificationResponse){
                                        $notificationData = array(
                                            'sender_users_id' => $senderDetails-> users_id,
                                            'receiver_users_id' => $receiverDetails-> users_id,
                                            'notification_type' => 'GroupCanceled',
                                            'message' => ' Group '.$groupDetails->category->category.' has been canceled just now ',
                                            'group_id' => $req->groupId,
                                            'datetime' => date('Y-m-d H:i:s'),
                                            'status' => 'Unread'
                                        );
                                        $notificationInsertQuery = Notification::insert($notificationData);
                                    }
                                }
                           }
                       }
                   }
               }

               $finalDataset = array(
                   'status_message' => 'Group Deleted successfully!',
                   'members_found' => $members_found
               );

            $response = Helper::success(200, 'success', $finalDataset);

            return Helper::custom_response($response);

    }




    public function get_all_groups(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong)){
            // current date
            $today_date = Carbon::today()->toDateString();
            // current date

            $nearbyGroups = Group::with('category','tribes', 'features','rules','members')
                            ->where('status', 'Active')->where('ending_date', '>=', $today_date)->get();

            foreach($nearbyGroups as $key =>  $k){
                //main loop
                $k->cover_photo = config('base_urls.group_cover_photo_base_url').$k->cover_photo;


                if(!(Str::contains($k->category->category_image, 'https'))){
                    $k->category->category_image = config('base_urls.group_category_image_base_url').$k->category->category_image;
                }

                foreach($k->rules as  $i){
                    $groupRuleDetails = GroupImportantRule::where([ ['important_rule_id', $i->important_rule_id],['group_id', $k->group_id] ])->first();
                    $i->answer = $groupRuleDetails->answer;
                    $i->group_important_rule_id = $groupRuleDetails->group_important_rule_id;
                }

                $k->members = $k->members->makeHidden(['password','verify_code']);

                $groupDetails = Group::where('group_id',$k->group_id)->first();

                foreach($k->members as $key=>$i){

					//for online status
                        $userData = User::where('users_id', $i->users_id)->first();
                        if($userData->online == 'Yes')
                            $i->is_online = true;
                        else
                            $i->is_online = false;

                    if($i->profile_picture != null && $i->profile_picture != "")
                        $i->profile_picture = config('base_urls.profile_images_base_url').$i->profile_picture;
                    else
                        $i->profile_picture = "";

                    if($groupDetails->users_id == $i->users_id)
                        $i->is_host = true;
                    else
                        $i->is_host = false;


                    /*  $memberStatusDetails = GroupMember::where([ ['group_id',$k->group_id],['users_id', $i->users_id] ])->first();
                             if($memberStatusDetails->status != 'Accepted')
                                      unset($k->members[$key]);  */

                }

                /*  $k->members = $k->members->toArray();
                 $k->members = array_values($k->members); */


                $k->total_attendees= sizeof($k->members);

                $k->formatted_from_datetime = date('l', strtotime($k->starting_date) ).', '.date('F d,Y', strtotime($k->starting_date)).' AT '.date('H:i' ,strtotime($k->starting_time));
                $k->formatted_to_datetime = date('l', strtotime($k->ending_date)).', '.date('F d,Y', strtotime($k->ending_date)).' AT '.date('H:i' ,strtotime($k->ending_time));

                $checkIfUserAttendingGroup = GroupMember::checkUserMember($k->group_id, $req->usersId, 'Accepted');

                if($checkIfUserAttendingGroup)
                    $k->is_user_attending = true;
                else
                    $k->is_user_attending = false;


                $checkIfUserIsInterested = UserGroupInterest::checkUserGroupInterest($k->group_id, $req->usersId);

                if($checkIfUserIsInterested)
                    $k->is_user_interested = true;
                else
                    $k->is_user_interested = false;


                $checkIfUserReportedGroup = GroupReport::checkUserReportedGroup($k->group_id, $req->usersId);

                if($checkIfUserReportedGroup)
                    $k->is_user_reported = true;
                else
                    $k->is_user_reported = false;


                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
                $k->distance_away = $distanceInKm;

                if($distanceInKm > 100)
                    unset($nearbyGroups[$key]);


            }

            $nearbyGroups = array_values(collect($nearbyGroups)->sortBy('distance_away')->toArray());


            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $nearbyGroups;

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }



    public function get_both_user_groups(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong) ){
            $mainDataset = array();

            $nearbyGroups = Group::with('category','tribes', 'features','rules','members')->where('status', 'Active')->get();
            $nearbyUsers = User::where('status', 'Active')->where('users_id','!=', $req->usersId)->get();

            foreach($nearbyGroups as $k){
                $customObject = new stdClass();
                $customObject->group_id = $k->group_id;
                $customObject->users_id = null;
                $customObject->name = $k->category->category;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $timeAgo = Helper::time_elapsed_string_group($k->created_at);
                $customObject->time_ago = $timeAgo;

                if($k->cover_photo != null && $k->cover_photo != "")
                    $customObject->picture = config('base_urls.group_cover_photo_base_url').$k->cover_photo;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = GroupMember::where([ ['group_id', $k->group_id], ['status', 'Accepted'] ])->count();
                $customObject->is_online = null;
                $customObject->object_type = 'Group';

                array_push($mainDataset, $customObject);
            }


            foreach($nearbyUsers as $k){
                $customObject = new stdClass();
                $customObject->group_id = null;
                $customObject->users_id = $k->users_id;
                $customObject->name = $k->user_name;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->user_lat, $k->user_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $customObject->time_ago = null;

                //for online status
                $userData = User::where('users_id', $k->users_id)->first();
                if($userData->online == 'Yes')
                    $customObject->is_online = true;
                else
                    $customObject->is_online = false;

                if($k->profile_picture != null && $k->profile_picture != "")
                    $customObject->picture = config('base_urls.profile_images_base_url').$k->profile_picture;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = null;
                $customObject->object_type = 'User';


                array_push($mainDataset, $customObject);

            }


            $mainDataset = array_values(collect($mainDataset)->sortBy('distance_away')->toArray());


            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $mainDataset;

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }


    public  function join_group_as_attendee(Request $req){
        $response = array();


        if(isset($req->usersId) && isset($req->groupId)){
            $checkIfUserAttendingGroup = GroupMember::where([ ['group_id', $req->groupId], ['users_id', $req->usersId] ])->first();
            if($checkIfUserAttendingGroup){
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "Request already sent";
            }else{
                $joiningData = [
                    'group_id' => $req->groupId,
                    'users_id' => $req->usersId,
                    'joining_type' => 'Attending',
                    'created_at' => date('Y-m-d H:i:s'),
                    'status' => 'Requested'
                ];

                $joiningQuery = GroupMember::insert($joiningData);
                if($joiningData){
                    //sending push notification
                    $groupDetails = Group::where('group_id', $req->groupId)->first();
                    $senderDetails = User::where('users_id',  $req->usersId)->first();
                    $receiverDetails = User::where('users_id', $groupDetails->users_id)->first();

                    if($senderDetails->users_id != $receiverDetails->users_id){
//                        if($receiverDetails->notification_status == 'True'){
                            $notificationResponse =  Helper::sendpushnotification($receiverDetails->one_signal_id, $senderDetails->user_name.' has requested to join your group ', 'groupJoinRequest');
                            if($notificationResponse){
                                $notificationData = array(
                                    'sender_users_id' => $senderDetails-> users_id,
                                    'receiver_users_id' => $receiverDetails-> users_id,
                                    'notification_type' => 'GroupJoinRequest',
                                    'message' => $senderDetails->user_name.' has requested to join your group ',
                                    'group_id' => $req->groupId,
                                    'datetime' => date('Y-m-d H:i:s'),
                                    'status' => 'Unread'
                                );
                                $notificationInsertQuery = Notification::insert($notificationData);
                            }
//                        }
                    }


                    $response["code"] = 200;
                    $response["status"] = "success";
                    $response["data"] = "Joining request sent successfully";
                }
            }


        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }



    public function user_interest_in_group(Request $req){
        $response = array();


        if(isset($req->usersId) && isset($req->groupId)){
            $checkAlreadyInterested = UserGroupInterest::checkUserGroupInterest($req->groupId, $req->usersId);
            if($checkAlreadyInterested){
                UserGroupInterest::where([ ['group_id', $req->groupId], ['users_id', $req->usersId] ])->delete();
                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = "Interest removed successfully";
            }else{
                $interestData = [
                    'group_id' => $req->groupId,
                    'users_id' => $req->usersId,
                    'created_at' => date('Y-m-d H:i:s'),
                ];

                $joiningQuery = UserGroupInterest::insert($interestData);
                if($interestData){
                    $response["code"] = 200;
                    $response["status"] = "success";
                    $response["data"] = "Interested successfully";
                }

            }

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }



    public function report_group(Request $req){
        $response = array();


        if(isset($req->usersId) && isset($req->groupId)){
            $checkAlreadyReported =  GroupReport::checkUserReportedGroup($req->groupId, $req->usersId);
            if($checkAlreadyReported){
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "Already Reported";
            }else{
                $reportData = [
                    'group_id' => $req->groupId,
                    'users_id' => $req->usersId,
                    'created_at' => date('Y-m-d H:i:s'),
                    'status' => 'Active',
                ];

                $joiningQuery = GroupReport::insert($reportData);
                if($reportData){
                    $response["code"] = 200;
                    $response["status"] = "success";
                    $response["data"] = "Reported successfully";
                }

            }

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }

    public function leave_group(Request $req){
        $response = array();


        if(isset($req->usersId) && isset($req->groupId)){
            GroupMember::where([ ['users_id', $req->usersId], ['group_id', $req->groupId] ])->update(['status' => 'Left']);
            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = "Group left successfully";
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }



    /*** GROUP MESSAGES ***/
    public function group_messages(Request $req){
        $response = array();


        if (isset($req->requestType)) {
            $request_type = $req->requestType;
            switch ($request_type) {

                case "sendMessage":

                    $message_details = array(
                        'users_id'=> $req->usersId,
                        'group_id'=> $req->groupId,
                        'content'=> json_encode($req->content),
                        'created_at'=> date('Y-m-d h:i:s'),
                    );

                    $insertedId = GroupMessage::insertGetId($message_details);
                    if($insertedId){
                        $messageDetails = GroupMessage::where('group_message_id', $insertedId)->first();

                        $senderDetails =  User::where('users_id', $messageDetails->users_id)->first();

                        $messageDetails->content = json_decode($messageDetails->content);

                        $response["code"] = 200;
                        $response["status"] = "success";
                        $response["data"] = $messageDetails;

                    } else{
                        $response["code"] = 500;
                        $response["status"] = "error";
                        $response["message"] = "Something went wrong in sending message";
                    }

                    break;

                case "getMessages":
                    if(isset($req->usersId) && isset($req->groupId)){
                        $chat_array =array();
                        $day_array =array();

                        $groupMessages = GroupMessage::getGroupMessages($req->groupId);

                        if(sizeof($groupMessages) > 0){
                            foreach($groupMessages as $key => $k){
                                $k->content = json_decode($k->content);
                                $senderDetails = User::where('users_id',$k->users_id)->first();
                                $k->user_name     =  $senderDetails->user_name != null || $senderDetails->user_name != "" ? $senderDetails->user_name : $senderDetails->email;;

                                if($senderDetails->profile_picture != '' || $senderDetails->profile_picture != null){
                                    $k->profile_picture     = config('base_urls.profile_images_base_url') . $senderDetails->profile_picture;
                                } else{
                                    $k->profile_picture     = '';
                                }


                            }

                            $response["code"] = 200;
                            $response["status"] = "success";
                            $response["data"] =  $groupMessages;


                        } else{
                            $response["code"] = 404;
                            $response["status"] = "error";
                            $response["message"] = "No messages found";
                        }
                    } else{
                        $response["code"] = 404;
                        $response["status"] = "error";
                        $response["message"] = "All fields are needed";
                    }
                    break;

            }
        } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "Request type not set";
        }
        return Helper::custom_response($response);

    }
    /*** GROUP MESSAGES ***/




    /*** UPLOAD GROUP COVER API ***/
    public function upload_group_cover(Request $req){
        $response = array();
        $postfix = '_flockdock_group_cover';
        $upd_prefix = date('d-m-y');
        $random = rand(1,1000000);

        $file_name = $upd_prefix.$random.$postfix.'.jpeg';
        $attachment_path_url= config('base_urls.relative_path_group_cover_photo');

        $uploadedAttachment = $req->file('cover_photo')->move($attachment_path_url,$file_name);
        if($uploadedAttachment){
            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $file_name;

        } else{
            $response["code"] = 500;
            $response["status"] = "error";
            $response["message"] = "Uploading failed";
        }

        return Helper::custom_response($response);
    }


    /*** NEARBY USERS API ***/
    public function nearby_users(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong)) {
            //$users = User::where([ ['users_id','!=', $req->usersId],['status', 'Active']])->get();
            $users = User::where([ ['status', 'Active']])->get();

            if(sizeof($users) > 0){
                $users = $users->makeHidden(['password','verify_code']);

                foreach($users as $key=> $k){
                    //for online status
                    $userData = User::where('users_id', $k->users_id)->first();
                    if($userData->online == 'Yes')
                        $k->is_online = true;
                    else
                        $k->is_online = false;

                    if($k->profile_picture != null && $k->profile_picture != "")
                        $k->profile_picture = config('base_urls.profile_images_base_url').$k->profile_picture;
                    else
                        $k->profile_picture = "";

                    $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->user_lat, $k->user_long, 'K');
                    $k->distance_away = $distanceInKm;

                    if($distanceInKm > 100)
                        unset($users[$key]);

                }

                $users = array_values(collect($users)->sortBy('distance_away')->toArray());


                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = $users;

            }else{
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "No users found";
            }

        } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed";
        }
        return Helper::custom_response($response);
    }



    /***FAVOURITE USERS GROUPS API ***/
    public function get_favourite_users_groups(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong) ){
            $mainDataset = array();

            $favGroupIds = UserGroupInterest::where('users_id', $req->usersId)->pluck('group_id');
            $favUserIds = FavouriteUser::where('users_id', $req->usersId)->pluck('favourite_user_id');

            $nearbyGroups = Group::with('category','tribes', 'features','rules','members')->whereIn('group_id',$favGroupIds)->where('status', 'Active')->get();
            $nearbyUsers = User::where('status', 'Active')->whereIn('users_id',$favUserIds)->get();

            foreach($nearbyGroups as $k){
                $customObject = new stdClass();
                $customObject->group_id = $k->group_id;
                $customObject->users_id = null;
                $customObject->name = $k->category->category;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $timeAgo = Helper::time_elapsed_string_group($k->created_at);
                $customObject->time_ago = $timeAgo;

                if($k->cover_photo != null && $k->cover_photo != "")
                    $customObject->picture = config('base_urls.group_cover_photo_base_url').$k->cover_photo;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = GroupMember::where([ ['group_id', $k->group_id], ['status', 'Accepted'] ])->count();
                $customObject->is_online = null;
                $customObject->object_type = 'Group';

                array_push($mainDataset, $customObject);
            }


            foreach($nearbyUsers as $k){
                $customObject = new stdClass();
                $customObject->group_id = null;
                $customObject->users_id = $k->users_id;
                $customObject->name = $k->user_name;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->user_lat, $k->user_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $customObject->time_ago = null;

                //for online status
                $userData = User::where('users_id', $k->users_id)->first();
                if($userData->online == 'Yes')
                    $customObject->is_online = true;
                else
                    $customObject->is_online = false;

                if($k->profile_picture != null && $k->profile_picture != "")
                    $customObject->picture = config('base_urls.profile_images_base_url').$k->profile_picture;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = null;
                $customObject->object_type = 'User';


                array_push($mainDataset, $customObject);

            }


            $mainDataset = array_values(collect($mainDataset)->sortBy('distance_away')->toArray());


            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $mainDataset;

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }




    /*** Group Details API ***/
    public function specific_group_details(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong) && isset($req->groupId)) {

            $specificGroupDetails = Group::with('category','tribes', 'features','rules','members')->where('group_id', $req->groupId)->first();

            $specificGroupDetails->cover_photo = config('base_urls.group_cover_photo_base_url').$specificGroupDetails->cover_photo;


            if(!(Str::contains($specificGroupDetails->category->category_image, 'https'))){
                $specificGroupDetails->category->category_image = config('base_urls.group_category_image_base_url').$specificGroupDetails->category->category_image;
            }

            foreach($specificGroupDetails->rules as  $i){
                $groupRuleDetails = GroupImportantRule::where([ ['important_rule_id', $i->important_rule_id],['group_id', $specificGroupDetails->group_id] ])->first();
                $i->answer = $groupRuleDetails->answer;
                $i->group_important_rule_id = $groupRuleDetails->group_important_rule_id;
            }

            $specificGroupDetails->members = $specificGroupDetails->members->makeHidden(['password','verify_code']);

            $groupDetails = Group::where('group_id',$specificGroupDetails->group_id)->first();

            foreach($specificGroupDetails->members as $key=>$i){

                if($i->profile_picture != null && $i->profile_picture != "")
                    $i->profile_picture = config('base_urls.profile_images_base_url').$i->profile_picture;
                else
                    $i->profile_picture = "";

                if($groupDetails->users_id == $i->users_id)
                    $i->is_host = true;
                else
                    $i->is_host = false;


                /*  $memberStatusDetails = GroupMember::where([ ['group_id',$specificGroupDetails->group_id],['users_id', $i->users_id] ])->first();
                         if($memberStatusDetails->status != 'Accepted')
                                  unset($specificGroupDetails->members[$key]);  */

            }

            /*  $specificGroupDetails->members = $specificGroupDetails->members->toArray();
             $specificGroupDetails->members = array_values($specificGroupDetails->members); */


            $specificGroupDetails->total_attendees= sizeof($specificGroupDetails->members);

            $specificGroupDetails->formatted_from_datetime = date('l', strtotime($specificGroupDetails->starting_date) ).', '.date('F d,Y', strtotime($specificGroupDetails->starting_date)).' AT '.date('H:i' ,strtotime($specificGroupDetails->starting_time));
            $specificGroupDetails->formatted_to_datetime = date('l', strtotime($specificGroupDetails->ending_date)).', '.date('F d,Y', strtotime($specificGroupDetails->ending_date)).' AT '.date('H:i' ,strtotime($specificGroupDetails->ending_time));

            $checkIfUserAttendingGroup = GroupMember::checkUserMember($specificGroupDetails->group_id, $req->usersId, 'Accepted');

            if($checkIfUserAttendingGroup)
                $specificGroupDetails->is_user_attending = true;
            else
                $specificGroupDetails->is_user_attending = false;


            $checkIfUserIsInterested = UserGroupInterest::checkUserGroupInterest($specificGroupDetails->group_id, $req->usersId);

            if($checkIfUserIsInterested)
                $specificGroupDetails->is_user_interested = true;
            else
                $specificGroupDetails->is_user_interested = false;


            $checkIfUserReportedGroup = GroupReport::checkUserReportedGroup($specificGroupDetails->group_id, $req->usersId);

            if($checkIfUserReportedGroup)
                $specificGroupDetails->is_user_reported = true;
            else
                $specificGroupDetails->is_user_reported = false;


            $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $specificGroupDetails->group_lat, $specificGroupDetails->group_long, 'K');
            $specificGroupDetails->distance_away = $distanceInKm;


            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $specificGroupDetails;

        } else{
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed";
        }
        return Helper::custom_response($response);
    }


    /*** SEARCH API ***/
    public function search_user_groups(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong) && isset($req->searchFilter) ){
            $mainDataset = array();

            $this->search_filter = $search_filter =  (isset($req->searchFilter)? $req->searchFilter: '');

            $categoryIds = GroupCategory::where(function($query){
                                                        $query->where('category','like', '%'.$this->search_filter.'%');
                                                    })->where('status', 'Active')->pluck('group_category_id');

            $nearbyGroups = Group::with('category','tribes', 'features','rules','members')->where('status', 'Active')->whereIn('group_category_id', $categoryIds)->get();

            $nearbyUsers = User::where('status', 'Active')->where(function($query){
                                                                    $query->where('user_name', 'like', '%'.$this->search_filter.'%');
                                                            })->get();

            foreach($nearbyGroups as $k){
                $customObject = new stdClass();
                $customObject->group_id = $k->group_id;
                $customObject->users_id = null;
                $customObject->name = $k->category->category;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $timeAgo = Helper::time_elapsed_string_group($k->created_at);
                $customObject->time_ago = $timeAgo;

                if($k->cover_photo != null && $k->cover_photo != "")
                    $customObject->picture = config('base_urls.group_cover_photo_base_url').$k->cover_photo;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = GroupMember::where([ ['group_id', $k->group_id], ['status', 'Accepted'] ])->count();
                $customObject->is_online = null;
                $customObject->object_type = 'Group';

                array_push($mainDataset, $customObject);
            }


            foreach($nearbyUsers as $k){
                $customObject = new stdClass();
                $customObject->group_id = null;
                $customObject->users_id = $k->users_id;
                $customObject->name = $k->user_name;

                $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->user_lat, $k->user_long, 'K');
                $customObject->distance_away = $distanceInKm;

                $customObject->time_ago = null;

                //for online status
                $userData = User::where('users_id', $k->users_id)->first();
                if($userData->online == 'Yes')
                    $customObject->is_online = true;
                else
                    $customObject->is_online = false;

                if($k->profile_picture != null && $k->profile_picture != "")
                    $customObject->picture = config('base_urls.profile_images_base_url').$k->profile_picture;
                else
                    $customObject->picture = "";


                if($k->verified == 'Yes')
                    $customObject->is_verified = True;
                else
                    $customObject->is_verified = False;

                $customObject->total_active_members = null;
                $customObject->object_type = 'User';


                array_push($mainDataset, $customObject);

            }


            $mainDataset = array_values(collect($mainDataset)->sortBy('distance_away')->toArray());


            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $mainDataset;

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["message"] = "All fields are needed.";
        }

        return response()
            ->json(array(
                'status' => $response["status"],
                isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');

    }




    /*** GROUP FILTERS API ***/
    public function filtered_groups(Request $req){
        $response = array();


        if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong)) {

            $this->date_filter = $date_filter = (isset($req->dateFilter)? date('Y-m-d', strtotime($req->dateFilter)): '');
            $this->location_filter = $location_filter = (isset($req->locationFilter)? $req->locationFilter: '');
            $this->type_category_filter = $type_category_filter =  (isset($req->typeCategoryFilter)? $req->typeCategoryFilter: '');

            if(isset($req->tribeFilter)){
                $tribeList = GroupTribe::whereIn('tribe_id',$req->tribeFilter)->distinct()->pluck('group_id');
                $this->tribe_filter = $tribe_filter =  $tribeList;
            } else
                $this->tribe_filter = $tribe_filter = '';

            if(isset($req->importantRulesFilter)){
                $importantRulesList = GroupImportantRule::whereIn('important_rule_id',$req->importantRulesFilter)->where('answer', 'Yes')->distinct()->pluck('group_id');
                $this->important_rules_filter = $important_rules_filter =  $importantRulesList;
            } else
                $this->important_rules_filter = $important_rules_filter = '';

            if(isset($req->featuresFilter)){
                $featuresList = GroupFeature::whereIn('feature_id',$req->featuresFilter)->distinct()->pluck('group_id');
                $this->features_filter = $features_filter =  $featuresList;
            } else
                $this->features_filter = $features_filter = '';
            //due to subtable title search group categories
            $this->cover_filter = $cover_filter = (isset($req->coverFilter)? $req->coverFilter: '');

            $filteredGroups = Group::with('category','tribes', 'features','rules','members')
                ->where(function($query){
                    if($this->date_filter != ''){
                        $query->where('starting_date', 'like', '%'.$this->date_filter.'%');
                    }
                })->where(function($query){
                    if($this->location_filter != ''){
                        $query->where('address', 'like', '%'.$this->location_filter.'%');
                    }
                })->where(function($query){
                    if($this->type_category_filter != ''){
                        $query->whereIn('group_category_id', $this->type_category_filter);
                    }
                })->where(function($query){
                    if($this->tribe_filter != ''){
                        $query->whereIn('group_id', $this->tribe_filter);
                    }
                })->where(function($query){
                    if($this->important_rules_filter != ''){
                        $query->whereIn('group_id', $this->important_rules_filter);
                    }
                })->where(function($query){
                    if($this->features_filter != ''){
                        $query->whereIn('group_id', $this->features_filter);
                    }
                })->where(function($query){
                    if($this->cover_filter != ''){
                        $query->where('cover', $this->cover_filter);
                    }
                })
                ->get();

            if(sizeof($filteredGroups) > 0){
                foreach($filteredGroups as $key => $k){
                    $k->cover_photo = config('base_urls.group_cover_photo_base_url').$k->cover_photo;


                    if(!(Str::contains($k->category->category_image, 'https'))){
                        $k->category->category_image = config('base_urls.group_category_image_base_url').$k->category->category_image;
                    }

                    foreach($k->rules as  $i){
                        $groupRuleDetails = GroupImportantRule::where([ ['important_rule_id', $i->important_rule_id],['group_id', $k->group_id] ])->first();
                        $i->answer = $groupRuleDetails->answer;
                        $i->group_important_rule_id = $groupRuleDetails->group_important_rule_id;
                    }

                    $k->members = $k->members->makeHidden(['password','verify_code']);

                    $groupDetails = Group::where('group_id',$k->group_id)->first();

                    foreach($k->members as $key=>$i){

                        if($i->profile_picture != null && $i->profile_picture != "")
                            $i->profile_picture = config('base_urls.profile_images_base_url').$i->profile_picture;
                        else
                            $i->profile_picture = "";

                        if($groupDetails->users_id == $i->users_id)
                            $i->is_host = true;
                        else
                            $i->is_host = false;


                        /*  $memberStatusDetails = GroupMember::where([ ['group_id',$k->group_id],['users_id', $i->users_id] ])->first();
                                if($memberStatusDetails->status != 'Accepted')
                                        unset($k->members[$key]);  */

                    }

                    /*  $k->members = $k->members->toArray();
                        $k->members = array_values($k->members); */


                    $k->total_attendees= sizeof($k->members);

                    $k->formatted_from_datetime = date('l', strtotime($k->starting_date) ).', '.date('F d,Y', strtotime($k->starting_date)).' AT '.date('H:i' ,strtotime($k->starting_time));
                    $k->formatted_to_datetime = date('l', strtotime($k->ending_date)).', '.date('F d,Y', strtotime($k->ending_date)).' AT '.date('H:i' ,strtotime($k->ending_time));

                    $checkIfUserAttendingGroup = GroupMember::checkUserMember($k->group_id, $req->usersId, 'Accepted');

                    if($checkIfUserAttendingGroup)
                        $k->is_user_attending = true;
                    else
                        $k->is_user_attending = false;


                    $checkIfUserIsInterested = UserGroupInterest::checkUserGroupInterest($k->group_id, $req->usersId);

                    if($checkIfUserIsInterested)
                        $k->is_user_interested = true;
                    else
                        $k->is_user_interested = false;


                    $checkIfUserReportedGroup = GroupReport::checkUserReportedGroup($k->group_id, $req->usersId);

                    if($checkIfUserReportedGroup)
                        $k->is_user_reported = true;
                    else
                        $k->is_user_reported = false;


                    $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
                    $k->distance_away = $distanceInKm;

                }
                $response = Helper::success(200, 'success', $filteredGroups);
            }else{
                $response = Helper::failed(404, 'error', 'No Groups found in these search filters');
            }
        } else{
            $response = Helper::failed(404, 'error', "All fields are needed");
        }

        return Helper::custom_response($response);

    }

    public function ended_group_members(Request $req)
    {
        $response = Helper::failed();
        $current_date = Carbon::now()->format('Y-m-d');


        $group = Group::where('users_id', $req->userId)->whereDate('ending_date', '<', $current_date)->orderBy('ending_date', 'DESC')->first();


        if ($group) {

            $checkAlreadyInserted = ReliabilityMember::where('group_id', $group->group_id)->count();
            if($checkAlreadyInserted == 0){
                $resultDataset = array();
                $groupMembers = GroupMember::where('group_id', $group->group_id)->get();
                foreach($groupMembers as $key=>$k){
                    $customResponseObject = new stdClass();
                    $userDetails = User::where('users_id', $k->users_id)->first();

                    $customResponseObject->users_id =  $k->users_id;
                    $customResponseObject->group_id =  $group->group_id;
                    $customResponseObject->user_name =  $userDetails->user_name;

                    $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $userDetails->user_lat, $userDetails->user_long, 'K');
                    $customResponseObject->distance_away = $distanceInKm;

                    if($userDetails->profile_picture != "" || $userDetails->profile_picture != null)
                        $customResponseObject->profile_picture = config('base_urls.profile_images_base_url').$userDetails->profile_picture;
                    else
                        $customResponseObject->profile_picture = "";

                    array_push($resultDataset, $customResponseObject);
                }

                $response = Helper::success('200', 'success', $resultDataset);

            }else
                $response = Helper::failed('404', 'error', 'Members already inserted');

        } else {
            $response = Helper::failed('404', 'error', 'No Group Found!');

        }


        return Helper::custom_response($response);
    }


    public function store_reliability_members(Request $req)
    {
        if (!isset($req->groupId) || !isset($req->memberId) || !isset($req->memberId)) {
            $response = Helper::failed(404, 'error', "(groupId:int, memberId:array, usersId:int) are required!");
            return Helper::custom_response($response);
        }

        foreach ($req->memberId as $k) {
            ReliabilityMember::Create([
                "group_id" => $req->groupId,
                "member_id" => $k,
                "users_id" => $req->usersId
            ]);
        }

        $response = Helper::success(200, 'success', "Data Saved Successfully!");
        return Helper::custom_response($response);
    }

    /*--------------- Get User Groups --------------- */
    public function get_user_groups(Request $req){
        if (isset($req->usersId)) {
            $nearbyGroups = Group::with('category','tribes', 'features','rules','members')
                            ->where('status', 'Active')->where('users_id', $req->usersId)->get();

            foreach($nearbyGroups as $key =>  $k){
            //main loop
            $k->cover_photo = config('base_urls.group_cover_photo_base_url').$k->cover_photo;

            if(!(Str::contains($k->category->category_image, 'https'))){
                $k->category->category_image = config('base_urls.group_category_image_base_url').$k->category->category_image;
            }

            foreach($k->rules as  $i){
                $groupRuleDetails = GroupImportantRule::where([ ['important_rule_id', $i->important_rule_id],['group_id', $k->group_id] ])->first();
                $i->answer = $groupRuleDetails->answer;
                $i->group_important_rule_id = $groupRuleDetails->group_important_rule_id;
            }

            $k->members = $k->members->makeHidden(['password','verify_code']);

            $groupDetails = Group::where('group_id',$k->group_id)->first();

            foreach($k->members as $key=>$i){

                //for online status
                    $userData = User::where('users_id', $i->users_id)->first();
                    if($userData->online == 'Yes')
                        $i->is_online = true;
                    else
                        $i->is_online = false;

                if($i->profile_picture != null && $i->profile_picture != "")
                    $i->profile_picture = config('base_urls.profile_images_base_url').$i->profile_picture;
                else
                    $i->profile_picture = "";

                if($groupDetails->users_id == $i->users_id)
                    $i->is_host = true;
                else
                    $i->is_host = false;
            }

            $k->total_attendees= sizeof($k->members);

            $k->formatted_from_datetime = date('l', strtotime($k->starting_date) ).', '.date('F d,Y', strtotime($k->starting_date)).' AT '.date('H:i' ,strtotime($k->starting_time));
            $k->formatted_to_datetime = date('l', strtotime($k->ending_date)).', '.date('F d,Y', strtotime($k->ending_date)).' AT '.date('H:i' ,strtotime($k->ending_time));

            $checkIfUserAttendingGroup = GroupMember::checkUserMember($k->group_id, $req->usersId, 'Accepted');

            if($checkIfUserAttendingGroup)
                $k->is_user_attending = true;
            else
                $k->is_user_attending = false;


            $checkIfUserIsInterested = UserGroupInterest::checkUserGroupInterest($k->group_id, $req->usersId);

            if($checkIfUserIsInterested)
                $k->is_user_interested = true;
            else
                $k->is_user_interested = false;


            $checkIfUserReportedGroup = GroupReport::checkUserReportedGroup($k->group_id, $req->usersId);

            if($checkIfUserReportedGroup)
                $k->is_user_reported = true;
            else
                $k->is_user_reported = false;


            $distanceInKm = Helper::calculate_miles($req->userLat, $req->userLong, $k->group_lat, $k->group_long, 'K');
            $k->distance_away = $distanceInKm;

            if($distanceInKm > 100)
                unset($nearbyGroups[$key]);


            }

            $nearbyGroups = array_values(collect($nearbyGroups)->sortBy('distance_away')->toArray());

            $response['code'] = 200;
            $response['status'] = 'success';
            $response['data'] = $nearbyGroups;
        } else{
            $response['code'] = 404;
            $response['status'] = 'error';
            $response['message'] = 'Please enter user id.';
        }

        return response()
        ->json(['status' => $response['status'], isset($response['message']) ? 'message' : 'data' => isset($response['message']) ? $response['message'] : $response['data']])
        ->header('Content-Type', 'application/json');
    }
    /*--------------- Get User Groups --------------- */
}
