<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\Controller;
use Mail;
use Carbon\Carbon;
use Illuminate\Support\Facades\Hash;
use File;
use DB;
use Stripe\Stripe;
use Stripe\Charge;
use Stripe\Customer;
use Stripe\StripeClient;
use DateTime;
use Illuminate\Support\Arr;
use App\Models\User;






class LoginAuthenticationController extends Controller{
    public $successStatus = 200;
    public $errorStatus = 401;


    //================ USER AUTHENTICATION AND REGISTRATION ===================//


    /*** GET USER TOKEN ***/
    public function get_token(Request $req){
        $response["code"] = 200;
        $response["status"] = "success";
        $response["token"] = csrf_token();
        return $response;
    }

    /*** GENERATE CODE ***/
    public function generate_code($limit){
        $permitted_chars = '0123456789';
        return substr(str_shuffle($permitted_chars), 0, $limit);
    }

    /*** SEND MAIL ***/
    public function send_email($to, $subject, $message) {

        $headers = "MIME-Version: 1.0" . "\r\n";
        $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
        // More headers
        $headers .= 'From: <support@eigix.com>' . "\r\n";
        $mail = mail($to, $subject, $message, $headers);
        return $mail;
    }

               /***TEST GET API**/
     public function get_about_desc(Request $req){
         $aboutDescription = DB::table('system_settings')->where('type', 'about_description_app')->first();
            $response["code"] = 200;
            $response["status"] = "success";
            $response["data"] = $aboutDescription->description;

            return response()
            ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
            ->header('Content-Type', 'application/json');
        }


          /*** CHECK ALREADY REGISTERED ***/
          public  function check_already_registered(Request $req){
            $response = array();


            if (isset($req->userEmail) && isset($req->userName)){
                    $username_exists = User::where('user_name', $req->userName)->get()->count();
                if ($username_exists == 0) {
                    $useremail_exists = User::where('email', $req->userEmail)->get()->count();
                    if ($useremail_exists == 0) {
                        $response["code"] = 200;
                        $response["status"] = "success";
                        $response["data"] = 'Unique email and username';
                    } else {
                        $response["code"] = 404;
                        $response["status"] = "error";
                        $response["message"] = "Email address already exists.";
                    }
                } else {
                    $response["code"] = 404;
                    $response["status"] = "error";
                    $response["message"] = "User name already exists.";
                }
            } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["message"] = "All fields are needed.";
            }


            return response()
                        ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                        ->header('Content-Type', 'application/json');

    }


    /*** SIGNUP USER ***/
    public  function signup(Request $req){
        $response = array();


        if (isset($req->userEmail) && isset($req->userName) && isset($req->birthday) && isset($req->userPassword) && isset($req->confirmPassword) && isset($req->oneSignalId) && isset($req->phoneNumber)) {
            $username_exists = User::where('user_name', $req->userName)->get()->count();
            if ($username_exists == 0) {
                $useremail_exists = User::where('email', $req->userEmail)->get()->count();
                if ($useremail_exists == 0) {
                    if($req->userPassword == $req->confirmPassword){
                        $user_data = array(
                            'user_name' => $req->userName,
                            'email' => $req->userEmail,
                            'password' => password_hash($req->userPassword, PASSWORD_DEFAULT),
                            'account_type' => 'SignupWithApp',
                            'phone_number' => $req->phoneNumber,
                            'verify_code' => '',
                            'birthday' => date('Y-m-d', strtotime($req->birthday)),
                            'gender' => 'Male',
                            'social_acc_type' => 'None',
                            'one_signal_id' => $req->oneSignalId,
                            'notification_status' => 'False',
                            'date_added' => date('Y-m-d H:i:s'),
                            'status' => 'Active',
                            'roles_id' => '1',

                        );


                        if (User::insert($user_data)) {
                            $user_details = User::where('user_name', $req->userName)->first();
                            if (!empty($user_details)) {
                                    if($user_details->profile_picture != ""){
                                        $base_url_profile_images = config('base_urls.profile_images_base_url');
                                        $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                        }

                                $response["code"] = 200;
                                $response["status"] = "success";
                                $response["temp_password_flag"] = "0";
                                $response["data"] = $user_details;
                            } else {
                                $response["code"] = 404;
                                $response["status"] = "error";
                                $response["temp_password_flag"] = "0";
                                $response["message"] = "User does not exists.";
                            }
                        } else {
                            $response["code"] = 500;
                            $response["status"] = "error";
                            $response["temp_password_flag"] = "0";
                            $response["message"] = "Something went wrong.";
                        }
                    }else{
                        $response["code"] = 404;
                        $response["status"] = "error";
                        $response["temp_password_flag"] = "0";
                        $response["message"] = "Password  did not Match.";
                    }
                } else {
                    $response["code"] = 404;
                    $response["status"] = "error";
                    $response["temp_password_flag"] = "0";
                    $response["message"] = "Email address already exists.";
                }
            } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["temp_password_flag"] = "0";
                $response["message"] = "User name already exists.";
            }
        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["temp_password_flag"] = "0";
            $response["message"] = "All fields are needed.";
        }


        return response()
                    ->json(array('temp_password_flag' => $response["temp_password_flag"],'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');

}



    /*** SIGNUP with Google/Apple  ***/
    public  function signup_with_social(Request $req){
        $response = array();

        if (isset($req->accountType) && isset($req->oneSignalId)) {

                switch($req->accountType){
                    case 'google':
                        $accesstoken_exists = User::where('google_access_token', $req->googleAccessToken)->whereNotNull('google_access_token')->get()->count();
                        $useremail_exists = User::where('email', $req->userEmail)->get()->count();


                        if($useremail_exists == 1){

                            //returning old data
                               if($accesstoken_exists == 0){
                                      //updating user info with google access token and giving old data
                                      $query = User::where('email',$req->userEmail)->update(array('account_type'=> 'Both','google_access_token' => $req->googleAccessToken));
                                          if($query){
                                            $user_details = User::where('google_access_token', $req->googleAccessToken)->first();
                                            if($user_details){
                                                if(password_verify('123456', $user_details->password)){
                                                    $response["temp_password_flag"] = "1";
                                                } else{
                                                    $response["temp_password_flag"] = "0";
                                                }
                                                if($user_details->profile_picture != ""){
                                                    $base_url_profile_images = config('base_urls.profile_images_base_url');
                                                    $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                                    }
                                                    //updating one signal device id for user
                                            User::where('users_id', $user_details->users_id)->update(array('one_signal_id' => $req->oneSignalId));
                                                $response["code"] = 200;
                                            $response["status"] = "success / Signed in with Google";
                                            $response["data"] = $user_details;
                                                }
                                          }

                                    } else{
                                       //simple returning old data
                                        $user_details = User::where('google_access_token', $req->googleAccessToken)->first();
                                        if($user_details){
                                            if(password_verify('123456', $user_details->password)){
                                                $response["temp_password_flag"] = "1";
                                            } else{
                                                $response["temp_password_flag"] = "0";
                                            }
                                            if($user_details->profile_picture != ""){
                                                $base_url_profile_images = config('base_urls.profile_images_base_url');
                                                $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                                }
                                                //updating one signal device id for user
                                            User::where('users_id', $user_details->users_id)->update(array('one_signal_id' => $req->oneSignalId));
                                            $response["code"] = 200;
                                        $response["status"] = "success / Signed in with Google";
                                        $response["data"] = $user_details;
                                            }

                     }

                        } else{
                            //new google register
                            $user_data = array(
                                'user_name' => (isset($req->userName) ? $req->userName: ''),
                                'email' => (isset($req->userEmail) ? $req->userEmail: ''),
                                'date_added' => date('Y-m-d H:i:s'),
                                'password' => password_hash('123456', PASSWORD_DEFAULT),
                                'roles_id' => '1',
                                'gender' => 'Male',
                                'status' => 'Active',
                                'one_signal_id' => $req->oneSignalId,
                                'account_type' => 'SignupWithSocial',
                                'notification_status' => 'False',
                                'social_acc_type'=> 'Google',
                                'verify_code' => '',
                                'profile_picture' => '',
                                'google_access_token' => $req->googleAccessToken,

                            );

                            $query =  User::insert($user_data);
                            if($query){
                                $user_details = User::where('google_access_token', $req->googleAccessToken)->first();
                                   if (!empty($user_details)) {
                                    if($user_details->profile_picture != ""){
                                        $base_url_profile_images = config('base_urls.profile_images_base_url');
                                        $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                        }

                                        if($user_details->profile_picture != ""){
                                            $base_url_profile_images = config('base_urls.profile_images_base_url');
                                            $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                            }
                                        $response["code"] = 200;
                                        $response["status"] = "success / Signed in with Google";
                                        $response["temp_password_flag"] = "1";
                                        $response["data"] = $user_details;
                                   } else{
                                    $response["code"] = 404;
                                    $response["temp_password_flag"] = "0";
                                    $response["status"] = "error";
                                    $response["message"] = "User not found";
                                   }
                            } else{
                                $response["code"] = 500;
                            $response["status"] = "error";
                            $response["temp_password_flag"] = "0";
                            $response["message"] = "Something went wrong while inserting data.";
                            }

                        }

                break;

                    case 'apple':
                        $appleid_exists = User::where('apple_id', $req->appleId)->get()->count();
                        if(isset($req->userEmail)){
                            $useremail_exists = User::where('email', $req->userEmail)->get()->count();
                        } else{
                            $useremail_exists = "0";
                        }

                        if($useremail_exists == 1){
                            //returning old data
                               if($appleid_exists == 0){
                                      //updating user info with Apple id and giving old data
                                      $query = User::where('email',  $req->userEmail)->update(array('account_type'=> 'Both','apple_id' => $req->appleId));
                                      if($query){
                                        $user_details = User::where('apple_id', $req->appleId)->first();
                                        if($user_details){
                                            $response["code"] = 200;
                                            if(password_verify('123456', $user_details->password)){
                                                $response["temp_password_flag"] = "1";
                                            } else{
                                                $response["temp_password_flag"] = "0";
                                            }
                                            if($user_details->profile_picture != ""){
                                                $base_url_profile_images = config('base_urls.profile_images_base_url');
                                                $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                                }
                                            //updating one signal device id for user
                                            User::where('users_id', $user_details->users_id)->update(array('one_signal_id' => $req->oneSignalId));
                                        $response["status"] = "success / Signed in with Apple";
                                        $response["data"] = $user_details;
                                            }
                                      }
                                } else{
                                    //simple returning old data
                                    $user_details = User::where('apple_id', $req->appleId)->first();
                                    if($user_details){
                                        $response["code"] = 200;
                                                    if(password_verify('123456', $user_details->password)){
                                                            $response["temp_password_flag"] = "1";
                                                        } else{
                                                            $response["temp_password_flag"] = "0";
                                                        }
                                        if($user_details->profile_picture != ""){
                                            $base_url_profile_images = config('base_urls.profile_images_base_url');
                                            $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                            }
                                            //updating one signal device id for user
                                            User::where('users_id', $user_details->users_id)->update(array('one_signal_id'=> $req->oneSignalId));
                                        $response["status"] = "success / Signed in with Apple";
                                    $response["data"] = $user_details;
                                }
                                }
                        }  else {
                            if($appleid_exists == 1){
                                //updating user info with Apple id and giving old data
                                  $user_details = User::where('apple_id', $req->appleId)->first();
                                  if($user_details){
                                      $response["code"] = 200;
                                      if(password_verify('123456', $user_details->password)){
                                          $response["temp_password_flag"] = "1";
                                      } else{
                                          $response["temp_password_flag"] = "0";
                                      }
                                      if($user_details->profile_picture != ""){
                                        $base_url_profile_images = config('base_urls.profile_images_base_url');
                                        $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                        }

                                        //updating one signal device id for user
                                        User::where('users_id', $user_details->users_id)->update(array('one_signal_id' => $req->oneSignalId));
                                  $response["status"] = "success / Signed in with Apple";
                                  $response["data"] = $user_details;
                                      }

                          } else{
                            //new Apple register
                            $user_data = array(
                                'user_name' => (isset($req->userName) ? $req->userName: ''),
                                'email' => (isset($req->userEmail) ? $req->userEmail: ''),
                                'date_added' => date('Y-m-d H:i:s'),
                                'password' => password_hash('123456', PASSWORD_DEFAULT),
                                'roles_id' => '1',
                                'gender' => 'Male',
                                'status' => 'Active',
                                'one_signal_id' => $req->oneSignalId,
                                'account_type' => 'SignupWithSocial',
                                'social_acc_type'=> 'Apple',
                                'notification_status' => 'False',
                                'verify_code' => '',
                                'profile_picture' => '',
                                'apple_id' => $req->appleId
                            );
                            $query =  User::insert($user_data);
                            if($query){
                                $user_details = User::where('apple_id', $req->appleId)->first();
                                   if (!empty($user_details)) {
                                    if($user_details->profile_picture != ""){
                                        $base_url_profile_images = config('base_urls.profile_images_base_url');
                                        $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                        }

                                        $response["code"] = 200;
                                        $response["temp_password_flag"] = "1";
                                        $response["status"] = "success / Signed in with Apple";
                                        $response["data"] = $user_details;
                                   } else{
                                    $response["code"] = 404;
                                    $response["status"] = "error";
                                    $response["temp_password_flag"] = "0";
                                    $response["message"] = "User not found";
                                   }
                            } else{
                                $response["code"] = 500;
                            $response["status"] = "error";
                            $response["temp_password_flag"] = "0";
                            $response["message"] = "Something went wrong while inserting data.";
                            }
                        }
                    }
                break;

                default:
                $response["code"] = 500;
                $response["status"] = "error";
                $response["temp_password_flag"] = "0";
                $response["message"] = "Invalid Account Type.";
                    }

        } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["temp_password_flag"] = "0";
            $response["message"] = "All fields are needed.";
        }


        return response()
                    ->json(array('temp_password_flag' => $response["temp_password_flag"],'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');
    }




    /*** LOGIN USER ***/
    public  function login(Request $req){

        $response = array();
       // if (isset($req->usernameOrEmail) && isset($req->userPassword) && isset($req->oneSignalId)) {
            $user_details = User::where('user_name', $req->usernameOrEmail)->orWhere('email', $req->usernameOrEmail)->first();
            
            if($user_details->account_type=="SignupWithApp"){
                $user_details->account_type="SignInWithUserName";
            }   
             
            if ($user_details) {
                if (password_verify($req->userPassword, $user_details->password)) {
                    $user_info = User::where('users_id', $user_details->users_id)->first();
                    if (!empty($user_info)) {
                        if ($user_details->roles_id == '1') {

                            if($user_details->profile_picture != ""){
                                $base_url_profile_images = config('base_urls.profile_images_base_url');
                                $user_details->profile_picture = $base_url_profile_images.$user_details->profile_picture;
                                }

                            User::where('users_id', $user_details->users_id)->update(array('one_signal_id' => $req->oneSignalId));
        
                            $response["code"] = 200;
                            $response["status"] = "success";
                              if(password_verify('123456', $user_details->password)){
                                  $response["temp_password_flag"] = "1";
                              } else{
                                $response["temp_password_flag"] = "0";
                              }
                            $response["data"] = $user_details;
                        }
                    }
                } else {
                    $response["code"] = 404;
                    $response["status"] = "error";
                    $response["temp_password_flag"] = "0";
                    $response["message"] = "Invalid email or password";
                }
            } else {
                $response["code"] = 404;
                $response["status"] = "error";
                $response["temp_password_flag"] = "0";
                $response["message"] = "Invalid email or password";
            }
    /*     } else {
            $response["code"] = 404;
            $response["status"] = "error";
            $response["temp_password_flag"] = "0";
            $response["message"] = "All fields are needed.";
        } */



        return response()
                    ->json(array('temp_password_flag' => $response["temp_password_flag"],'status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');
    }

    /*** FORGOT PASSWORD USER ***/
    public function forgot_password(Request $req){
		$postdata=file_get_contents("php://input");
		$post_data=json_decode($postdata);
		$response=array();
		$requestType=$post_data->requestType;

		switch($requestType){
			case 'forgot_password':
			    $email	    =   $post_data->email;
			    if(isset($email)){
			        $get_query = User::where('email', $email)->get()->count();
			        if($get_query > 0){
        				$update['verify_code'] = $this->generate_code(4);
                        $query =   User::where('email', '=', $email)->update($update);
    					if($query){
    						$email_template = "Dear,
    						Here is your verification code. This code can only be used for one time only.
    						{verify_code}";
    						$subject = "Verification Code";
    						$message = $email_template;
    						$message = str_replace("{verify_code}", $update['verify_code'], $message);
    						$result = $this->send_email($email, $subject, $message);
    						if($result){
    							$response['code']		= 200;
    							$response['status'] ='Success';
    							$response['message']='Verification Code is Successfully sent to your Email Address';
    						} else {
    							$response['code']		= 404;
    							$response['status'] ='error';
    							$response['message']='Verification Code is not sent to your Email Address';
    						}
    					} else {
    						$response['code']		= 404;
    						$response['status'] = "Error";
    						$response['msg']    = "Code is not generated";
    					}
			        } else {
        				$response['code']		= 404;
        				$response['status']="error";
        				$response['message']="email not found";
        			}
    			} else{
    				$response['code']		= 404;
    				$response['status'] ='error';
    				$response['message']='email is required';
			    }

				return response()
                    ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');
		    break;

    		case 'match_code':
    			$email      = $post_data->email;
    			$code       = $post_data->code;
    			$email_get  = User::where('email', $email)->first();
    			if($email_get){
    				$matchCode=$email_get->verify_code;
    				if($matchCode == $code){
    					$response['code']		= 200;
    					$response['status'] = 'Success';
    					$response['message']= 'Your Code is Successfully Verified';
    				} else{
    					$response['code']		= 404;
    					$response['status'] = 'error';
    					$response['message']= 'Code doesnot match,Try Again Please';
    				}
    			} else{
    				$response['code']		= 404;
    				$response['status'] = 'error';
    				$response['message']= 'No such Email is present in Database';
    			}

    			return response()
                    ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');
    		break;

    		case 'reset_password':
    			$email	 	    = $post_data->email;
    			$password	    = $post_data->password;
    			$c_password	    = $post_data->confirmPassword;
    			$email_get      = User::where('email', $email)->first();
    			$old_password   = $email_get->password;
    			if($email_get){
    				if($password == $c_password){
    					if($old_password != $password){
    						$update['password'] = password_hash($password,PASSWORD_BCRYPT);
                            $query =   User::where('email', $email)->update($update);
    						if($query){
    							$response['code']		= 200;
    							$response['status'] = 'Success';
    							$response['message']= 'You have successfully Updated Your Password';
    						} else {
    							$response['code']		= 404;
    							$response['status'] = 'error';
    							$response['message']= 'Password is not Updated';
    						}
    					} else {
    						$response['code']		= 404;
    						$response['status'] = 'error';
    						$response['message']= 'This is your OLD password,Please try with new Strong Password';
    					}
    				} else {
    					$response['code']	= 404;
    					$response['status'] = 'error';
    					$response['message']= 'Password and confirm password are not Matching';
    				}
    			} else {
    				$response['code']	= 404;
    				$response['status'] = 'error';
    				$response['message']= 'No such Email is present in Database';
    			}

    			return response()
                    ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
                    ->header('Content-Type', 'application/json');
    		break;
		}
    }



   /*** UPDATE USER LOCATION API ***/
   public function update_user_location(Request $req){
    $response = array();


    if (isset($req->usersId) && isset($req->userLat) && isset($req->userLong)) {
            $updateQuery =   User::where('users_id', $req->usersId)->update(['user_lat' => $req->userLat, 'user_long' => $req->userLong] );
            $updateOnlineStatus =     User::where('users_id', $req->usersId)->update(['online' => 'Yes']);


                $response["code"] = 200;
                $response["status"] = "success";
                $response["data"] = 'Location updated successfully';

    } else{
        $response["code"] = 404;
        $response["status"] = "error";
        $response["message"] = "All fields are needed";
    }
    return response()
    ->json(array('status' => $response["status"], isset($response["message"]) ? 'message' : 'data' => isset($response["message"]) ? $response["message"] : $response["data"]))
    ->header('Content-Type', 'application/json');
}

}
