<?php
namespace App\Http\Controllers;

use App\Imports\UsersImport;
use App\Models\reference;
use App\Models\Application;
use GuzzleHttp\Client;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Maatwebsite\Excel\Facades\Excel;

class MemberController extends Controller{

    //index
    public function index(Request $request){

        $application = Application::where("status","!=","");
//        $application = Application();

        $search = (!isset($request->search) && empty($request->search)) ? '' : $request->search;
        $platinum = (!isset($request->platinum) && empty($request->platinum)) ? '' : $request->platinum;
        $gold = (!isset($request->gold) && empty($request->gold)) ? '' : $request->gold;
        $silver = (!isset($request->silver) && empty($request->silver)) ? '' : $request->silver;
        $bronze = (!isset($request->bronze) && empty($request->bronze)) ? '' : $request->bronze;
        $state = (!isset($request->state) && empty($request->state)) ? '' : $request->state;
        $city = (!isset($request->city) && empty($request->city)) ? '' : $request->city;
        $trust = (!isset($request->trust) && empty($request->trust)) ? '' : $request->trust;
        $bank = (!isset($request->bank) && empty($request->bank)) ? '' : $request->bank;



        if (!empty($search)) {
            $application->where('app_name', 'like', '%' . $search . '%')
                ->orWhere('app_bvn', 'like', '%' . $search . '%')
                ->orWhere('app_account_no', 'like', '%' . $search . '%')
                ->orWhere('app_bank_name', 'like', '%' . $search . '%')
                ->orWhere('app_phone_no', 'like', '%' . $search . '%')
                ->orWhere('app_email', 'like', '%' . $search . '%')
                ->orWhere('app_address', 'like', '%' . $search . '%')
                ->orWhere('app_state', 'like', '%' . $search . '%')
                ->orWhere('app_zone', 'like', '%' . $search . '%')
                ->orWhere('app_sponsor', 'like', '%' . $search . '%')
                ->orWhere('app_sponsors_affilate', 'like', '%' . $search . '%');
        }


        if (!empty($platinum)) {
            $application->where('app_membership_level','=',$platinum);
        }
        if (!empty($gold)) {
            $application->where('app_membership_level','=',$gold);
        }
        if (!empty($silver)) {
            $application->where('app_membership_level','=',$silver);
        }
        if (!empty($bronze)) {
            $application->where('app_membership_level','=',$bronze);
        }
        if (!empty($trust)) {
            $application->where('app_trust_level','=',$trust);
        }
        if (!empty($bank)) {
            $application->where('app_bank_name','=',$bank);
        }
        if (!empty($state)) {
            $application->where('app_state', 'like', '%' . $state . '%');
        }
        if (!empty($city)) {
            $application->where('app_zone', 'like', '%' . $city . '%');
        }


        $application = $application->paginate(25);
        return view('welcome',compact('application'));
    }


//   old excel upload
//        public function add_excel_member(Request $request){
//        $file = $request->file('file');
//        Excel::import(new UsersImport, $file);
//        return redirect('/')->with('success', 'Excel Successfully Uploaded');
//    }

    //  mid old  excel upload
//    public function add_excel_member(Request $request){
//        $file = $request->file('file');
//        Excel::import(new UsersImport, $file);
//        return redirect('/')->with('success', 'Excel Successfully Uploaded');
//    }


    //    excel upload
    public function add_excel_member(Request $request){
        $file = $request->file('file');
        Excel::import(new UsersImport, $file);

        $get_apps = Application::where('status','=','Inactive')->get();

        foreach($get_apps as $get_app){

            // Open Account Api
            // fetch database data
            $ref = reference::orderBy('id', 'desc')->first();
            $request_ref = $ref->request_ref + 180;
            $transaction_ref = $ref->transaction_ref + 180;
            $customer_ref = $ref->customer_ref + 180;




            // encrypt bvn code
            $encryption_key = "kLkIfuBgPLnKxn0P";
            $data = $get_app->app_bvn;
            $method = "des-ede3-cbc";
            $source = mb_convert_encoding($encryption_key, 'UTF-16LE', 'UTF-8');
            $encryption_key = md5($source, true);
            $encryption_key .= substr($encryption_key, 0, 16);
            $iv =  "\0\0\0\0\0\0\0\0";
            $encData = openssl_encrypt($data,$method, $encryption_key, $options=OPENSSL_RAW_DATA, $iv);
            $bvntext = base64_encode($encData);




            // create signature
            // $combine = $request_ref.";". env("ONE_PIPE_API_SECRET_KEY");
            $combine = $request_ref.";kLkIfuBgPLnKxn0P";
            $signature =  md5($combine);

            // Api call
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://api.onepipe.io/v2/transact',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS =>'{
                "request_ref":'. $request_ref.',
                "request_type": "open_account",
                "auth": {
    "type": "bvn", 
    "secure": "'.$bvntext.'",
                    "auth_provider": "DemoProvider",
                    "route_mode": null
                },
                "transaction": {
                    "mock_mode": "inspect",
                    "transaction_ref":'. $transaction_ref.',
                    "transaction_desc": "A random transaction",
                    "transaction_ref_parent": null,
                    "amount": 0,
                    "customer": {
                        "customer_ref": "DemoApp_Customer007",
                        "firstname": "Uju",
                        "surname": "Usmanu",
                        "email": "ujuusmanu@gmail.com",
                        "mobile_no": "234802343132"
                    },
                    "meta": {
                        "a_key": "a_meta_value_1",
                        "another_key": "a_meta_value_2"
                    },
                    "details": {
                        "name_on_account": "Tobi Olajide",
                        "middlename": "string",
                        "dob": "2020-09-20-11-30-30",
                        "gender": "M",
                        "title": "Mr",
                        "address_line_1": "23, Okon street, Ikeja",
                        "address_line_2": "Ikeja",
                        "city": "lagos",
                        "state": "lagos",
                        "country": "NG"
                    }
                }
            }',
                CURLOPT_HTTPHEADER => array(
                    'Authorization: Bearer nSf6jEmVa5YNnRKxi03D_24556c6166a648a09f1619629befe9f2',
                    'Signature:' . $signature,
                    'Content-Type: application/json'
                ),
            ));

            $response = curl_exec($curl);
            curl_close($curl);
            $result = json_decode($response);


            // if status successful store data on database
            if($result->status == "Successful"){

//                store reference
                $add_ref = new reference();
                $add_ref->request_ref = $request_ref;
                $add_ref->transaction_ref= $transaction_ref;
                $add_ref->customer_ref= $customer_ref;
                $add_ref->timestamps = false;
                $add_ref->save();


//                update application
                $response_data = $result->data->provider_response;

//dd($response_data->account_number);

                $store = Application::where('app_id',$get_app->app_id)->first();
                $store->app_name = $response_data->account_name;
                $store->app_account_no = $response_data->account_number;
                $store->app_bank_name = $response_data->bank_name;
                $store->currency_code = $response_data->currency_code;
                $store->app_email = $response_data->customer_email;
                $store->bank_code = $response_data->bank_code;
                $store->account_type = $response_data->account_type;
                $store->account_created_at = $response_data->created_on;
                $store->status = $response_data->status;
                $store->save();
            }
        }
        return redirect('/')->with('success', 'Excel Successfully Uploaded');
    }

//    store member
    public function store_member(Request $request)
    {

        $this->validate($request, [
            'name' => ['required', 'max:255'],
            'bvn' => ['required', 'max:255', 'unique:applications,app_bvn'],
            'bank_name' => ['required'],
            'account_no' => ['required', 'max:255', 'unique:applications,app_account_no'],
            'number' => ['required', 'max:255',  'unique:applications,app_phone_no'],
            'email' => ['required', 'max:255', 'unique:applications,app_email'],
            'address' => ['required'],
            'state' => ['required'],
            'zone' => ['required'],
            'sponsor' => ['required', 'max:255'],
            'affilate' => ['required'],
            'trust_level' => ['required'],
//            'membership_level' => ['required', 'max:255'],
        ]);

        $store = new Application();
        $store->app_name = $request->name;
        $store->app_bvn = $request->bvn;
        $store->app_account_no = $request->account_no;
        $store->app_bank_name = $request->bank_name;
                $store->app_phone_no = $request->number;
        $store->app_email = $request->email;
                $store->app_address = $request->address;
        $store->app_state = $request->state;
                $store->app_zone = $request->zone;
        $store->app_sponsor = $request->sponsor;
                $store->app_sponsors_affilate = $request->affilate;
        $store->app_trust_level = $request->trust_level;
                $store->app_membership_level = "Silver";
        $store->save();



        // Open Account Api
        // fetch database data
        $ref = reference::orderBy('id', 'desc')->first();
        $request_ref = $ref->request_ref + 180;
        $transaction_ref = $ref->transaction_ref + 180;
        $customer_ref = $ref->customer_ref + 180;




        // encrypt bvn code
        $encryption_key = "kLkIfuBgPLnKxn0P";
        $data = $store->app_bvn;
        $method = "des-ede3-cbc";
        $source = mb_convert_encoding($encryption_key, 'UTF-16LE', 'UTF-8');
        $encryption_key = md5($source, true);
        $encryption_key .= substr($encryption_key, 0, 16);
        $iv =  "\0\0\0\0\0\0\0\0";
        $encData = openssl_encrypt($data,$method, $encryption_key, $options=OPENSSL_RAW_DATA, $iv);
        $bvntext = base64_encode($encData);




        // create signature
        // $combine = $request_ref.";". env("ONE_PIPE_API_SECRET_KEY");
        $combine = $request_ref.";kLkIfuBgPLnKxn0P";
        $signature =  md5($combine);

        // Api call
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.onepipe.io/v2/transact',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{
                "request_ref":'. $request_ref.',
                "request_type": "open_account",
                "auth": {
    "type": "bvn", 
    "secure": "'.$bvntext.'",
                    "auth_provider": "DemoProvider",
                    "route_mode": null
                },
                "transaction": {
                    "mock_mode": "inspect",
                    "transaction_ref":'. $transaction_ref.',
                    "transaction_desc": "A random transaction",
                    "transaction_ref_parent": null,
                    "amount": 0,
                    "customer": {
                        "customer_ref": "DemoApp_Customer007",
                        "firstname": "Uju",
                        "surname": "Usmanu",
                        "email": "ujuusmanu@gmail.com",
                        "mobile_no": "234802343132"
                    },
                    "meta": {
                        "a_key": "a_meta_value_1",
                        "another_key": "a_meta_value_2"
                    },
                    "details": {
                        "name_on_account": "Tobi Olajide",
                        "middlename": "string",
                        "dob": "2020-09-20-11-30-30",
                        "gender": "M",
                        "title": "Mr",
                        "address_line_1": "23, Okon street, Ikeja",
                        "address_line_2": "Ikeja",
                        "city": "lagos",
                        "state": "lagos",
                        "country": "NG"
                    }
                }
            }',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer nSf6jEmVa5YNnRKxi03D_24556c6166a648a09f1619629befe9f2',
                'Signature:' . $signature,
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);
        curl_close($curl);
        $result = json_decode($response);


        // if status successful store data on database
        if($result->status == "Successful"){

//                store reference
            $add_ref = new reference();
            $add_ref->request_ref = $request_ref;
            $add_ref->transaction_ref= $transaction_ref;
            $add_ref->customer_ref= $customer_ref;
            $add_ref->timestamps = false;
            $add_ref->save();


//                update application
            $response_data = $result->data->provider_response;

//dd($response_data->account_number);

            $store = Application::where('app_id',$store->app_id)->first();
            $store->app_name = $response_data->account_name;
            $store->app_account_no = $response_data->account_number;
            $store->app_bank_name = $response_data->bank_name;
            $store->currency_code = $response_data->currency_code;
            $store->app_email = $response_data->customer_email;
            $store->bank_code = $response_data->bank_code;
            $store->account_type = $response_data->account_type;
            $store->account_created_at = $response_data->created_on;
            $store->status = $response_data->status;
            $store->save();
        }


        return back()->with('success', 'Member Successfully Created');

    }

    public function edit_member($id){

        $emp = Application::where('app_id','=',$id)->first();

        if ($emp){
            return response()->json([
                'status'=>200,
                'application'=>$emp
            ]);
        }else{
            return response()->json([
                'status'=>400,
                'message'=>"Not Found"
            ]);
        }

    }

    public function update_member(Request $request){

//        dd($request->all());

        $store = Application::where('app_id',$request->id)->first();
        $store->app_name = $request->name;
        $store->app_bvn = $request->bvn;
        $store->app_account_no = $request->account_no;
        $store->app_bank_name = $request->bank_name;
        $store->app_phone_no = $request->number;
        $store->app_email = $request->email;
        $store->app_address = $request->address;
        $store->app_state = $request->state;
        $store->app_zone = $request->zone;
        $store->app_sponsor = $request->sponsor;
        $store->app_sponsors_affilate = $request->affilate;
        $store->app_trust_level = $request->trust_level;
//        $store->app_membership_level = "Silver";
        $store->save();

        return back()->with('success', 'Member Successfully Updated');




//        if ($request->hasFile('image')){
//
////                delete img
//            $path ='uploads/application/'.$application->image;
//            if (File::exists($path)){
//                File::delete($path);
//            }
//
//
////                store img
//            $file = $request->file("image");
//            $extension = $file->getClientOriginalExtension();
//            $filename = time() . "." . $extension;
//            $file->move('uploads/application/',$filename);
//            $application->image = $filename;
//
////            }
//            $application->save();
//
//            return response()->json([
//                'status'=>200,
//                'errors'=>"Employee Image Updated"
//            ]);
//
//
//        }

    }

    public function delete_member($id){

        $emp = Application::where('app_id','=',$id)->first();

        if ($emp){

//            //                delete img
//            $path ='uploads/application/'.$emp->image;
//            if (File::exists($path)){
//                File::delete($path);
//            }

            $emp->delete();

            return response()->json([
                'status'=>200,
                'message'=>"Employee Deleted Successfully"
            ]);
        }else{
            return response()->json([
                'status'=>400,
                'message'=>"Not Found"
            ]);
        }

    }


    // open account
    public function open_account(){

        // Open Account Api
        // fetch database data
        $ref = reference::orderBy('id', 'desc')->first();
        $request_ref = $ref->request_ref + 100;
        $transaction_ref = $ref->transaction_ref + 100;
        $customer_ref = $ref->customer_ref + 100;

        // create signature
        // $combine = $request_ref.";". env("ONE_PIPE_API_SECRET_KEY");
        $combine = $request_ref.";kLkIfuBgPLnKxn0P";
        $signature =  md5($combine);

        // Api call
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.onepipe.io/v2/transact',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{
                "request_ref":'.$request_ref.',
                "request_type": "open_account",
                "auth": {
                    "type": null,
                    "secure": null,
                    "auth_provider": "DemoProvider",
                    "route_mode": null
                },
                "transaction": {
                    "mock_mode": "inspect",
                    "transaction_ref":'. $transaction_ref.',
                    "transaction_desc": "A random transaction",
                    "transaction_ref_parent": null,
                    "amount": 0,
                    "customer": {
                        "customer_ref": "DemoApp_Customer007",
                        "firstname": "Uju",
                        "surname": "Usmanu",
                        "email": "ujuusmanu@gmail.com",
                        "mobile_no": "234802343132"
                    },
                    "meta": {
                        "a_key": "a_meta_value_1",
                        "another_key": "a_meta_value_2"
                    },
                    "details": {
                        "name_on_account": "Tobi Olajide",
                        "middlename": "string",
                        "dob": "2020-09-20-11-30-30",
                        "gender": "M",
                        "title": "Mr",
                        "address_line_1": "23, Okon street, Ikeja",
                        "address_line_2": "Ikeja",
                        "city": "lagos",
                        "state": "lagos",
                        "country": "NG"
                    }
                }
            }',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer nSf6jEmVa5YNnRKxi03D_24556c6166a648a09f1619629befe9f2',
                'Signature:' . $signature,
                'Content-Type: application/json'
            ),
            // CURLOPT_HTTPHEADER => array(
            //     'Authorization: Bearer '. env("ONE_PIPE_API_KEY"),
            //     'Signature:' . $signature,
            //     'Content-Type: application/json'
            // ),
        ));

        $response = curl_exec($curl);
        curl_close($curl);
        $result = json_decode($response);

        // if status successful store data on database
        if($result->status == "Successful"){

            $add_ref = new reference();
            $add_ref->request_ref = $request_ref;
            $add_ref->transaction_ref= $transaction_ref;
            $add_ref->customer_ref= $customer_ref;
            $add_ref->timestamps = false;
            $add_ref->save();

        }

        // return response in json
        return response()
            ->json(array('Response' => $result))
            ->header('Content-Type', 'application/json');
    }

    // get_balance
    public function get_balance(){

        // get balance Api
        // fetch data from database
        $ref = reference::orderBy('id', 'desc')->first();
        $request_ref = $ref->request_ref + 12532;
        $transaction_ref = $ref->transaction_ref + 12532;
        $customer_ref = $ref->customer_ref + 12532;

        echo  $request_ref;
        echo "<br>";
        echo $transaction_ref;
        echo "<br>";
        echo $customer_ref;

        // create signature
        $combine = $request_ref.";kLkIfuBgPLnKxn0P";
        echo $combine;
        $signature =  md5($combine);
        echo "<br>";

        echo $signature;

// Api call
        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.onepipe.io/v2/transact',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{
  "request_ref":'. $request_ref.',
  "request_type":"get_balance",
  "auth": {
    "type": "bvn",
    "secure": "R83dCymHAdz6WcD2dUPnAdZ6Vpp6Qyxv",
    "auth_provider": "Polaris",
    "route_mode": null
},
  "transaction": {
    "mock_mode": "inspect", 
    "transaction_ref":'. $transaction_ref.',
    "transaction_desc": "A random transaction", 
    "transaction_ref_parent": null, 
    "amount": 0,
    "customer":{
    	"customer_ref": "DemoApp_Customer007",
    	"firstname": "Uju",
        "surname": "Usmanu",
    	"email": "ujuusmanu@gmail.com",
    	"mobile_no": "234802343132"
    },
    "meta":{
    	"a_key":"a_meta_value_1",
    	"another_key":"a_meta_value_2"
    },
    "details": {
    	
    }
  }
}',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer nSf6jEmVa5YNnRKxi03D_24556c6166a648a09f1619629befe9f2',
                'Signature:' . $signature,
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);
        curl_close($curl);
        $result = json_decode($response);
echo "\n\r s2LsV7Ka2mi6SLbjuDIVmrxANCldBJFxAZ5Y0ckQnXs";
        // if status is successful store data in database
        if($result->status == "Successful"){

            $add_ref = new reference();
            $add_ref->request_ref = $request_ref;
            $add_ref->transaction_ref= $transaction_ref;
            $add_ref->customer_ref= $customer_ref;
            $add_ref->timestamps = false;
            $add_ref->save();

        }
        echo '{
            "request_ref":'. $request_ref.',
            "request_type":"get_balance",
            "auth": {
              "auth_provider": "Demoprovider",
              "route_mode": null
            },
            "transaction": {
              "mock_mode": "inspect", 
              "transaction_ref":'. $transaction_ref.',
              "transaction_desc": "A random transaction", 
              "transaction_ref_parent": null, 
              "amount": 0,
              "customer":{
                "customer_ref": "DemoApp_Customer007",
                "firstname": "Uju",
                  "surname": "Usmanu",
                "email": "ujuusmanu@gmail.com",
                "mobile_no": "234802343132"
              },
              "meta":{
                "a_key":"a_meta_value_1",
                "another_key":"a_meta_value_2"
              },
              "details": {
                
              }
            }
          }';

        // return json response
        return response()
            ->json(array('Response' => $result))
            ->header('Content-Type', 'application/json');
    }

    // bvn mid
    public function bvn_mid(){

        // BVN Mid Api
        // fetch data from database
        $ref = reference::orderBy('id', 'desc')->first();
        $request_ref = $ref->request_ref + 100;
        $transaction_ref = $ref->transaction_ref + 100;
        $customer_ref = $ref->customer_ref + 100;

        // create signature
        $combine = $request_ref.";kLkIfuBgPLnKxn0P";
        $signature =  md5($combine);


        // encrypt bvn code
        $encryption_key = "kLkIfuBgPLnKxn0P";
        $data = '132155526';
        $method = "des-ede3-cbc";
        $source = mb_convert_encoding($encryption_key, 'UTF-16LE', 'UTF-8');
        $encryption_key = md5($source, true);
        $encryption_key .= substr($encryption_key, 0, 16);
        $iv =  "\0\0\0\0\0\0\0\0";
        $encData = openssl_encrypt($data,$method, $encryption_key, $options=OPENSSL_RAW_DATA, $iv);
        $bvntext = base64_encode($encData);

        // Call Api
        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.onepipe.io/v2/transact',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{
  "request_ref":'. $request_ref.',
  "request_type":"lookup_bvn_mid",
  "auth": {
    "type": "bvn", 
    "secure": "'.$bvntext.'",
    "auth_provider": "Demoprovider",
    "route_mode": null
  },
  "transaction": {
    "mock_mode": "inspect", 
    "transaction_ref":'. $transaction_ref.',
    "transaction_desc": "A random transaction", 
    "transaction_ref_parent": null, 
    "amount": 0,
    "customer":{
    	"customer_ref": '. $customer_ref.',
    	"firstname": "Uju",
        "surname": "Usmanu",
    	"email": "ujuusmanu@gmail.com",
    	"mobile_no": "03115161895"
    },
    "meta":{
    	"a_key":"a_meta_value_1",
    	"b_key":"a_meta_value_2"
    },
    "details": {
    	
    }
  }
}',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer nSf6jEmVa5YNnRKxi03D_24556c6166a648a09f1619629befe9f2',
                'Signature:' . $signature,
                'Content-Type: application/json'
            ),
        ));



        $response = curl_exec($curl);
        curl_close($curl);
        $result = json_decode($response);

        // if status is success store in database
        if($result->status == "Successful"){
            $add_ref = new reference();
            $add_ref->request_ref = $request_ref;
            $add_ref->transaction_ref= $transaction_ref;
            $add_ref->customer_ref= $customer_ref;
            $add_ref->timestamps = false;
            $add_ref->save();

        }

        // return response in json
        return response()
            ->json(array('Response' => $result))
            ->header('Content-Type', 'application/json');
    }

}