<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;

class PushTokenController extends Controller
{
    public function reportToken(Request $request)
    {
        $request->validate([
            'fcm_token' => 'required|string',
            'sip_uri' => 'required|string',
        ]);

        $fcmToken = $request->input('fcm_token');
        $sipUri = $request->input('sip_uri');

        $response = Http::withHeaders([
            'Authorization' => 'Bearer ' . env('ACROBITS_API_KEY'),
        ])->post(env('ACROBITS_API_URL') . '/client/push_token_reporter', [
            'fcmToken' => $fcmToken,
            'sipUri' => $sipUri,
        ]);

        if ($response->successful()) {
            return response()->json(['message' => 'FCM token reported successfully']);
        } else {
            return response()->json(['error' => 'Failed to report FCM token'], $response->status());
        }
    }
}
