<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Cookie;
use Symfony\Component\HttpFoundation\Response;

class CustomerAuth
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next): Response
    {
        if ($request->hasCookie('c_auth_token') == false || $request->hasCookie('customer_info') ==false) {
            Cookie::queue(Cookie::forget('c_auth_token'));
            Cookie::queue(Cookie::forget('customer_info'));
            return redirect()->route('customer.login');
        }
        return $next($request);
    }
}
