<?php

namespace App\Imports;

use App\Models\Application;
use Illuminate\Support\Facades\Hash;
use Maatwebsite\Excel\Concerns\ToModel;
use Maatwebsite\Excel\Concerns\WithHeadingRow;
use Maatwebsite\Excel\Concerns\SkipsOnError;
use Maatwebsite\Excel\Concerns\Importable;
use Maatwebsite\Excel\Concerns\WithValidation;



class UsersImport implements ToModel, WithHeadingRow, WithValidation, SkipsOnError
{
    /**
    * @param array $row
    *
    * @return \Illuminate\Database\Eloquent\Model|null
    */

    public function onError(\Throwable $e)
    {
        return redirect('/')->with('error', 'Duplicate BVN Number');
    }

    public function rules(): array
    {
        return [
            'bvn' => [
                'required',
            ],
        ];
    }

    public function model(array $row)
    {
//        old excel upload
//        return new Application([
//                        'app_name'     => $row['applicant_name'],
//                        'app_bvn'     => $row['bvn'],
//                        'app_account_no'     => $row['account_number'],
//                        'app_bank_name'     => $row['bank_name'],
//                        'app_phone_no'     => $row['phone_number'],
//                        'app_email'     => $row['email_address'],
//                        'app_address'     => $row['address'],
//                        'app_state'     => $row['state_of_residence'],
//                        'app_zone'     => $row['geopolitical_zone'],
//                        'app_sponsor'     => $row['sponsor'],
//                        'app_trust_level'     => $row['trust_level'],
//                        'app_membership_level'     => $row['membership_level'],
//                        'app_sponsors_affilate'     => $row['sponsors_affiliate'],
//        ]);

        //    excel upload
        return new Application([
            'app_first_name'     => $row['firstname'],
            'app_surname'     => $row['surname'],
            'app_name'     => $row['username'],
            'app_bvn'     => $row['bvn'],
            'app_phone_no'     => $row['phone_no'],
            'app_email'     => $row['e_mail'],
            'app_address'     => $row['address'],
            'app_trust_level'     => $row['trust_level'],
            'app_membership_level'     => $row['membership'],

            'app_covid19_loan'     => $row['covid_19_loan'],
            'app_household_loan'     => $row['household_loan'],
            'app_theobarth_grant'     => $row['theobarth_grant'],
            'app_supreme_grant'     => $row['supreme_grant'],
            'app_liberation_grant'     => $row['liberation_grant'],
            'app_agsmeis_loan'     => $row['agsmeis_loan'],
        ]);
    }



}
